<?php
/**
 * @package Auctions Factory
 * @version 2.0.0
 * @copyright www.thefactory.ro
 * @license: commercial
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
@error_reporting(E_ALL & ~E_NOTICE);

require_once(JPATH_COMPONENT_SITE.'/bids.globals.php');
require_once( JPATH_COMPONENT_SITE.'/options.php');

require_once( JPATH_COMPONENT.DS.'controller.php' );
require_once(JPATH_COMPONENT_SITE.'/helpers/helper.php');

require_once(JPATH_COMPONENT_SITE.'/bids.functions.php');

require_once( JPATH_COMPONENT_ADMINISTRATOR.DS."admin.bids.html.php");
require_once (JPATH_COMPONENT_ADMINISTRATOR.DS."admin.bids.class.php");


if (file_exists(JPATH_COMPONENT_SITE.'/lang/'.bid_opt_language))
	require_once(JPATH_COMPONENT_SITE.'/lang/'.bid_opt_language);
else
	require_once(JPATH_COMPONENT_SITE.'/lang/default.php');

require_once(JPATH_COMPONENT.DS.'thefactory'.DS.'admin.application.php');
$T_app=&JTheFactoryApp::getInstance();

require_once (JPATH_COMPONENT_SITE.DS."bids.class.php");

	
$admintask = JRequest::getCmd('task',"dashbord");
$sub = JRequest::getCmd('sub',"");
if($sub)
	$admintask = $sub;

if ($T_app->checktask($admintask)) return ; 


$controller = new JBidsAdminController();
if(in_array($admintask,$controller->_methods)){
	$controller->execute( $admintask );
	$controller->redirect();
	return;
}


$doc=&JFactory::getDocument();
$doc->addStyleSheet(JURI::base().'components/com_bids/assets/css/com_bids.css');

switch ($task) {
	// ====================== AUCTION EVENTS =========================================
	case 'viewmessages':
		viewMessages($id); //
		break;
	case 'purgeauctions':
	    purgeAuctions();
	    break;
	case 'dopurgeauctions':
	    dopurgeAuctions();
	    break;

	// ================================ REPORTED THINGS ===================================
	case 'reported_offers':
	reportedOffers(); //
	break;
	case 'write_admin_message':
	writeAdminMessage(); //
	break;
	case 'send_message_auction':
	sendAuctionMessage(); //
	break;
	case 'change_reported_status':
	changeReportStatus();//
	break;

	// ============================= STATISTICS ========================================
	case'statistics':
	Statistics();
	break;
	case'bid_stats':
	bidstats();
	break;
	//=========================== INSTALL MENU ===========================================

	case'installOpt':
		installOpt();
		FactoryLayer::redirect($returnurl,bid_succes);
	break;
	case'installCB':
		installCB();
		FactoryLayer::redirect($returnurl,bid_succes);
	break;

	//=========================== IMPORT, BACKUP and RESTORE ===========================================
	case 'exportToXls':
    	exportToXls();   //
	break;
	case 'showadmimportform':
		showadmimportform();
	break;
	case 'importcsv':
		importadmfromcsv();
	break;
	case 'backup':
		createbackupzip();
	break;
	case 'showrestoreform':
		showrestoreform();
	break;
	case 'restorebackup':
		restorebackup();
	break;
	
	case 'paymentmanager':
	    showPaymentManager();
	break;
	case 'settingsmanager':
	    showSettingsManager();
	break;
	case 'auctionmanager':
	    showAuctionsManager();
	break;
	
}


function viewMessages($id){
	$database = & JFactory::getDBO();
    
	$popup=JRequest::getInt('popup',0);
	if (!$id){
		echo bid_does_not_exist;
		return;
	}


	$auction=new JAuctions($database);
	if(!$auction->load($id)){
		echo bid_does_not_exist;
		return;
	}

	$query = "select a.id,a.id_offer,a.userid1,a.userid2,a.message,a.modified,u1.username as username1,u2.username as username2
			from #__bid_messages a left join #__users u1 on a.userid1=u1.id
    	 	left join #__users u2 on a.userid2=u2.id
    	 	where a.id_offer={$id}
	";
	$database->setQuery($query);
	$Messages = $database->loadObjectList();


	if ($popup) ob_clean();


	HTML_admin_auctions::viewMessages($auction,$Messages);

	if ($popup) exit;
}

function reportedOffers(){
	global $Itemid;
	$app	= JFactory::getApplication();
	$database = & JFactory::getDBO();
	 

	$limit 		=JRequest::getInt('limit',  $app->getCfg('list_limit'));
	$limitstart = JRequest::getInt('limitstart', 0 ) ;

	$filter_solveid 	= JRequest::getInt('filter_solveid', 0 );

	$reported = "";
	$id_reported = "";
	$tabel_reported = "";
	$from = "";
	$and = "";
	$modified = "";

	$where=" where 1=1 ";
	switch ($filter_solveid){
		case "0":
		break;
		default:
		case "1":
		$where.=" and solved=0 ";
		break;
		case "2":
		$where.=" and solved=0 and processing=1";
		break;
	}


	$query = "select count(*) from #__bid_report_auctions $where";
	$database->setQuery( $query );
	$total = $database->loadResult();

	$pageNav = FactoryLayer::initPagination($total,$limitstart, $limit);

	$query = "select a.*,b.title,u.username from #__bid_report_auctions a
                left join #__bid_auctions b on a.id_offer=b.id
                left join #__users u on a.userid=u.id
                $where
        order by a.id desc
	";

	$database->setQuery($query,$pageNav->limitstart,$pageNav->limit);
	$rows = $database->loadObjectList();
	$solveid[] = JHTML::_('select.option', '0', bid_all);
	$solveid[] = JHTML::_('select.option', '1', bid_unsolved);
	$solveid[] = JHTML::_('select.option', '2', bid_in_progress);
	$lists['solveid'] = JHTML::_('select.genericlist', $solveid, 'filter_solveid', 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', $filter_solveid );

	HTML_admin_auctions::listReports($rows,$pageNav,$lists,$from);
}

function sendAuctionMessage(){
	global $mainframe;
	$database = & JFactory::getDBO();
	$my = & JFactory::getUser();
	
	$id_auction=JRequest::getInt('id_auction',0);
	$message=JRequest::getVar('message','');

	if (!$message){
		echo bid_err_message_empty;
		return;
	}

	$auction=new JAuctions($database);
	if (!$auction->load($id_auction)) return;

	$auction->newmessages =1;
	$auction->store();
	$auction->sendNewMessage($id_auction,$id_msg,$message);

	//echo $database->getQuery();

	$owner_user=new JTableUser($database);
	$owner_user->load($auction->userid);

	$auction->SendMails(array($owner_user),'bid_admin_message');

	FactoryLayer::redirect('index.php?option=com_bids&task=editoffer&id='.$id_auction,bid_alt_message_sent);

}

function writeAdminMessage(){
	$database = & JFactory::getDBO();

	$id_auction=JRequest::getInt('id_auction',0);
	$id_reported = JRequest::getInt('id_reported',0);

	if ($id_auction){
		$obj=new JAuctions($database);
		if (!$obj->load($id_auction)) return;

	}elseif($id_reported){


		$obj=new JAuctions($database);


		if (!$obj->load($id_reported)) return;

	}else{

		return;
	}

	$usr=JTable::getInstance("user");
	$usr->load($obj->userid);
	$obj->username=$usr->username;

	//sa se vada doar reporturile nerezolvate. alea rezolvate le vad separat daca e. sa pot sa aleg ca la published ->rezolvate/nerezolvate
	HTML_admin_auctions::writeAuctionMessage($obj);
}

function changeReportStatus() {
	$cid = JRequest::getVar("cid",array());
	$database = & JFactory::getDBO();

	if (count( $cid ) < 1) {
		echo "<script> alert('".bid_err_no_selected."'); window.history.go(-1);</script>\n";
		exit;
	}

	$status=JRequest::getWord('status','');

	switch ($status){
		default:
		case "solved":
			$set=" solved=1, processing=0 ";
			break;
		case "unsolved":
			$set=" solved=0 ";
			break;
		case "processing":
			$set=" solved=0, processing=1 ";
			break;
		case "unprocessing":
			$set=" processing=0 ";
			break;
	}

	$cids = implode( ',', $cid );

	$query = "UPDATE #__bid_report_auctions"
	. "\n SET $set "
	. "\n WHERE id IN ( $cids )"
	;
	$database->setQuery( $query );
	if (!$database->query()) {
		echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	if (count( $cid ) == 1) {
		$row = new JAuctions($database );
		$row->checkin( $cid[0] );
	}

	Factorylayer::redirect( 'index.php?option=com_bids&task=reported_offers',bid_status_changed );
}

//=========================== STATISTICS ===========================================


function Statistics(){
	$database = & JFactory::getDBO();
	
	$app	= JFactory::getApplication();

	$limit 		=JRequest::getInt('limit',  $app->getCfg('list_limit'));
	$limitstart = JRequest::getInt('limitstart', 0 ) ;

	$query = "SELECT COUNT(*)"
	. "\n FROM #__users a where a.usertype!='Super Administrator' and a.usertype!='Administrator'";
	$database->setQuery( $query );
	$total = $database->loadResult();

	$pageNav = FactoryLayer::initPagination($total,$limitstart, $limit);

	$query = "select d.*
			 from #__users d
			 where d.usertype!='Super Administrator' and d.usertype!='Administrator' and d.block!=1
			 ";
	$database->setQuery($query,$pageNav->limitstart,$pageNav->limit);
	$userlist=$database->loadObjectList();

	$query="select count(distinct userid) from #__bid_auctions";
	$database->setQuery($query);
	$nr_a_users = $database->loadResult();

	$query="select count(*) from #__users";
	$database->setQuery($query);
	$nr_r_users = $database->loadResult();


	$query="select count(*) from #__bid_auctions where close_offer !=1 and close_by_admin !=1 and published !=0";
	$database->setQuery($query);
	$nr_a_auctions = $database->loadResult();

	$query="select count(*) from #__bid_auctions where close_offer =1 or close_by_admin =1";
	$database->setQuery($query);
	$nr_c_auctions = $database->loadResult();

	$query="select count(*) from #__bids b
	               left join #__bid_auctions a on b.id_offer=a.id
	       where a.close_offer <>1 and a.close_by_admin <>1";
	$database->setQuery($query);
	$nr_a_bids = $database->loadResult();

	$query="select count(*) from #__bids where accept=1";
	$database->setQuery($query);
	$nr_acc_bids = $database->loadResult();

	$totals = array();
	$totals['r_users'] = $nr_r_users;
	$totals['a_users'] = $nr_a_users;
	$totals['a_auctions'] = $nr_a_auctions;
	$totals['c_auctions'] = $nr_c_auctions;
	$totals['a_bids'] = $nr_a_bids;
	$totals['ac_bids'] = $nr_acc_bids;

	HTML_admin_auctions::Statistics($lists,$users,$userlist,$pageNav,$totals);

}

function bidstats(){
	$app	= JFactory::getApplication();
	$database = & JFactory::getDBO();
	
	$filter_user 	 = JRequest::getInt('filter_user',null);
	$filter_orderid  = JRequest::getString('filter_orderid',"b.modified");
	$filter_orderdir = JRequest::getWord('filter_orderdir',"DESC");

	$whereA[] = "1=1";
	$limit 		=JRequest::getInt('limit',  $app->getCfg('list_limit'));
	$limitstart = JRequest::getInt('limitstart', 0 ) ;

	if($filter_user){
		$whereA[] = " b.userid = $filter_user ";
	}
	if($filter_orderid){
		$orderA[] = " $filter_orderid $filter_orderdir ";
	}
	$where = implode(' AND ', $whereA);
	$order = implode(' , ', $orderA);

	$q = "SELECT count(*) FROM #__bid_log AS b WHERE {$where} ";
	$database->setQuery($q);
	$total = $database->loadResult();

	$pageNav = FactoryLayer::initPagination($total,$limitstart, $limit);

	$q = "SELECT b.*,a.title as offer,u.username FROM #__bid_log AS b LEFT JOIN #__users as u ON b.userid = u.id LEFT JOIN #__bid_auctions AS a ON b.id_offer = a.id WHERE {$where} ORDER BY $order ";
	$database->setQuery($q);
	
	$rows = $database->loadObjectList();

	HTML_admin_auctions::BidStats($rows,$lists,$pageNav);
}

function installOpt(){
	
   require_once(JPATH_ROOT."/administrator/components/com_bids/install.bids.php");
	$db = & JFactory::getDBO();

	$db->setQuery("SELECT id FROM #__components where link like '%option=com_bids%'");
	$component_id = $db->LoadResult();
	
	$MenuInstaller = new TheFactoryMenuHelper();
	$MenuInstaller->title = "Auctions Menu";
	$MenuInstaller->componentid = $component_id;
	$MenuInstaller->AddMenuItem("Categories","categories","index.php?option=com_bids&view=category", 0,0 );
	$MenuInstaller->AddMenuItem("Tree Categories","tree-categories","index.php?option=com_bids&view=category&layout=tree", 1,0 );
	$MenuInstaller->AddMenuItem("Show Auctions","show-auctions","index.php?option=com_bids&view=auctions", 2 ,0 );
	$MenuInstaller->AddMenuItem("Search Auctions","search-auctions","index.php?option=com_bids&view=bids&layout=search", 2 ,0 );
	$MenuInstaller->AddMenuItem("Search Auctioneers","search-auctioneers","index.php?option=com_bids&view=user&layout=searchusers", 2 ,0 ,"usertype=2");
	$MenuInstaller->storeMenu();
	
	
	$MenuInstaller2 = new TheFactoryMenuHelper();
	$MenuInstaller2->title = "Auctions User Menu";
	$MenuInstaller2->componentid = $component_id;
	$MenuInstaller2->AddMenuItem("My Profile","auctioneer-profile","index.php?option=com_bids&view=user", 0 , 1 );
	$MenuInstaller2->AddMenuItem("Post Offer","post-offer","index.php?option=com_bids&view=auction&layout=form", 1, 1 );
	$MenuInstaller2->AddMenuItem("My Auctions","my-auctions","index.php?option=com_bids&view=auctions&layout=myauctions", 2, 1 );
	
	$MenuInstaller2->storeMenu();
	
}

function installCB(){
   require_once(JPATH_ROOT."/administrator/components/com_bids/install.bids.php");
	install_cbplugin("com_bids");
}

function showadmimportform(){
 	HTML_admin_auctions::bulkadmimport("com_bids",null);
}

function importadmfromcsv(){
    $err=ImportFromCSV("com_bids",1);
    if (count($err)<=0)
    	FactoryLayer::redirect('index.php?option=com_bids',bid_succes);
    else{
	 	HTML_admin_auctions::bulkadmimport($err);
    }
}

function exportToXls(){
	$database = & JFactory::getDBO();
	
	$sqlQ = "
	SELECT
		*, b.name as currency_name, c.name as payment_name, d.catname, e.name as username,
		max(bbids.bid_price+0) as highest_bid  
		
	FROM #__bid_auctions a
	LEFT JOIN #__bids as bbids ON bbids.id_offer=a.id 
	LEFT JOIN #__bid_currency b ON a.currency = b.id
	LEFT JOIN #__bid_payment c ON a.payment = c.id
	LEFT JOIN #__bid_categories d ON a.cat = d.id
	LEFT JOIN #__bid_users e ON a.userid = e.userid
	GROUP BY a.id
	";
	$database->setQuery($sqlQ);
	$result = $database->loadObjectList();

	$filename = "ExportXLS";
	header("Content-type: application/vnd.ms-excel");
    header("Content-Disposition: attachment; filename=\"".$filename.".xls\"");
    header("Expires: 0");
    header("Cache-Control: must-revalidate, post-check=0,pre-check=0");
	header("Pragma: public");
	ob_clean();

	echo createXLS( $result );
	ob_end_flush();
	exit;
}

function createbackupzip(){
		$database = & JFactory::getDBO();
 		require_once( JPATH_ROOT. '/administrator/includes/pcl/pclzip.lib.php' );
		require_once( JPATH_ROOT . '/administrator/includes/pcl/pclerror.lib.php' );

		@set_time_limit(0);
	    @error_reporting(0);

	    $array_backup_table=array(
	       '#__bid_fields',
	       '#__bid_fields_positions',
	       '#__bid_fields_categories',
	       '#__bid_fields_options',
	       '#__bid_auctions',
	       '#__bid_categories',
	       '#__bid_cbfields',
	       '#__bid_comissions',
	       '#__bid_country',
	       '#__bid_credits',
	       '#__bid_currency',
	       '#__bid_mails',
	       '#__bid_messages',
	       '#__bid_paylog',
	       '#__bid_payment',
	       '#__bid_paysystems',
	       '#__bid_pictures',
	       '#__bid_pricing',
	       '#__bid_proxy',
	       '#__bid_rate',
	       '#__bid_report_auctions',
	       '#__bid_tags',
	       '#__bid_users',
	       '#__bid_watchlist',
	       '#__bid_log',
	       '#__bids'
	    );

		$back_dir = JPATH_ROOT."/administrator/backups/";
		$back_zip_name = "auctions_backup".date("Ymd")."_".date("His").".zip";
		$archive = JPATH_ROOT."/media/".$back_zip_name;
 		$backupsql = JPATH_ROOT."/media/auction_dump.sql";

	    if($handle = fopen($backupsql,'w')){
	        foreach ($array_backup_table as $bakup_table)
	        {
	            $s=createBackupString($bakup_table);
	            if ($s)
        	    	if(fwrite($handle, $s)==null){
        	    		echo "<script>alert('".bid_err_file_write_failed." ".$bakup_table."');</script>";
            			echo "<script>history.go(-1);</script>";
        				exit;
        	    	}
	        }
	    }else{
    		echo "<script>alert('".bid_err_file_not_opened."');</script>";
			echo "<script>history.go(-1);</script>";
			exit;
	    }
	    fclose($handle);

		jimport('joomla.filesystem.path');
		$archivename 	= JPath::clean( $archive );
		$zipfile = new PclZip( $archivename );
		$arr_arch = array("$backupsql");
		$zipfile->create($arr_arch,$p_add_dir="", $p_remove_dir=JPATH_ROOT."/media/");
		$arr_add = array(AUCTION_PICTURES_PATH);
		$zipfile->add($arr_add,$p_add_dir,$p_remove_dir=JPATH_ROOT."/images/");

		if(file_exists($archive)) {
			if(!rename($archive,$back_dir.$back_zip_name)){
				echo "<script>alert('".bid_err_back_zip_move_failed."');</script>";
				echo "<script>history.go(-1);</script>";
				exit;
			}
		}
		if(file_exists($archive)){ unlink($archive);}
		if(file_exists($backupsql)){ unlink($backupsql);}
		download($back_dir.$back_zip_name);
}

function download($file) {
 	$database = &JFactory::getDBO();
 	$my = & JFactory::getUser();
	$arr = explode(JPATH_ROOT."/administrator/backups/",$file);
	$name = $arr[1];
	$filepath = $file;
    if (!file_exists($filepath)){
        echo bid_err_file_not;
        return;
    }
	ob_clean();
	header("Pragma: public");
	header("Expires: 0"); // set expiration time
	header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
	header("Content-Type: application/force-download");
	header("Content-Type: application/octet-stream");
	header("Content-Type: application/download");
	header("Content-Disposition: attachment; filename=\"".$name."\"");
	header("Content-Transfer-Encoding: binary");
	header("Content-size: ".filesize($filepath));
	header("Content-Length: ".filesize($file));
	if ($stream = fopen($filepath, 'rb')){
		while(!feof($stream) && connection_status() == 0){
			print(fread($stream,1024*4));
		}
		fclose($stream);
	}
    exit;
 }

function restorebackup() 
{
	$database = & JFactory::getDBO();
	jimport('joomla.filesystem.path');
	
	require_once( JPATH_ROOT . '/administrator/includes/pcl/pclzip.lib.php' );
	require_once( JPATH_ROOT . '/administrator/includes/pcl/pclerror.lib.php' );
	@set_time_limit(0);
	error_reporting(E_ALL);
	define('_TMP_DIR',JPATH_ROOT."/media/");
	$tmpdir 		= uniqid( 'backup_' );
	$base_Dir 		= JPath::clean( JPATH_ROOT.'/media' ).DS;
	$extractdir 	= JPath::clean( $base_Dir . $tmpdir ).DS;
	$sql_file = $extractdir."auction_dump.sql";
	$img_dir = JPath::clean($extractdir."auctions").DS;

	$overwrite_imgs=JRequest::getInt('overwrite_imgs',0);
	$local_file=JRequest::getVar('local_file','');
	$msg='';
	if($_FILES['backup']['tmp_name']) {
		$upload_arch = $base_Dir.$_FILES['backup']['name'];
		if(!move_uploaded_file($_FILES['backup']['tmp_name'],$upload_arch)){
			$msg .= bid_err_bkp_import_error;
		}
	}elseif(file_exists($local_file)){
		$upload_arch = $local_file;
	}else{
		$msg .= bid_err_bkp_import_error;
	}
	if ($msg){
		FactoryLayer::redirect( "index.php?option=com_bids",$msg );
		exit;
	}
	@chmod($upload_arch,0777);
	$archivename 	= $upload_arch;
	@mkdir($extractdir);
	$archivename 	= JPath::clean( $archivename );
	$zipfile = new PclZip( $archivename );
	if(substr(PHP_OS, 0, 3) == 'WIN') {
		define('OS_WINDOWS',1);
	} else {
		define('OS_WINDOWS',0);
	}
	$ret = $zipfile->extract( PCLZIP_OPT_PATH, $extractdir );
	if($ret == 0) {die( 'Unrecoverable error '.$zipfile->errorName(true).'"' );}
	if(!file_exists($sql_file)) {
		echo "<script>alert('".bid_err_back_sql_no_file."');</script>";
		echo "<script>history.go(-1);</script>";
	}else {
		//delete auctions bids and images
		$database->setQuery("truncate table #__bids");$database->query();
		$database->setQuery("truncate table #__bid_auctions");$database->query();
		$database->setQuery("truncate table #__bid_pictures");$database->query();

		//restore info
		$handle = fopen($sql_file, "r");
	    $count=0;
	    if ($handle) {while (!feof($handle)){$buffer = fgets($handle, 100000);$database->setQuery($buffer);$database->query();}fclose($handle);}
	    if(file_exists($img_dir)) {
	    	if($overwrite_imgs){
	    		if ($handle = opendir($img_dir)) {
				    while (false !== ($file = readdir($handle))) {
				    	if($file!='.' && $file!='..') {
				    		if(file_exists(AUCTION_PICTURES_PATH.$file)) {
				    			unlink(AUCTION_PICTURES_PATH.$file);rename($img_dir.$file,AUCTION_PICTURES_PATH.$file);
				    		}else { rename($img_dir.$file,AUCTION_PICTURES_PATH.$file);}
				    	}
				    }
					closedir($handle);
				}
	    	}else {
	    		JFolder::delete(AUCTION_PICTURES_PATH);
	    		JFolder::copy($img_dir,AUCTION_PICTURES_PATH);
	    	}
	    }
	}
	if(file_exists($extractdir)) {
		JFolder::delete($extractdir);
		if(file_exists($sql_file))
			unlink($sql_file);
		if(file_exists($extractdir))
			rmdir($extractdir);
	}
	if(file_exists($base_Dir.$_FILES['bkp']['name']))
	unlink($base_Dir.$_FILES['backup']['name']);
	$msg = bid_bkp_success;
	
	$redirect_link = "index.php?option=com_bids";
	FactoryLayer::redirect( $redirect_link,$msg );
}

function showrestoreform() {	global $Itemid;	HTML_admin_auctions::restoreform($Itemid);}

function dopurgeAuctions(){
    $database = & JFactory::getDBO();
    @set_time_limit(0);
	$query = "SELECT id FROM #__bid_auctions
				WHERE close_offer =1 or close_by_admin =1 ";
    $database->setQuery($query);
	$idx = $database->loadObjectList();
	$auction=new JAuctions($database);

	for ($i=0;$i<count($idx);$i++){
	   $auction->delete($idx[$i]->id);
	}

	//Close all auctions without a parent user (deleted users?)
	$query = "update #__bid_auctions a left join #__users b on a.userid=b.id set close_by_admin = 1 where b.id is null";
	$database->setQuery($query); $database->query();

   FactoryLayer::redirect('index.php?option=com_bids&task=offers',bid_succes);
}

function purgeAuctions(){
	$database = & JFactory::getDBO();
	@set_time_limit(0);
	$query = "SELECT count(id) as nr FROM #__bid_auctions
				WHERE close_offer =1 or close_by_admin =1 ";
   $database->setQuery($query);
	$idx = $database->loadObject();
	
	if($idx->nr==0){
		echo "<strong>No expired auctions to purge!</strong>";
		echo "<br />";
		echo "<a href='index.php?option=com_bids&task=auctionmanager'>Return</a>";
	}else{
		echo "<strong>Are you sure you want to purge {$idx->nr} auctions?</strong>";
		echo "<br />";
		echo "<br />";
		echo "<table width='300'><tr><td align='center'>";
		echo "<input type='button' onclick='document.location=\"index.php?option=com_bids&task=auctionmanager\"' value='No'>";
		echo "&nbsp;&nbsp;";
		echo "<input type='button' onclick='document.location=\"index.php?option=com_bids&task=dopurgeauctions\"' value='Yes'>";
		echo "</td></tr></table>";
	}
	
}

function showAuctionsManager(){ HTML_admin_auctions::showAuctionsManager();}
function showSettingsManager(){ HTML_admin_auctions::showSettingsManager();}
function showPaymentManager(){ HTML_admin_auctions::showPaymentManager();}

?>
