DROP TABLE IF EXISTS `#__bids`;
CREATE TABLE `#__bids` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_offer` int(11) NOT NULL DEFAULT '0',
  `userid` int(11) NOT NULL DEFAULT '0',
  `id_proxy` int(11) NOT NULL DEFAULT '0',
  `initial_bid` varchar(200) DEFAULT NULL,
  `bid_price` varchar(200) NOT NULL DEFAULT '0',
  `payment` int(11) NOT NULL DEFAULT '0',
  `cancel` int(11) DEFAULT NULL,
  `accept` tinyint(4) NOT NULL DEFAULT '0',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `quantity` int(11) DEFAULT 1,
  PRIMARY KEY (`id`),
  KEY `id_offer` (`id_offer`),
  KEY `userid` (`userid`),
  KEY `ixbid_price` (`bid_price`)
);
DROP TABLE IF EXISTS `#__bid_auctions`;
CREATE TABLE `#__bid_auctions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(200) NOT NULL DEFAULT '',
  `shortdescription` text,
  `description` text NOT NULL,
  `picture` varchar(50) NOT NULL DEFAULT '',
  `link_extern` text NOT NULL,
  `initial_price` varchar(200) NOT NULL DEFAULT '0',
  `currency` int(1) NOT NULL DEFAULT '0',
  `BIN_price` varchar(200) NOT NULL DEFAULT '0',
  `auction_type` int(11) NOT NULL DEFAULT '0',
  `automatic` int(1) DEFAULT '1',
  `payment` int(11) NOT NULL DEFAULT '0',
  `shipment_info` text,
  `shipment_price` varchar(100) DEFAULT '0',
  `start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `closed_date` date NOT NULL DEFAULT '0000-00-00',
  `params` text NOT NULL,
  `published` tinyint(4) NOT NULL DEFAULT '0',
  `close_offer` int(11) NOT NULL DEFAULT '0',
  `close_by_admin` int(11) NOT NULL DEFAULT '0',
  `hits` int(11) NOT NULL DEFAULT '0',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `newmessages` int(1) DEFAULT '1',
  `winner_id` int(11) NOT NULL DEFAULT '0',
  `cat` int(11) NOT NULL DEFAULT '0',
  `auction_nr` varchar(12) DEFAULT NULL,
  `nr_items` int(11) DEFAULT NULL,
  `nr_items_left` int(11) DEFAULT NULL,
  `featured` enum('gold','silver','bronze','none') DEFAULT 'none',
  `reserve_price` varchar(200) DEFAULT NULL,
  `min_increase` VARCHAR(100) DEFAULT '0',
  `extended_counter` int(11) NOT NULL default '0',
  `payment_info` text NOT NULL,
  `quantity` int(11) DEFAULT 1,
  PRIMARY KEY (`id`),
  KEY `userid` (`userid`),
  KEY `iAuctionNr` (`auction_nr`),
  KEY `ititle` (`title`),
  KEY `ifeatured` (`featured`)
);
DROP TABLE IF EXISTS `#__bid_country`;
CREATE TABLE `#__bid_country` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(150) NOT NULL DEFAULT '',
  `simbol` char(3) NOT NULL DEFAULT '',
  `active` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
);
INSERT INTO `#__bid_country` VALUES (4,'AFGHANISTAN','AF',1);
INSERT INTO `#__bid_country` VALUES (5,'ALAND ISLANDS','AX',0);
INSERT INTO `#__bid_country` VALUES (6,'ALBANIA','AL',1);
INSERT INTO `#__bid_country` VALUES (7,'ALGERIA','DZ',0);
INSERT INTO `#__bid_country` VALUES (8,'AMERICAN SAMOA','AS',0);
INSERT INTO `#__bid_country` VALUES (9,'ANDORRA','AD',0);
INSERT INTO `#__bid_country` VALUES (10,'ANGOLA','AO',0);
INSERT INTO `#__bid_country` VALUES (11,'ANGUILLA','AI',0);
INSERT INTO `#__bid_country` VALUES (12,'ANTARCTICA','AQ',0);
INSERT INTO `#__bid_country` VALUES (13,'ANTIGUA AND BARBUDA','AG',0);
INSERT INTO `#__bid_country` VALUES (14,'ARGENTINA','AR',0);
INSERT INTO `#__bid_country` VALUES (15,'ARMENIA','AM',0);
INSERT INTO `#__bid_country` VALUES (16,'ARUBA','AW',0);
INSERT INTO `#__bid_country` VALUES (17,'AUSTRALIA','AU',1);
INSERT INTO `#__bid_country` VALUES (18,'AUSTRIA','AT',1);
INSERT INTO `#__bid_country` VALUES (19,'AZERBAIJAN','AZ',0);
INSERT INTO `#__bid_country` VALUES (20,'BAHAMAS','BS',0);
INSERT INTO `#__bid_country` VALUES (21,'BAHRAIN','BH',0);
INSERT INTO `#__bid_country` VALUES (22,'BANGLADESH','BD',0);
INSERT INTO `#__bid_country` VALUES (23,'BARBADOS','BB',0);
INSERT INTO `#__bid_country` VALUES (24,'BELARUS','BY',0);
INSERT INTO `#__bid_country` VALUES (25,'BELGIUM','BE',0);
INSERT INTO `#__bid_country` VALUES (26,'BELIZE','BZ',0);
INSERT INTO `#__bid_country` VALUES (27,'BENIN','BJ',0);
INSERT INTO `#__bid_country` VALUES (28,'BERMUDA','BM',0);
INSERT INTO `#__bid_country` VALUES (29,'BHUTAN','BT',0);
INSERT INTO `#__bid_country` VALUES (30,'BOLIVIA','BO',0);
INSERT INTO `#__bid_country` VALUES (31,'BOSNIA AND HERZEGOVINA','BA',0);
INSERT INTO `#__bid_country` VALUES (32,'BOTSWANA','BW',0);
INSERT INTO `#__bid_country` VALUES (33,'BOUVET ISLAND','BV',0);
INSERT INTO `#__bid_country` VALUES (34,'BRAZIL','BR',0);
INSERT INTO `#__bid_country` VALUES (35,'BRITISH INDIAN OCEAN TERRITORY','IO',0);
INSERT INTO `#__bid_country` VALUES (36,'BRUNEI DARUSSALAM','BN',0);
INSERT INTO `#__bid_country` VALUES (37,'BULGARIA','BG',0);
INSERT INTO `#__bid_country` VALUES (38,'BURKINA FASO','BF',0);
INSERT INTO `#__bid_country` VALUES (39,'BURUNDI','BI',0);
INSERT INTO `#__bid_country` VALUES (40,'CAMBODIA','KH',0);
INSERT INTO `#__bid_country` VALUES (41,'CAMEROON','CM',0);
INSERT INTO `#__bid_country` VALUES (42,'CANADA','CA',0);
INSERT INTO `#__bid_country` VALUES (43,'CAPE VERDE','CV',0);
INSERT INTO `#__bid_country` VALUES (44,'CAYMAN ISLANDS','KY',0);
INSERT INTO `#__bid_country` VALUES (45,'CENTRAL AFRICAN REPUBLIC','CF',0);
INSERT INTO `#__bid_country` VALUES (46,'CHAD','TD',0);
INSERT INTO `#__bid_country` VALUES (47,'CHILE','CL',0);
INSERT INTO `#__bid_country` VALUES (48,'CHINA','CN',0);
INSERT INTO `#__bid_country` VALUES (49,'CHRISTMAS ISLAND','CX',0);
INSERT INTO `#__bid_country` VALUES (50,'COCOS (KEELING) ISLANDS','CC',0);
INSERT INTO `#__bid_country` VALUES (51,'COLOMBIA','CO',0);
INSERT INTO `#__bid_country` VALUES (52,'COMOROS','KM',0);
INSERT INTO `#__bid_country` VALUES (53,'CONGO','CG',0);
INSERT INTO `#__bid_country` VALUES (54,'CONGO,THE DEMOCRATIC REPUBLIC OF THE','CD',0);
INSERT INTO `#__bid_country` VALUES (55,'COOK ISLANDS','CK',0);
INSERT INTO `#__bid_country` VALUES (56,'COSTA RICA','CR',0);
INSERT INTO `#__bid_country` VALUES (57,'CROATIA','HR',0);
INSERT INTO `#__bid_country` VALUES (58,'CUBA','CU',0);
INSERT INTO `#__bid_country` VALUES (59,'CYPRUS','CY',0);
INSERT INTO `#__bid_country` VALUES (60,'CZECH REPUBLIC','CZ',0);
INSERT INTO `#__bid_country` VALUES (61,'DENMARK','DK',0);
INSERT INTO `#__bid_country` VALUES (62,'DJIBOUTI','DJ',0);
INSERT INTO `#__bid_country` VALUES (63,'DOMINICA','DM',0);
INSERT INTO `#__bid_country` VALUES (64,'DOMINICAN REPUBLIC','DO',0);
INSERT INTO `#__bid_country` VALUES (65,'ECUADOR','EC',0);
INSERT INTO `#__bid_country` VALUES (66,'EGYPT','EG',0);
INSERT INTO `#__bid_country` VALUES (67,'EL SALVADOR','SV',0);
INSERT INTO `#__bid_country` VALUES (68,'EQUATORIAL GUINEA','GQ',0);
INSERT INTO `#__bid_country` VALUES (69,'ERITREA','ER',0);
INSERT INTO `#__bid_country` VALUES (70,'ESTONIA','EE',0);
INSERT INTO `#__bid_country` VALUES (71,'ETHIOPIA','ET',0);
INSERT INTO `#__bid_country` VALUES (72,'FALKLAND ISLANDS (MALVINAS)','FK',0);
INSERT INTO `#__bid_country` VALUES (73,'FAROE ISLANDS','FO',0);
INSERT INTO `#__bid_country` VALUES (74,'FIJI','FJ',0);
INSERT INTO `#__bid_country` VALUES (75,'FINLAND','FI',0);
INSERT INTO `#__bid_country` VALUES (76,'FRANCE','FR',1);
INSERT INTO `#__bid_country` VALUES (77,'FRENCH GUIANA','GF',1);
INSERT INTO `#__bid_country` VALUES (78,'FRENCH POLYNESIA','PF',0);
INSERT INTO `#__bid_country` VALUES (79,'FRENCH SOUTHERN TERRITORIES','TF',0);
INSERT INTO `#__bid_country` VALUES (80,'GABON','GA',0);
INSERT INTO `#__bid_country` VALUES (81,'GAMBIA','GM',0);
INSERT INTO `#__bid_country` VALUES (82,'GEORGIA','GE',0);
INSERT INTO `#__bid_country` VALUES (83,'GERMANY','DE',1);
INSERT INTO `#__bid_country` VALUES (84,'GHANA','GH',0);
INSERT INTO `#__bid_country` VALUES (85,'GIBRALTAR','GI',0);
INSERT INTO `#__bid_country` VALUES (86,'GREECE','GR',0);
INSERT INTO `#__bid_country` VALUES (87,'GREENLAND','GL',0);
INSERT INTO `#__bid_country` VALUES (88,'GRENADA','GD',0);
INSERT INTO `#__bid_country` VALUES (89,'GUADELOUPE','GP',0);
INSERT INTO `#__bid_country` VALUES (90,'GUAM','GU',0);
INSERT INTO `#__bid_country` VALUES (91,'GUATEMALA','GT',0);
INSERT INTO `#__bid_country` VALUES (92,'GUERNSEY','GG',0);
INSERT INTO `#__bid_country` VALUES (93,'GUINEA','GN',0);
INSERT INTO `#__bid_country` VALUES (94,'GUINEA-BISSAU','GW',0);
INSERT INTO `#__bid_country` VALUES (95,'GUYANA','GY',0);
INSERT INTO `#__bid_country` VALUES (96,'HAITI','HT',0);
INSERT INTO `#__bid_country` VALUES (97,'HEARD ISLAND AND MCDONALD ISLANDS','HM',0);
INSERT INTO `#__bid_country` VALUES (98,'HONDURAS','HN',0);
INSERT INTO `#__bid_country` VALUES (99,'HONG KONG','HK',0);
INSERT INTO `#__bid_country` VALUES (100,'HUNGARY','HU',0);
INSERT INTO `#__bid_country` VALUES (101,'ICELAND','IS',0);
INSERT INTO `#__bid_country` VALUES (102,'INDIA','IN',0);
INSERT INTO `#__bid_country` VALUES (103,'INDONESIA','ID',0);
INSERT INTO `#__bid_country` VALUES (104,'IRAN, ISLAMIC REPUBLIC OF','IR',0);
INSERT INTO `#__bid_country` VALUES (105,'IRAQ','IQ',0);
INSERT INTO `#__bid_country` VALUES (106,'IRELAND','IE',0);
INSERT INTO `#__bid_country` VALUES (107,'ISLE OF MAN','IM',0);
INSERT INTO `#__bid_country` VALUES (108,'ISRAEL','IL',0);
INSERT INTO `#__bid_country` VALUES (109,'ITALY','IT',0);
INSERT INTO `#__bid_country` VALUES (110,'JAMAICA','JM',0);
INSERT INTO `#__bid_country` VALUES (111,'JAPAN','JP',0);
INSERT INTO `#__bid_country` VALUES (112,'JERSEY','JE',0);
INSERT INTO `#__bid_country` VALUES (113,'JORDAN','JO',0);
INSERT INTO `#__bid_country` VALUES (114,'KAZAKHSTAN','KZ',0);
INSERT INTO `#__bid_country` VALUES (115,'KENYA','KE',0);
INSERT INTO `#__bid_country` VALUES (116,'KIRIBATI','KI',0);
INSERT INTO `#__bid_country` VALUES (117,'KOREA, REPUBLIC OF','KR',0);
INSERT INTO `#__bid_country` VALUES (118,'KUWAIT','KW',0);
INSERT INTO `#__bid_country` VALUES (119,'KYRGYZSTAN','KG',0);
INSERT INTO `#__bid_country` VALUES (120,'LATVIA','LV',0);
INSERT INTO `#__bid_country` VALUES (121,'LEBANON','LB',0);
INSERT INTO `#__bid_country` VALUES (122,'LESOTHO','LS',0);
INSERT INTO `#__bid_country` VALUES (123,'LIBERIA','LR',0);
INSERT INTO `#__bid_country` VALUES (124,'LIBYAN ARAB JAMAHIRIYA','LY',0);
INSERT INTO `#__bid_country` VALUES (125,'LIECHTENSTEIN','LI',0);
INSERT INTO `#__bid_country` VALUES (126,'LITHUANIA','LT',0);
INSERT INTO `#__bid_country` VALUES (127,'LUXEMBOURG','LU',0);
INSERT INTO `#__bid_country` VALUES (128,'MACAO','MO',0);
INSERT INTO `#__bid_country` VALUES (129,'MACEDONI, THE FORMER YUGOSLAV REPUBLIC OF','MK',0);
INSERT INTO `#__bid_country` VALUES (130,'MADAGASCAR','MG',0);
INSERT INTO `#__bid_country` VALUES (131,'MALAWI','MW',0);
INSERT INTO `#__bid_country` VALUES (132,'MALAYSIA','MY',0);
INSERT INTO `#__bid_country` VALUES (133,'MALDIVES','MV',0);
INSERT INTO `#__bid_country` VALUES (134,'MALI','ML',0);
INSERT INTO `#__bid_country` VALUES (135,'MALTA','MT',0);
INSERT INTO `#__bid_country` VALUES (136,'MARSHALL ISLANDS','MH',0);
INSERT INTO `#__bid_country` VALUES (137,'MARTINIQUE','MQ',0);
INSERT INTO `#__bid_country` VALUES (138,'MAURITANIA','MR',0);
INSERT INTO `#__bid_country` VALUES (139,'MAURITIUS','MU',0);
INSERT INTO `#__bid_country` VALUES (140,'MAYOTTE','YT',0);
INSERT INTO `#__bid_country` VALUES (141,'MEXICO','MX',0);
INSERT INTO `#__bid_country` VALUES (142,'MICRONESIA, FEDERATED STATES OF','FM',0);
INSERT INTO `#__bid_country` VALUES (143,'MOLDOVA, REPUBLIC OF','MD',0);
INSERT INTO `#__bid_country` VALUES (144,'MONACO','MC',0);
INSERT INTO `#__bid_country` VALUES (145,'MONGOLIA','MN',0);
INSERT INTO `#__bid_country` VALUES (146,'MONTENEGRO','ME',0);
INSERT INTO `#__bid_country` VALUES (147,'MONTSERRAT','MS',0);
INSERT INTO `#__bid_country` VALUES (148,'MOROCCO','MA',0);
INSERT INTO `#__bid_country` VALUES (149,'MOZAMBIQUE','MZ',0);
INSERT INTO `#__bid_country` VALUES (150,'MYANMAR','MM',0);
INSERT INTO `#__bid_country` VALUES (151,'NAMIBIA','NA',0);
INSERT INTO `#__bid_country` VALUES (152,'NAURU','NR',0);
INSERT INTO `#__bid_country` VALUES (153,'NEPAL','NP',0);
INSERT INTO `#__bid_country` VALUES (154,'NETHERLANDS','NL',0);
INSERT INTO `#__bid_country` VALUES (155,'NETHERLANDS ANTILLES','AN',0);
INSERT INTO `#__bid_country` VALUES (156,'NEW CALEDONIA','NC',0);
INSERT INTO `#__bid_country` VALUES (157,'NEW ZEALAND','NZ',0);
INSERT INTO `#__bid_country` VALUES (158,'NICARAGUA','NI',0);
INSERT INTO `#__bid_country` VALUES (159,'NIGER','NE',0);
INSERT INTO `#__bid_country` VALUES (160,'NIGERIA','NG',0);
INSERT INTO `#__bid_country` VALUES (161,'NIUE','NU',0);
INSERT INTO `#__bid_country` VALUES (162,'NORFOLK ISLAND','NF',0);
INSERT INTO `#__bid_country` VALUES (163,'NORTHERN MARIANA ISLANDS','MP',0);
INSERT INTO `#__bid_country` VALUES (164,'NORWAY','NO',0);
INSERT INTO `#__bid_country` VALUES (165,'OMAN','OM',0);
INSERT INTO `#__bid_country` VALUES (166,'PAKISTAN','PK',0);
INSERT INTO `#__bid_country` VALUES (167,'PALAU','PW',0);
INSERT INTO `#__bid_country` VALUES (168,'PALESTINIAN TERRITORY, OCCUPIED','PS',0);
INSERT INTO `#__bid_country` VALUES (169,'PANAMA','PA',0);
INSERT INTO `#__bid_country` VALUES (170,'PAPUA NEW GUINEA','PG',0);
INSERT INTO `#__bid_country` VALUES (171,'PARAGUAY','PY',0);
INSERT INTO `#__bid_country` VALUES (172,'PERU','PE',0);
INSERT INTO `#__bid_country` VALUES (173,'PHILIPPINES','PH',0);
INSERT INTO `#__bid_country` VALUES (174,'PITCAIRN','PN',0);
INSERT INTO `#__bid_country` VALUES (175,'POLAND','PL',0);
INSERT INTO `#__bid_country` VALUES (176,'PORTUGAL','PT',0);
INSERT INTO `#__bid_country` VALUES (177,'PUERTO RICO','PR',0);
INSERT INTO `#__bid_country` VALUES (178,'QATAR','QA',0);
INSERT INTO `#__bid_country` VALUES (179,'REUNION','RE',0);
INSERT INTO `#__bid_country` VALUES (180,'ROMANIA','RO',1);
INSERT INTO `#__bid_country` VALUES (181,'RUSSIAN FEDERATION','RU',0);
INSERT INTO `#__bid_country` VALUES (182,'RWANDA','RW',0);
INSERT INTO `#__bid_country` VALUES (183,'SAINT HELENA','SH',0);
INSERT INTO `#__bid_country` VALUES (184,'SAINT KITTS AND NEVIS','KN',0);
INSERT INTO `#__bid_country` VALUES (185,'SAINT LUCIA','LC',0);
INSERT INTO `#__bid_country` VALUES (186,'SAINT PIERRE AND MIQUELON','PM',0);
INSERT INTO `#__bid_country` VALUES (187,'SAINT VINCENT AND THE GRENADINES','VC',0);
INSERT INTO `#__bid_country` VALUES (188,'SAMOA','WS',0);
INSERT INTO `#__bid_country` VALUES (189,'SAN MARINO','SM',0);
INSERT INTO `#__bid_country` VALUES (190,'SAO TOME AND PRINCIPE','ST',0);
INSERT INTO `#__bid_country` VALUES (191,'SAUDI ARABIA','SA',0);
INSERT INTO `#__bid_country` VALUES (192,'SENEGAL','SN',0);
INSERT INTO `#__bid_country` VALUES (193,'SERBIA','RS',0);
INSERT INTO `#__bid_country` VALUES (194,'SEYCHELLES','SC',0);
INSERT INTO `#__bid_country` VALUES (195,'SIERRA LEONE','SL',0);
INSERT INTO `#__bid_country` VALUES (196,'SINGAPORE','SG',0);
INSERT INTO `#__bid_country` VALUES (197,'SLOVAKIA','SK',0);
INSERT INTO `#__bid_country` VALUES (198,'SLOVENIA','SI',0);
INSERT INTO `#__bid_country` VALUES (199,'SOLOMON ISLANDS','SB',0);
INSERT INTO `#__bid_country` VALUES (200,'SOMALIA','SO',0);
INSERT INTO `#__bid_country` VALUES (201,'SOUTH AFRICA','ZA',0);
INSERT INTO `#__bid_country` VALUES (202,'SOUTH GEORGIA AND THE SOUTH SANDWICH ISLANDS','GS',0);
INSERT INTO `#__bid_country` VALUES (203,'SPAIN','ES',0);
INSERT INTO `#__bid_country` VALUES (204,'SRI LANKA','LK',0);
INSERT INTO `#__bid_country` VALUES (205,'SUDAN','SD',0);
INSERT INTO `#__bid_country` VALUES (206,'SURINAME','SR',0);
INSERT INTO `#__bid_country` VALUES (207,'SVALBARD AND JAN MAYEN','SJ',0);
INSERT INTO `#__bid_country` VALUES (208,'SWAZILAND','SZ',0);
INSERT INTO `#__bid_country` VALUES (209,'SWEDEN','SE',0);
INSERT INTO `#__bid_country` VALUES (210,'SWITZERLAND','CH',1);
INSERT INTO `#__bid_country` VALUES (211,'SYRIAN ARAB REPUBLIC','SY',0);
INSERT INTO `#__bid_country` VALUES (212,'TAIWAN, PROVINCE OF CHINA','TW',0);
INSERT INTO `#__bid_country` VALUES (213,'TAJIKISTAN','TJ',0);
INSERT INTO `#__bid_country` VALUES (214,'TANZANIA, UNITED REPUBLIC OF','TZ',0);
INSERT INTO `#__bid_country` VALUES (215,'THAILAND','TH',0);
INSERT INTO `#__bid_country` VALUES (216,'TIMOR-LESTE','TL',0);
INSERT INTO `#__bid_country` VALUES (217,'TOGO','TG',0);
INSERT INTO `#__bid_country` VALUES (218,'TOKELAU','TK',0);
INSERT INTO `#__bid_country` VALUES (219,'TONGA','TO',0);
INSERT INTO `#__bid_country` VALUES (220,'TRINIDAD AND TOBAGO','TT',0);
INSERT INTO `#__bid_country` VALUES (221,'TUNISIA','TN',0);
INSERT INTO `#__bid_country` VALUES (222,'TURKEY','TR',0);
INSERT INTO `#__bid_country` VALUES (223,'TURKMENISTAN','TM',0);
INSERT INTO `#__bid_country` VALUES (224,'TURKS AND CAICOS ISLANDS','TC',0);
INSERT INTO `#__bid_country` VALUES (225,'TUVALU','TV',0);
INSERT INTO `#__bid_country` VALUES (226,'UGANDA','UG',0);
INSERT INTO `#__bid_country` VALUES (227,'UKRAINE','UA',0);
INSERT INTO `#__bid_country` VALUES (228,'UNITED ARAB EMIRATES','AE',0);
INSERT INTO `#__bid_country` VALUES (229,'UNITED KINGDOM','GB',1);
INSERT INTO `#__bid_country` VALUES (230,'UNITED STATES','US',1);
INSERT INTO `#__bid_country` VALUES (231,'UNITED STATES MINOR OUTLYING ISLANDS','UM',0);
INSERT INTO `#__bid_country` VALUES (232,'URUGUAY','UY',0);
INSERT INTO `#__bid_country` VALUES (233,'UZBEKISTAN','UZ',0);
INSERT INTO `#__bid_country` VALUES (234,'VANUATU','VU',0);
INSERT INTO `#__bid_country` VALUES (235,'VATICAN CITY STATE (HOLY SEE)','VA',0);
INSERT INTO `#__bid_country` VALUES (236,'VENEZUELA','VE',0);
INSERT INTO `#__bid_country` VALUES (237,'VIET NAM','VN',0);
INSERT INTO `#__bid_country` VALUES (238,'VIRGIN ISLANDS, BRITISH','VG',0);
INSERT INTO `#__bid_country` VALUES (239,'VIRGIN ISLANDS, U.S.','VI',0);
INSERT INTO `#__bid_country` VALUES (240,'WALLIS AND FUTUNA','WF',0);
INSERT INTO `#__bid_country` VALUES (241,'WESTERN SAHARA','EH',0);
INSERT INTO `#__bid_country` VALUES (242,'YEMEN','YE',0);
INSERT INTO `#__bid_country` VALUES (243,'ZAMBIA','ZM',0);
INSERT INTO `#__bid_country` VALUES (244,'ZIMBABWE','ZW',0);
DROP TABLE IF EXISTS `#__bid_currency`;
CREATE TABLE `#__bid_currency` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
);
INSERT INTO `#__bid_currency` (`id`, `name`) VALUES (1, 'USD');
INSERT INTO `#__bid_currency` (`id`, `name`) VALUES (2, 'AUD');
INSERT INTO `#__bid_currency` (`id`, `name`) VALUES (3, 'EUR');
INSERT INTO `#__bid_currency` (`id`, `name`) VALUES (4, 'RON');
DROP TABLE IF EXISTS `#__bid_mails`;
CREATE TABLE `#__bid_mails` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mail_type` varchar(250) DEFAULT NULL,
  `content` text,
  `subject` varchar(250) DEFAULT NULL,
  `enabled` int(11) DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `mailtypes` (`mail_type`)
);
DROP TABLE IF EXISTS `#__bid_messages`;
CREATE TABLE `#__bid_messages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_offer` int(11) NOT NULL DEFAULT '0',
  `userid1` int(11) NOT NULL DEFAULT '0',
  `userid2` int(11) NOT NULL DEFAULT '0',
  `parent_message` int(11) NOT NULL DEFAULT '0',
  `message` text NOT NULL,
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `wasread` int(1) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `id_offer` (`id_offer`),
  KEY `ixuserid` (`userid1`),
  KEY `ixuserid2` (`userid2`)
);
DROP TABLE IF EXISTS `#__bid_payment`;
CREATE TABLE `#__bid_payment` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
);
INSERT INTO `#__bid_payment`(`id`,`name`) VALUES('1','Any type of payment');
INSERT INTO `#__bid_payment`(`id`,`name`) VALUES('2','Cash');
INSERT INTO `#__bid_payment`(`id`,`name`) VALUES('3','Bankwire');
INSERT INTO `#__bid_payment`(`id`,`name`) VALUES('4','VISA / MASTER CARD');

DROP TABLE IF EXISTS `#__bid_pictures`;
CREATE TABLE `#__bid_pictures` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_offer` int(11) NOT NULL DEFAULT '0',
  `userid` int(11) NOT NULL DEFAULT '0',
  `picture` varchar(100) NOT NULL DEFAULT '',
  `modified` date NOT NULL DEFAULT '0000-00-00',
  PRIMARY KEY (`id`),
  KEY `idoffer` (`id_offer`),
  KEY `ixuserid` (`userid`)
);
DROP TABLE IF EXISTS `#__bid_rate`;
CREATE TABLE `#__bid_rate` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `voter` int(11) NOT NULL DEFAULT '0',
  `user_rated` int(11) NOT NULL DEFAULT '0',
  `rating` int(11) DEFAULT '0',
  `modified` date NOT NULL DEFAULT '0000-00-00',
  `message` text,
  `auction_id` int(11) NOT NULL DEFAULT '0',
  `rate_type` enum('auctioneer','bidder') DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `userrated` (`user_rated`),
  KEY `auctionid` (`auction_id`),
  KEY `ratetype` (`rate_type`)
);
DROP TABLE IF EXISTS `#__bid_report_auctions`;
CREATE TABLE `#__bid_report_auctions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_offer` int(11) NOT NULL DEFAULT '0',
  `userid` int(11) NOT NULL DEFAULT '0',
  `message` varchar(200) NOT NULL DEFAULT '',
  `processing` int(11) NOT NULL DEFAULT '0',
  `solved` int(11) NOT NULL DEFAULT '0',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `id_offer` (`id_offer`)
);
DROP TABLE IF EXISTS `#__bid_watchlist`;
CREATE TABLE `#__bid_watchlist` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` int(11) NOT NULL DEFAULT '0',
  `auctionid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `iuserid` (`userid`),
  KEY `iauctionid` (`auctionid`)
);
DROP TABLE IF EXISTS `#__bid_users`;
CREATE TABLE `#__bid_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` int(11) NOT NULL DEFAULT '0',
  `name` varchar(50) NOT NULL DEFAULT '',
  `surname` varchar(50) NOT NULL DEFAULT '',
  `address` varchar(150) NOT NULL DEFAULT '',
  `city` varchar(50) NOT NULL DEFAULT '',
  `country` varchar(150) NOT NULL DEFAULT '',
  `phone` text NOT NULL,
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `verified` int(1) DEFAULT '0',
  `isBidder` int(1) DEFAULT '0',
  `isSeller` int(1) DEFAULT '0',
  `powerseller` int(1) DEFAULT '0',
  `paypalemail` text,
  PRIMARY KEY (`id`),
  KEY `userid` (`userid`),
  KEY `ixopts` (`verified`,`isBidder`,`isSeller`)
);
DROP TABLE IF EXISTS `#__bid_proxy`;
CREATE TABLE `#__bid_proxy` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `auction_id` int(11) NOT NULL DEFAULT '0',
  `user_id` int(11) NOT NULL DEFAULT '0',
  `max_proxy_price` varchar(200) DEFAULT NULL,
  `active` tinyint(4) NOT NULL DEFAULT '0',
  `latest_bid` varchar(200) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `idauction` (`auction_id`),
  KEY `user_id` (`user_id`)
);
DROP TABLE IF EXISTS `#__bid_categories`;
CREATE TABLE `#__bid_categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `catname` varchar(100) NOT NULL DEFAULT '',
  `parent` int(11) NOT NULL DEFAULT '0',
  `hash` varchar(32) NOT NULL DEFAULT '',
  `ordering` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `ihash` (`hash`)
);
DROP TABLE IF EXISTS `#__bid_cbfields` ;
CREATE TABLE `#__bid_cbfields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `field` varchar(50) DEFAULT NULL,
  `cb_field` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`id`)
);
INSERT INTO `#__bid_cbfields` VALUES (1,'country','');
INSERT INTO `#__bid_cbfields` VALUES (2,'city','');
INSERT INTO `#__bid_cbfields` VALUES (3,'isBidder','');
INSERT INTO `#__bid_cbfields` VALUES (4,'isSeller','');
INSERT INTO `#__bid_cbfields` VALUES (5,'verified','');
INSERT INTO `#__bid_cbfields` VALUES (6,'powerseller','');
INSERT INTO `#__bid_cbfields` VALUES (7,'paymentparam','');

DROP TABLE IF EXISTS `#__bid_credits`;
CREATE TABLE `#__bid_credits` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` int(11) DEFAULT NULL,
  `credittype` varchar(50) DEFAULT NULL,
  `amount` varchar(200) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `ixuserid` (`userid`),
  KEY `ixcreit` (`credittype`)
);
DROP TABLE IF EXISTS `#__bid_paylog`;
CREATE TABLE `#__bid_paylog` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` datetime DEFAULT NULL,
  `amount` varchar(200) DEFAULT NULL,
  `currency` varchar(11) DEFAULT NULL,
  `refnumber` varchar(100) DEFAULT NULL,
  `invoice` varchar(50) DEFAULT NULL,
  `ipn_response` text,
  `ipn_ip` varchar(100) DEFAULT NULL,
  `comission_id` int(11) DEFAULT NULL,
  `status` enum('ok','error','manual_check','cancelled','refunded') DEFAULT NULL,
  `userid` int(11) DEFAULT NULL,
  `itemname` varchar(50) DEFAULT NULL,
  `payment_method` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `ixdate` (`date`),
  KEY `ixuserid` (`userid`),
  KEY `ixstatus` (`status`),
  KEY `ixref` (`refnumber`),
  KEY `ixinvoice` (`invoice`)
);
DROP TABLE IF EXISTS `#__bid_paysystems`;
CREATE TABLE `#__bid_paysystems` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `paysystem` varchar(50) DEFAULT NULL,
  `classname` varchar(50) DEFAULT NULL,
  `enabled` int(1) DEFAULT '1',
  `params` text,
  `ordering` int(11) DEFAULT NULL,
  `isdefault` int(1) DEFAULT '0',
  PRIMARY KEY (`id`)
);
INSERT INTO `#__bid_paysystems` 
(`id`, `paysystem`, `classname`, `enabled`, `params`, `ordering`, `isdefault`) 
VALUES 
(1, 'Paypal', 'pay_paypal', 1, 'paypal_email=change@me.now\r\nuse_sandbox=0', NULL, 0),
(2, 'Moneybookers', 'pay_moneybookers', 1, 'email=change@me.now\n', NULL, 0);
DROP TABLE IF EXISTS `#__bid_pricing`;
CREATE TABLE `#__bid_pricing` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `itemname` varchar(50) DEFAULT NULL,
  `pricetype` enum('percent','fixed') DEFAULT NULL,
  `price` varchar(200) DEFAULT NULL,
  `currency` varchar(11) DEFAULT NULL,
  `enabled` int(1) DEFAULT NULL,
  `params` text,
  `ordering` int(11) DEFAULT NULL,
  `task_pay` varchar(30) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `ixitemname` (`itemname`)
);
DROP TABLE IF EXISTS `#__bid_tags`;
CREATE TABLE `#__bid_tags` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `auction_id` int(11) DEFAULT NULL,
  `tagname` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `iauction` (`auction_id`),
  KEY `itagname` (`tagname`)
);
DROP TABLE IF EXISTS `#__bid_balance`;
CREATE TABLE `#__bid_balance` (
	 `id` int(11) NOT NULL auto_increment,
	`auctioneer` int(11) NOT NULL,
	`amount` varchar(255) NOT NULL,
	`last_pay` datetime NOT NULL,
	`currency` int(1),
  	`sent_message` tinyint(1) DEFAULT '0',
	PRIMARY KEY  (`id`)
);

DROP TABLE IF EXISTS `#__bid_payments`;
CREATE TABLE `#__bid_payments` (
  `id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL,
  `amount` varchar(255) NOT NULL,
   `paydate` datetime NOT NULL,
   `automatic` int(11) default '0' NOT NULL,
	`currency` int(1),
    PRIMARY KEY  (`id`)
);
DROP TABLE IF EXISTS `#__bid_comissions`;
CREATE TABLE `#__bid_comissions` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) default NULL,
  `auction_id` int(11) default NULL,
  `bid_id` int(11) NOT NULL,
  `comission_date` datetime default NULL,
  `amount` varchar(200) default NULL,
	`currency` int(1),
  PRIMARY KEY  (`id`),
  KEY `ixuserid` (`userid`),
  KEY `ixauctionid` (`auction_id`)
);
INSERT INTO `#__bid_mails` VALUES (1,'terms_and_conditions','<p><strong>TERMS AND CONDITIONS</strong>  </p><p>&nbsp;</p><p>&nbsp;</p><p>Thanks  <u>Bye</u> </p>',NULL,1);
INSERT INTO `#__bid_mails` VALUES (2,'new_message','<p>Dear %NAME%  %SURNAME%,  </p><p>&nbsp;You received a new reply to your bid regarding the Auction: &quot;%AUCTIONTITLE% &quot;</p><p> You can see the message here  %AUCTIONLINK%  </p><p>&nbsp;You must login to read the message.</p><p>Best Regards,</p><p>The Webmaster&nbsp;</p>','New message regarding Auction %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (3,'new_bid','<p>Dear %NAME%  %SURNAME%,  </p><p>&nbsp;You received a new bid to your bid regarding the Auction: &quot;%AUCTIONTITLE% &quot;</p><p> You can see the bid here  %AUCTIONLINK%  </p><p>&nbsp;You must login to read the message.</p><p>Best Regards,</p><p>The Webmaster </p>','New bid on your Auction %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (4,'bid_accepted','<p>Dear %NAME% %SURNAME%,  </p><p>&nbsp;Your Bid for the auction %AUCTIONTITLE% won!&nbsp;</p><p>Congratulations!!</p><p>&nbsp;</p><p>  You can get more details on the webpage  %AUCTIONLINK%</p><p>Best Regards,</p><p>The Webmaster </p>','Your Bid was accepted on the Auction %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (5,'bid_lost','<p>Dear %NAME% %SURNAME%,</p><p>  Unfortunately, your Bid for the auction %AUCTIONTITLE% has lost </p><p>  You can get more details on the webpage  %AUCTIONLINK%</p><p>Best Regards,</p><p>The Webmaster </p><p>&nbsp;</p>','Informations about your bid on %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (8,'new_bid_auto_bin','<p>Dear %NAME% %SURNAME%,</p><p>  You recieved a BIN Bid for your auction %AUCTIONTITLE% and it was automatically accepted!  </p><p>You can get more details on the webpage  %AUCTIONLINK%</p><p>Best Regards,</p> <p>The Webmaster </p> <p>&nbsp;</p>','A BIN bid on %AUCTIONTITLE% was automatically accepted',1);
INSERT INTO `#__bid_mails` VALUES (9,'bin_accepted','Dear %NAME% %SURNAME%,  Your BIN Bid for the auction %AUCTIONTITLE% was accepted!  You can get more details on the webpage  %AUCTIONLINK%','Informations about your bid on %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (10,'bin_wait_approval','<p>Dear %NAME% %SURNAME%,  </p> <p>&nbsp;Your BIN Bid for the auction %AUCTIONTITLE% is waiting approval. You will be notify as soon as the Auctioneer takes a decision regarding your bid.</p><p>You can get more details on the webpage  %AUCTIONLINK%</p> <p>Best Regards,</p> <p>The Webmaster </p>','Informations about your BIN bid on Auction %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (11,'alert_bin_accepted','<p>Dear %NAME% %SURNAME%,  </p> <p>On the Auction &quot;%AUCTIONTITLE%&quot; a BIN bid was accepted!&nbsp;</p><p>You can get more details on the webpage  %AUCTIONLINK%</p> <p>Best Regards,</p> <p>The Webmaster </p>','Informations about your Watch on  %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (12,'bid_watchlist_canceled','<p>Dear %NAME% %SURNAME%,  </p> <p>The Auction %AUCTIONTITLE% was canceled!&nbsp;</p><p>You can get more details on the webpage  %AUCTIONLINK%</p> <p>Best Regards,</p> <p>The Webmaster </p>','Informations about your Watched Auction  %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (13,'bid_canceled','<p>Dear %NAME% %SURNAME%,  </p> <p>The auction %AUCTIONTITLE% was canceled!</p><p>You can get more details on the webpage  %AUCTIONLINK%</p> <p>Best Regards,</p> <p>The Webmaster </p>','Informations about your bid on  %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (14,'bid_watchlist_closed','<p>Dear %NAME% %SURNAME%,  </p> <p>The auction %AUCTIONTITLE% you were watching was closed!&nbsp;</p><p>You can get more details on the webpage  %AUCTIONLINK%</p> <p>Best Regards,</p> <p>The Webmaster </p>','Informations about your Watched Auction %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (15,'bid_closed','<p>Dear %NAME% %SURNAME%,  </p><p>The auction %AUCTIONTITLE% was closed !</p><p>You can get more details on the webpage  %AUCTIONLINK%</p> <p>Best Regards,</p> <p>The Webmaster </p>','Informations about your bid on %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (16,'bid_rate','<p>Dear %NAME% %SURNAME%,</p><p>  You recieved a rating for the auction %AUCTIONTITLE%  !</p> <p>  You can get more details on the webpage  %AUCTIONLINK%</p> <p>Best Regards,</p> <p>The Webmaster </p> <p>&nbsp;</p>','New Rating recieved',1);
INSERT INTO `#__bid_mails` VALUES (17,'bid_admin_message','<p>Dear %NAME% %SURNAME%,  </p><p>You recieved a message from one of the Administrators regarding your auction %AUCTIONTITLE%  !</p><p>You can get more details on the webpage  %AUCTIONLINK%</p> <p>Best Regards,</p> <p>The Webmaster </p>','New Message from Webmaster regarding %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (18,'bid_your_will_expire','<p>Dear %NAME% %SURNAME%,  </p><p>Your auction %AUCTIONTITLE% will soon expire !  </p><p>You can get more details on the webpage  %AUCTIONLINK%</p><p>Best Regards,</p> <p>The Webmaster </p> <p>&nbsp;</p>','Your Auction %AUCTIONTITLE% will soon expire',1);
INSERT INTO `#__bid_mails` VALUES (19,'bid_watchlist_will_expire','<p>Dear %NAME% %SURNAME%,  </p><p>The Action you watched: %AUCTIONTITLE% will soon expire !  </p><p>You can get more details on the webpage  %AUCTIONLINK%</p> <p>Best Regards,</p> <p>The Webmaster </p>','Informations about your watched Auction  %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (20,'bid_new_mybid','<p>Dear %NAME% %SURNAME%,  </p><p>you placed a new bid on : %AUCTIONTITLE%  !</p><p>You can get more details on the webpage  %AUCTIONLINK%</p> <p>Best Regards,</p> <p>The Webmaster </p>','Bid placed on Auction %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (21,'proxy_ended','<p>Dear %NAME% %SURNAME%,  </p> <p>&nbsp;Your Proxy Bid for the auction %AUCTIONTITLE% has reached its limit.</p><p>You can get more details on the webpage  %AUCTIONLINK%</p> <p>Best Regards,</p> <p>The Webmaster </p>','Informations about your proxybid on %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (22,'new_bid_watchlist','<p>Dear %NAME%  %SURNAME%,  </p><p>A new bid was placed on the Auction: &quot;%AUCTIONTITLE% &quot; that you were watching</p><p> You can see the bid here  %AUCTIONLINK%  </p><p> You must login to read the message.</p><p>Best Regards,</p><p>The Webmaster </p>','Informations about your Watched Auction %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (23,'new_bid_bin','<p>Dear %NAME% %SURNAME%,  </p><p>A new BIN bid was placed on your Auction %AUCTIONTITLE%  !&nbsp; </p><p>It is waiting for your approval!&nbsp;</p><p>You can get more details on the webpage  %AUCTIONLINK%</p> <p>Best Regards,</p> <p>The Webmaster </p>','New BIN bid on your Auction %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (24,'alert_new_bid_bin','<p>Dear %NAME%  %SURNAME%,  </p> <p>A new BIN bid was placed on the Auction: &quot;%AUCTIONTITLE% &quot; that you were watching<br /> </p> <p> You can see the bid here  %AUCTIONLINK%  </p> <p> You must login to read the message.</p> <p>Best Regards,</p> <p>The Webmaster </p>','Informations about your Watched Auction %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (25,'bid_choose_winner','<p>Dear %NAME% %SURNAME%,  </p><p>&nbsp;Your auction %AUCTIONTITLE% awaits that you choose a winner.&nbsp;</p><p>You can do this by visiting %AUCTIONLINK%</p><p>Best Regards,</p><p>The Webmaster </p>','A bid won for your auction %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (26,'bid_offer_winner_to_owner','<p>Dear %NAME% %SURNAME%,  </p><p>&nbsp;Your auction %AUCTIONTITLE% has a winning bid.&nbsp;</p><p>You can see it by visiting %AUCTIONLINK%</p><p>Best Regards,</p><p>The Webmaster </p>','Please choose a winner for your auction %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (27,'bid_offer_no_winner_to_owner','<p>Dear %NAME% %SURNAME%,  </p><p>&nbsp;Your auction %AUCTIONTITLE% did not had a winning bid. It was closed without one&nbsp;</p><p>You can visit %AUCTIONLINK%</p><p>Best Regards,</p><p>The Webmaster </p>','No winner for your auction %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (28,'bid_outbid','<p>Dear %NAME% %SURNAME%,  </p><p>&nbsp;Your bid on %AUCTIONTITLE% was outbid.&nbsp;</p><p>You can rebid here %AUCTIONLINK%</p><p>Best Regards,</p><p>The Webmaster </p>','Your bid on %AUCTIONTITLE% was outbidded',1);
INSERT INTO `#__bid_mails` VALUES (29,'bid_reserve_not_met','<p>Dear %NAME%  %SURNAME%,  </p> <p>Your  Auction: &quot;%AUCTIONTITLE% &quot; expired and the reserve price was not met<br /> </p> <p> You can see the bid here  %AUCTIONLINK%  </p> <p> You must login to choose winner.</p> <p>Best Regards,</p> <p>The Webmaster </p>','Your Auction %AUCTIONTITLE% did not met reserve price',1);
INSERT INTO `#__bid_mails` VALUES (30,'bid_payment_received','<p>Dear %NAME%  %SURNAME%,  </p> <p>Your  Payment was received<br /> </p>   <p>Best Regards,</p> <p>The Webmaster </p>','Your Payment is received',1);
INSERT INTO `#__bid_mails` VALUES (31,'report_notify','<p>Dear %NAME%  %SURNAME%,  </p><p>&nbsp;The Auction: &quot;%AUCTIONTITLE% &quot;</p><p> was reported as abusive. You can see the message here  %AUCTIONLINK%  </p><p>&nbsp;You must login to read the message.</p><p>Best Regards,</p><p>The Webmaster&nbsp;</p>','The Auction: %AUCTIONTITLE%  was reported as abusive',1);

INSERT INTO `#__bid_mails` VALUES (32,'suggest_accepted','<p>Dear %NAME%  %SURNAME%,  </p><p>Your price suggestion on &quot;%AUCTIONTITLE% &quot;</p><p> was accepted. You can see the suggestion here  %AUCTIONLINK%  </p><p>&nbsp;You must login to read the message.</p><p>Best Regards,</p><p>The Webmaster&nbsp;</p>','Your price suggestion on Auction: %AUCTIONTITLE%  was accepted',1);
INSERT INTO `#__bid_mails` VALUES (33,'suggest_rejected','<p>Dear %NAME%  %SURNAME%,  </p><p>Your price suggestion on &quot;%AUCTIONTITLE% &quot;</p><p> was rejected. You can see the suggestion here  %AUCTIONLINK%  </p><p>&nbsp;You must login to read the message.</p><p>Best Regards,</p><p>The Webmaster&nbsp;</p>','Your price suggestion on Auction: %AUCTIONTITLE%  was rejected',1);

INSERT INTO `#__bid_mails` VALUES (34,'suggest_success','<p>Dear %NAME%  %SURNAME%,  </p><p>A new price suggestion was received on &quot;%AUCTIONTITLE% &quot;</p><p> You can see the suggestions here  %AUCTIONLINK%  </p><p>&nbsp;You must login to see the suggestions.</p><p>Best Regards,</p><p>The Webmaster&nbsp;</p>','A new price suggestion on Auction: %AUCTIONTITLE%  was received',1);
INSERT INTO `#__bid_mails` VALUES (35,'suggest_reminder','<p>Dear %NAME%  %SURNAME%,  </p><p>Some price suggestions on &quot;%AUCTIONTITLE% &quot; are waitting to be accepted / reject </p><p> You can see the suggestions here  %AUCTIONLINK%  </p><p>&nbsp;You must login to read the message.</p><p>Best Regards,</p><p>The Webmaster&nbsp;</p>','Some price suggestions on Auction: %AUCTIONTITLE%  are waitting for moderation',1);
INSERT INTO `#__bid_mails` VALUES (36,'replysuggest_success','<p>Dear %NAME%  %SURNAME%,  </p><p>You have received a suggestion reply on &quot;%AUCTIONTITLE% &quot;</p><p> You can see the suggestions here  %AUCTIONLINK%  </p><p>&nbsp;You must login to read the message.</p><p>Best Regards,</p><p>The Webmaster&nbsp;</p>','You have received reply to suggestion: %AUCTIONTITLE%',1);
INSERT INTO `#__bid_mails` VALUES (37,'new_auction','<p>Dear %NAME%  %SURNAME%,  </p><p>Your auction &quot;%AUCTIONTITLE% &quot; was published </p><p> You can see the auction here  %AUCTIONLINK%  </p><p>&nbsp;You must login to read the message.</p><p>Best Regards,</p><p>The Webmaster&nbsp;</p>','Your auction %AUCTIONTITLE% was published',1);

INSERT INTO `#__bid_pricing` VALUES (1,'featured_gold','fixed',11,'USD',1,NULL,3,'buy_featured&featured=gold');
INSERT INTO `#__bid_pricing` VALUES (2,'listing','fixed',4,'USD',0,NULL,1,'buy_listing');
INSERT INTO `#__bid_pricing` VALUES (4,'featured_silver','fixed',5,'USD',1,NULL,4,'buy_featured&featured=silver');
INSERT INTO `#__bid_pricing` VALUES (5,'featured_bronze','fixed',2,'USD',1,NULL,5,'buy_featured&featured=bronze');
INSERT INTO `#__bid_pricing` VALUES (6,'comission','percent',10,'',0,NULL,2,'pay_comission');
INSERT INTO `#__bid_pricing` VALUES (7,'contact','fixed',1,'USD',0,NULL,2,'buy_contact');
INSERT INTO `#__bid_pricing` VALUES (8,'bid','fixed',1,'USD',0,NULL,2,'buy_bidding');

DROP TABLE IF EXISTS `#__contacts_buy`;
CREATE TABLE `#__contacts_buy` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL,
  `contact_id` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
);

DROP TABLE IF EXISTS `#__bid_custom_prices`;
CREATE TABLE `#__bid_custom_prices` (
  `id` int(11) NOT NULL auto_increment,
  `category` int(11) NOT NULL,
  `price` int(11) NOT NULL,
  `price_type` enum('listing','commission') NOT NULL,
  PRIMARY KEY  (`id`)
);

DROP TABLE IF EXISTS `#__bid_auct_payments`;
CREATE TABLE `#__bid_auct_payments` (
  `id` int(11) NOT NULL auto_increment,
  `auct` int(11) NOT NULL,
  `payment` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
);

DROP TABLE IF EXISTS `#__bid_increment`;
CREATE TABLE `#__bid_increment` (
  `id` int(11) NOT NULL auto_increment,
  `min_bid` float(10,2) NOT NULL,
  `max_bid` float(10,2) NOT NULL,
  `value` float(10,2) NOT NULL,
   PRIMARY KEY  (`id`)
);

INSERT INTO `#__bid_increment` (`id`, `min_bid`, `max_bid`, `value`) VALUES
(1, '0.01', '10.00', '0.10'),
(2, '10.01', '25.00', '0.50'),
(3, '25.01', '100.00', '1.00'),
(4, '100.01', '150.00', '2.00'),
(5, '150.01', '500.00', '5.00'),
(6, '500.01', '1500.00', '10.00'),
(7, '1500.01', '2500.00', '20.00');

DROP TABLE IF EXISTS `#__bid_shipment_prices`;
CREATE TABLE `#__bid_shipment_prices` (
  `id` int(11) NOT NULL auto_increment,
  `zone` int(11) NOT NULL,
  `price` varchar(100) NOT NULL,
  `auction` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
);

DROP TABLE IF EXISTS `#__bid_shipment_zones`;
CREATE TABLE `#__bid_shipment_zones` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `state` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`)
);


DROP TABLE IF EXISTS `#__bid_user_settings`;
CREATE TABLE `#__bid_user_settings` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY  (`id`)
);


DROP TABLE IF EXISTS `#__bid_fields`;
CREATE TABLE `#__bid_fields` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `db_name` varchar(100) NOT NULL,
  `field_id` varchar(100) NOT NULL,
  `page` varchar(100) NOT NULL,
  `search` tinyint(1) NOT NULL,
  `ftype` varchar(150) NOT NULL,
  `compulsory` tinyint(1) NOT NULL,
  `validate_type` varchar(100) NOT NULL,
  `own_table` varchar(100) NOT NULL,
  `status` tinyint(1) NOT NULL,
  `css_class` varchar(100) NOT NULL,
  `style_attr` text NOT NULL,
  `ordering` int(11) NOT NULL default '0',
  `has_options` int(11) NOT NULL default '0',
  `attributes` text NOT NULL,
  `params` text NOT NULL,
  PRIMARY KEY  (`id`)
);

DROP TABLE IF EXISTS `#__bid_fields_options`;
CREATE TABLE `#__bid_fields_options` (
  `id` int(11) NOT NULL auto_increment,
  `fid` int(11) NOT NULL,
  `option_name` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`)
);
DROP TABLE IF EXISTS `#__bid_log`;
CREATE TABLE `#__bid_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_offer` int(11) NOT NULL DEFAULT '0',
  `userid` int(11) NOT NULL DEFAULT '0',
  `id_proxy` int(11) NOT NULL DEFAULT '0',
  `initial_bid` varchar(200) DEFAULT NULL,
  `bid_price` varchar(200) NOT NULL DEFAULT '0',
  `payment` int(11) NOT NULL DEFAULT '0',
  `cancel` int(11) DEFAULT NULL,
  `accept` tinyint(4) NOT NULL DEFAULT '0',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `quantity` int(11) DEFAULT 1,
  PRIMARY KEY (`id`),
  KEY `id_offer` (`id_offer`),
  KEY `userid` (`userid`),
  KEY `ixbid_price` (`bid_price`)
);

DROP TABLE IF EXISTS `#__bid_suggest`;
CREATE TABLE `#__bid_suggest` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL,
  `auctionid` int(11) NOT NULL,
  `modified`  datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `status` tinyint(2) NOT NULL COMMENT '0 rejected, 1 accepted, 2 pending',
  `price` varchar(255) NOT NULL,
  `replyto` int(11) NOT NULL,
  `quantity` int(11) DEFAULT 1,
  PRIMARY KEY  (`id`)
);

DROP TABLE IF EXISTS `#__bid_fields_positions`;
CREATE TABLE `#__bid_fields_positions` (
  `id` int(11) NOT NULL auto_increment,
  `fid` int(11) NOT NULL,
  `position` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`)
);

DROP TABLE IF EXISTS `#__bid_positions`;
CREATE TABLE `#__bid_positions` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL,
  `name` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `html` text NOT NULL,
  `tpl` text NOT NULL,
  `verified` tinyint(1) NOT NULL,
  PRIMARY KEY  (`id`)
);
 
INSERT INTO `#__bid_positions` (`id`, `title`, `name`, `description`, `html`, `tpl`, `verified`) VALUES
(1, 'Default Listing position', 'deflisting', '', '<strong>%LABEL%:</strong> %VALUE% <br />', 't_listauctions.tpl', 0),
(2, 'Default Details page  position', 'defdetails', '', '<strong>%LABEL%:</strong>  %VALUE% <br />', 't_auctiondetails.tpl', 0);

INSERT INTO `#__bid_positions` (`id`, `title`, `name`, `description`, `html`, `tpl`, `verified`) VALUES (NULL, 'Default My User Details page position', 'defuserviewpage', '', '<tr><td width="85"><strong>%LABEL%:</strong></td><td>%VALUE%</td></tr>', 't_display_userprofile.tpl', '');


ALTER TABLE `#__bid_categories` ADD `description` text NOT NULL, ADD `status` int(11) NOT NULL default '1';
ALTER TABLE `#__bid_messages` ADD `published` TINYINT( 1 ) NOT NULL DEFAULT '1';

DROP TABLE IF EXISTS `#__bid_fields_categories`;
CREATE TABLE IF NOT EXISTS `#__bid_fields_categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `fid` int(11) NOT NULL,
  `cid` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fid` (`fid`),
  KEY `cid` (`cid`)
);

ALTER TABLE `#__bid_fields` ADD `help` text NOT NULL;

DROP TABLE IF EXISTS `#__bid_categories_sef`;
CREATE TABLE IF NOT EXISTS `#__bid_categories_sef` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL,
  `categories` text NOT NULL,
  PRIMARY KEY (`id`)
);

ALTER TABLE `#__bid_paylog` ADD `object_id` INT( 11 ) NOT NULL;


DROP TABLE IF EXISTS `#__bid_watchlist_cats`;
CREATE TABLE `#__bid_watchlist_cats` (
  `id` int(11) NOT NULL auto_increment,
  `catid` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
);


DROP TABLE IF EXISTS `#__bid_packages`;
CREATE TABLE IF NOT EXISTS `#__bid_packages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `price` varchar(100) NOT NULL,
  `currency` varchar(3) NOT NULL,
  PRIMARY KEY (`id`)
);

INSERT INTO `#__bid_packages` (`id`, `name`, `price`, `currency`) VALUES
(1, 'Premium', '50', 'EUR'),
(2, 'Full', '100', 'USD'),
(3, 'Regular', '30', 'EUR');


DROP TABLE IF EXISTS `#__bid_packages_credits`;
CREATE TABLE IF NOT EXISTS `#__bid_packages_credits` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `pid` int(11) NOT NULL,
  `pricing` varchar(50) NOT NULL,
  `credits` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
);

INSERT INTO `#__bid_packages_credits` (`id`, `pid`, `pricing`, `credits`) VALUES
(1, 1, 'listing', '30'),
(2, 1, 'featured_gold', '5'),
(3, 2, 'listing', '50'),
(4, 2, 'featured_gold', '10'),
(5, 1, 'featured_silver', '1'),
(6, 2, 'featured_silver', '5'),
(7, 3, 'listing', '5'),
(8, 3, 'featured_gold', '1');

ALTER TABLE `#__bid_paylog` 
ADD `var_name1` VARCHAR( 255 ) NOT NULL ,
ADD `var_name2` VARCHAR( 255 ) NOT NULL ,
ADD `var_name3` VARCHAR( 255 ) NOT NULL ,
ADD `var_name4` VARCHAR( 255 ) NOT NULL ,
ADD `var_value1` VARCHAR( 255 ) NOT NULL ,
ADD `var_value2` VARCHAR( 255 ) NOT NULL ,
ADD `var_value3` VARCHAR( 255 ) NOT NULL ,
ADD `var_value4` VARCHAR( 255 ) NOT NULL ;

ALTER TABLE `#__bid_packages` ADD `status` TINYINT( 1 ) NOT NULL DEFAULT '0';

INSERT INTO `#__bid_pricing` ( `id` ,`itemname` ,`pricetype`, `enabled`) 
VALUES ( NULL , 'packages', 'fixed', '1' );

INSERT INTO `#__bid_paysystems` 
(`id`, `paysystem`, `classname`, `enabled`, `params`, `ordering`, `isdefault`) 
VALUES 
(3, '2Checkout', 'pay_2checkout', 1, '', NULL, 0);
