<?php 
/**
 * @version		2.0.0
 * @package		Auctions Factory Factory
 * @copyright	Factory Team
 * @license		comercial
*/
// no direct access
//defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.controller');


/**
 * Auctions Factory Component Controller
 *
 * @package	Bids
 * @since 2.0.0
 */
class JBidsAdminController extends JController
{
	function users() {
		
		$db		=& JFactory::getDBO();
		$app	= JFactory::getApplication();
		$where = array();

		$context			= 'com_bids.bidsadminview.users';
		$filter_order		= $app->getUserStateFromRequest( $context.'filter_order',		'filter_order',		'',	'cmd' );
		$filter_order_Dir	= $app->getUserStateFromRequest( $context.'filter_order_Dir',	'filter_order_Dir',	'',	'word' );
		
		$search				= $app->getUserStateFromRequest( $context.'search',			'search',			'',	'string' );
		$search				= JString::strtolower($search);
		
		$limit				= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart			= $app->getUserStateFromRequest($context.'limitstart', 'limitstart', 0, 'int');
		// In case limit has been changed, adjust limitstart accordingly
		$limitstart 		= ( $limit != 0 ? (floor($limitstart / $limit) * $limit) : 0 );

		if (!$filter_order) {
			$filter_order = 'name';
		}
		$order = ' ORDER BY '. $filter_order .' '. $filter_order_Dir .'';

		if($search)
			$where[] = " username LIKE '%$search%' ";

		// Build the where clause of the content record query
		$where = (count($where) ? ' WHERE '.implode(' AND ', $where) : '');

		// Get the total number of records
		$query = "SELECT COUNT(*) ".
			"FROM #__users".$where;
		$db->setQuery($query);
		$total = $db->loadResult();

		// Create the pagination object
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);



		// Get the users
    	$query = "SELECT b.id as profid, u.id as userid1, u.username as username,u.name as name ".
    			", u.email AS email , b.id as usrid,c.name as country_name, 
    			 b.verified as verified, b.powerseller, b.isBidder, b.isSeller,
    			 COUNT(DISTINCT btbl.id) as nr_closed_bids,
    			 COUNT(DISTINCT auctactive.id) as nr_open_offers,
    			 COUNT(DISTINCT auctclosed.id) as nr_closed_offers,
    			 COUNT(DISTINCT auctfeatured.id) as nr_featured_offers,
    			 SUM(DISTINCT urate.rating) / COUNT(DISTINCT urate.id) as rating_user,
    			 u.block 
    			 ".
    			" FROM #__users AS u ".
    			" LEFT JOIN #__bid_users AS b ON u.id=b.userid ".
    			" LEFT JOIN #__bid_country AS c ON b.country=c.id ".
    			
    			" LEFT JOIN #__bid_rate AS urate ON u.id=urate.user_rated ".
    			
    			" LEFT JOIN #__bids AS btbl ON u.id=btbl.userid and btbl.accept=1 ".
    			
    			" LEFT JOIN #__bid_auctions AS auctactive ON u.id= auctactive.userid and auctactive.close_offer<>1  ".
    			" LEFT JOIN #__bid_auctions AS auctclosed ON u.id= auctclosed.userid and auctclosed.close_offer=1  ".
    			" LEFT JOIN #__bid_auctions AS auctfeatured ON u.id= auctfeatured.userid and auctfeatured.featured<>'none'  ".
    			
				$where.
				
				"GROUP BY u.id ".$order;
				
		$db->setQuery($query, $pagination->limitstart, $pagination->limit);
		$rows = $db->loadObjectList();
		
		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;
		$lists['search']		= $search;

		HTML_admin_auctions::listUsers($rows, $pagination, $search,$lists,$filter_orderid);
	}
	
	function detailuser(){
		
		$app	= JFactory::getApplication();
		$db = & JFactory::getDBO();
		
		$cid = JRequest::getVar("cid",array());
		$id = JRequest::getInt("id");

		
		if(!$id){
			if (!$id) $id=$cid[0];			
		}

		$limit		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart	= $app->getUserStateFromRequest($context.'limitstart', 'limitstart', 0, 'int');
		// In case limit has been changed, adjust limitstart accordingly
		$limitstart = ( $limit != 0 ? (floor($limitstart / $limit) * $limit) : 0 );
	
		$user = new JAuctionUsers($db);
		if (!$user->getUserDetails($id) && (CB_DETECT!=1)){
			echo "<script>alert('".bid_err_user_does_not_exist."');</script>";
			echo "<script>history.go(-1);</script>";
			return;
		}
		$user->userid=$id;
		$lists=array();
		
		$db->setQuery("SELECT 
				rating,count(*) as nr,
				auction_id, a.title as auction,
				voter, u.username 
			FROM #__bid_rate 
			LEFT JOIN #__bid_auctions AS a on auction_id = a.id 
			LEFT JOIN #__users AS u on voter = u.id 
			WHERE user_rated='$id' 
			GROUP BY rating order by rating
		");
		$lists['ratings'] = $db->loadObjectList();
		
		$db->setQuery("
			SELECT 
				m.id,
				id_offer, a.title as auction,
				u.id as from_id, u.username as fromuser,
				u2.id as to_id, u2.username as touser,
				m.modified,
				m.message,
				m.published
				
			FROM #__bid_messages as m 
			LEFT JOIN #__bid_auctions AS a on m.id_offer = a.id 
			LEFT JOIN #__users AS u on m.userid1 = u.id 
			LEFT JOIN #__users AS u2 on m.userid2 = u2.id 
			WHERE userid1='$id' or userid2 = '$id' 
		");
		$lists['messages'] = $db->loadObjectList();
	
		$query="select count(*) as nr_auctions,max(modified) as last_auction_date from #__bid_auctions where userid=$id";
		$db->setQuery($query);
		$res=$db->loadAssocList();
		$lists['nr_auctions']=$res[0]['nr_auctions'];
		$lists['last_auction_placed']=$res[0]['last_auction_date'];
	
		$query="select count(*) as nr_bids_won from #__bids where userid=$id and accept=1 ";
		$db->setQuery($query);
		$res=$db->loadAssocList();
		$lists['nr_won_bids']=$res[0]['nr_bids_won'];
	
		$query="select count(*) as nr_bids, max(modified) as last_date from #__bids where userid=$id ";
		$db->setQuery($query);
		$res=$db->loadAssocList();
		$lists['nr_bids']=$res[0]['nr_bids'];
		$lists['last_bid_placed']=$res[0]['last_date'];
		
		
		$query="select c.*, a.title, a.BIN_price, cr.name as currency
		FROM #__bids as c  
		LEFT join #__bid_auctions as a on c.id_offer = a.id
		LEFT join #__bid_currency as cr on a.currency = cr.id
		WHERE c.userid = $id";
		$db->setQuery($query);
		$lists['bids'] = $db->loadObjectList();
	
		$query="select * from #__bid_credits c
					where userid = $id";
		$db->setQuery($query);
		$lists['credits'] = $db->loadObjectList();
		
		$query="select d.name, c.status 
				  from #__bid_paylog c 
				  left join #__bid_packages d on d.id = c.var_value1 
				  where userid = $id and itemname='packages' 
				  ";
		$db->setQuery($query);
		$lists['packages'] = $db->loadObjectList();
		
	    if( !CB_DETECT ){
			$Fi = & FactoryFieldsFront::getInstance();
	    	$lists["user_fields"] = $Fi->getCustomFields("user_profile", $id);
	    }	
		HTML_admin_auctions::detailUser( $user, $lists, $ratings,$pagination);
	}
	
	function blockuser(){
		
		$database = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$cid = JRequest::getVar("cid",array());
		
		if (count( $cid ) < 1 && (!$cid)) {
			FactoryLayer::redirect( 'index.php?option=com_bids&task=users', "Select an user!");
		}
		
		if (is_array($cid))	
			$cids = implode( ',', $cid );
		else 
			$cids=$cid;
		
		$query = "UPDATE #__users"
		. "\n SET block = '1' "
		. "\n WHERE id IN ( $cids )"
		;
		$database->setQuery( $query );
		$database->query();
		/*
		echo "<Pre>";
		var_dump($database);
		exit;
		*/
		
		
		/*
		if (count( $cid ) == 1) {
			$row = new JTableUser($database );
			$row->checkin( $cid[0] );
		}
		*/
		
		FactoryLayer::redirect( 'index.php?option=com_bids&task=users', "User Blocked!");
		
	}

	function unblockuser(){
		
		$database = & JFactory::getDBO();
		$my = & JFactory::getUser();
		$cid = JRequest::getVar("cid",array());
		
		if (count( $cid ) < 1 && (!$cid)) {
			FactoryLayer::redirect( 'index.php?option=com_bids&task=users', "Select an user!");
		}
		
		if (is_array($cid))	
			$cids = implode( ',', $cid );
		else 
			$cids=$cid;
		
		$query = "UPDATE #__users"
		. "\n SET block = '' "
		. "\n WHERE id IN ( $cids )"
		;
		$database->setQuery( $query );
		$database->query();
		/*
		echo "<Pre>";
		var_dump($database);
		exit;
		*/
		
		
		/*
		if (count( $cid ) == 1) {
			$row = new JTableUser($database );
			$row->checkin( $cid[0] );
		}
		*/
		
		FactoryLayer::redirect( 'index.php?option=com_bids&task=users', "User unblocked!");
		
	}
	
	function toggleverify()
	{
		
		$app	= JFactory::getApplication();
		$db = & JFactory::getDBO();
		
		$cid = JRequest::getVar("cid",array());
		
		if (count( $cid ) < 1 && (!$cid)) {
			echo "<script> alert('Select a user'); window.history.go(-1);</script>\n";
			exit;
		}
		if (is_array($cid))	$cids = implode( ',', $cid );
		else $cids=$cid;
	
	    if (CB_DETECT){
	        $db->setQuery("update #__comprofiler set `".$cb_fieldmap['verified']."`=0 where `".$cb_fieldmap['verified']."` is null");
	        $db->query();
			$db->setQuery("update #__comprofiler set `".$cb_fieldmap['verified']."`=1-`".$cb_fieldmap['verified']."` where user_id in ($cids)");
	    }else{
			$db->setQuery("update #__bid_users set `verified`=0 where `verified` is null");
			$db->query();
			$db->setQuery("update #__bid_users set `verified`=1-`verified` where userid in ($cids)");
	    }
	    $db->query();
		FactoryLayer::redirect('index.php?option=com_bids&task=users',bid_succes);
	}

	function togglepowerseller()
	{
		
		$app	= JFactory::getApplication();
		$db = & JFactory::getDBO();
		
		$cid = JRequest::getVar("cid",array());
		
		if (count( $cid ) < 1 && (!$cid)) {
			echo "<script> alert('Select a user'); window.history.go(-1);</script>\n";
			exit;
		}
		if (is_array($cid))	$cids = implode( ',', $cid );
		else $cids=$cid;
	
	    if (CB_DETECT){
	        $db->setQuery("update #__comprofiler set `".$cb_fieldmap['powerseller']."`=0 where `".$cb_fieldmap['powerseller']."` is null");
	        $db->query();
			$db->setQuery("update #__comprofiler set `".$cb_fieldmap['powerseller']."`=1-`".$cb_fieldmap['powerseller']."` where user_id in ($cids)");
	    }else{
			$db->setQuery("update #__bid_users set `powerseller`=0 where `powerseller` is null");
			$db->query();
			$db->setQuery("update #__bid_users set `powerseller`=1-`powerseller` where userid in ($cids)");
	    }
	    $db->query();
		FactoryLayer::redirect('index.php?option=com_bids&task=users',bid_succes);
	}
	
	function toggleBidder()
	{
		$app	= JFactory::getApplication();
		$db = & JFactory::getDBO();
		
		$cid = JRequest::getVar("cid",array());
		
		if (count( $cid ) < 1 && (!$cid)) {
			echo "<script> alert('Select a user'); window.history.go(-1);</script>\n";
			exit;
		}
		if (is_array($cid))	$cids = implode( ',', $cid );
		else $cids=$cid;
	
		if (bid_opt_enable_acl && bid_opt_acl_type=='profile'){
		    if (CB_DETECT){
		       $db->setQuery("update #__comprofiler set `".$cb_fieldmap['isBidder']."`=1-coalesce(`".$cb_fieldmap['isBidder']."`,0) where user_id in ($cids)");
		    }else{
		       $db->setQuery("update #__bid_users set `isBidder`=1-`isBidder` where userid in ($cids)");
		    }
	        $db->query();
		}else 
			FactoryLayer::redirect('index.php?option=com_bids&task=users',"ACL on profiles is not enabled! <h3>Enable <a href='index.php?option=com_bids&task=settings'>&raquo; here!</a></h3>");
		
		FactoryLayer::redirect('index.php?option=com_bids&task=users',bid_succes);
	}
	
	function toggleSeller()
	{
		$app	= JFactory::getApplication();
		$db = & JFactory::getDBO();
		
		$cid = JRequest::getVar("cid",array());
		
		if (count( $cid ) < 1 && (!$cid)) {
			echo "<script> alert('Select a user'); window.history.go(-1);</script>\n";
			exit;
		}
		if (is_array($cid))	$cids = implode( ',', $cid );
		else $cids=$cid;
	
		if (bid_opt_enable_acl && bid_opt_acl_type=='profile'){
		    if (CB_DETECT){
		       $db->setQuery("update #__comprofiler set `".$cb_fieldmap['isSeller']."`=1-coalesce(`".$cb_fieldmap['isSeller']."`,0) where user_id in ($cids)");
		    }else{
		       $db->setQuery("update #__bid_users set `isSeller`=1-`isSeller` where userid in ($cids)");
		    }
	        $db->query();
		}
		
		FactoryLayer::redirect('index.php?option=com_bids&task=users',bid_succes);
	}
	
	function offers(){
		
		$app	= & JFactory::getApplication();
		$db	= & JFactory::getDBO();
		$my 	= & JFactory::getUser();
		
		$where = array();

		$context			= 'com_bids.jbidsdminview.offers';
		$filter_order		= $app->getUserStateFromRequest( $context.'filter_order', 'filter_order', '', 'cmd' );
		$filter_order_Dir	= $app->getUserStateFromRequest( $context.'filter_order_Dir', 'filter_order_Dir', '', 'word' );
		
		$filter_authorid	= $app->getUserStateFromRequest( $context.'filter_authorid', 'filter_authorid',	0,	'int' );
		
		$filter_bidtype		= $app->getUserStateFromRequest( $context.'filter_bidtype', 'filter_bidtype',	0,	'int' );
		
		$search				= $app->getUserStateFromRequest( $context.'filter',	'filter','','string' );
		$search				= JString::strtolower($search);

		$limit				= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart			= $app->getUserStateFromRequest($context.'limitstart', 'limitstart', 0, 'int');

		// In case limit has been changed, adjust limitstart accordingly
		$limitstart 		= ( $limit != 0 ? (floor($limitstart / $limit) * $limit) : 0 );


		if (!$filter_order) {
			$filter_order = 'a.title';
		}
		
		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;
		
		$order = ' ORDER BY '. $filter_order .' '. $filter_order_Dir .'';

		if($search)
			$where[] = " a.title LIKE '%$search%' ";
			
		if($filter_authorid!=0){
			$where[] = " a.userid = '$filter_authorid%' ";
		}
		
		switch($filter_bidtype) {
			case 1 :
			$where[]=" a.published=1 and close_offer=0 and  close_by_admin=0 ";
			break;
			case 2 :
			$where[]=" (close_offer=1 or close_by_admin=1) "; //avoid showing closed by admin
			break;
	
			case 3 :
			$where[]=" a.published=0 and close_offer=0 and  close_by_admin=0";
			break;
			
			case 4 :
			$where[]=" close_by_admin=1 ";
			break;
		}

		// Build the where clause of the content record query
		$where = (count($where) ? ' WHERE '.implode(' AND ', $where) : '');

		// Get the total number of records
		$query = 'SELECT COUNT(*)' .
				' FROM #__bid_auctions AS a' .
				' LEFT JOIN #__bid_categories AS cc ON cc.id = a.cat ' .
				$where;
		$db->setQuery($query);
		$total = $db->loadResult();

		// Create the pagination object
		jimport('joomla.html.pagination');
		$pagination = new JPagination($total, $limitstart, $limit);

		// Get the auctions
		$query = 'SELECT a.*, cc.catname AS name,`cur`.`name` as currency_name,  '.PHP_EOL.
				' u.name AS username, count(bids.id) as nr_bids, max(bids.bid_price)as min_bid , ' .PHP_EOL.
				' count(DISTINCT bids.userid) as nr_bidders '.PHP_EOL.
				' , if(a.picture<>"",COUNT(DISTINCT pix.id )+1, COUNT(DISTINCT pix.id ) )  as nr_pix '.PHP_EOL.
				', 1-MIN(msg.wasread) as newmessages '.PHP_EOL.
				' FROM #__bid_auctions AS a ' .PHP_EOL.
				' LEFT JOIN #__bid_categories AS cc ON cc.id = a.cat ' .PHP_EOL.
				' LEFT JOIN #__bid_currency AS cur ON `cur`.`id`=`a`.`currency` ' .PHP_EOL.
				' LEFT JOIN #__users AS u ON u.id = a.userid '.PHP_EOL  .
				' LEFT JOIN #__bid_pictures AS pix ON pix.id_offer = a.id ' .PHP_EOL.
				' LEFT JOIN `#__bids` AS bids ON `bids`.`id_offer`=`a`.`id` '.PHP_EOL.
				' LEFT JOIN #__bid_messages AS msg ON msg.id_offer = a.id AND msg.userid2 = \''.$my->id .'\'' .PHP_EOL.
				$where.
				' GROUP BY a.id '.PHP_EOL.
				$order;
		$db->setQuery($query, $pagination->limitstart, $pagination->limit);
		//echo nl2br($db->getQuery());
		//exit;
		$rows = $db->loadObjectList();
		
		$lists["filter_bidtype"] = $filter_bidtype;
		$lists["search"] = $search;

		HTML_admin_auctions::showAuctions( $rows, $pagination, $lists );
	}

	function editoffer() {
	
		$database = &JFactory::getDBO();
		$my = &JFactory::getUser();
		
		$cid	= JRequest::getVar( 'cid', array(), '', 'array' );
			
		$id = intVal(JRequest::getVar("id"));
		if (!$id) $id=$cid[0];
		
		if(!$id)
			FactoryLayer::redirect("index.php?option=com_bids&task=offers","Select an auction!");
	
		$limit 		=JRequest::getInt('limit',  20);
		$limitstart = JRequest::getInt('limitstart', 0 ) ;
	
		$row = new JAuctions( $database );
		// load the row from the db table
		$row->load( $id );
	
		$lists = array();
	
		$user = new JAuctionUsers($database);
		$user->getUserDetails($row->userid);
		
		if (!$user->username) {
			
			$user = &JFactory::getUser($row->userid);
		}
		
		$row->userdetails = $user;
	
		$query = "update #__bid_messages set wasread=1 where userid2='$my->id' and id_offer='$id'";
		$database->setQuery($query);
		$database->query();
		
		$query = "update #__bid_auctions set newmessages=0 where id='$id'";
		$database->setQuery($query);
		$database->query();
	
		$lists['category'] =$row->GetCategory();
		$lists['category_list'] = BidsHTML::selectCategory("cat", array("select"=>$row->cat, "include_root"=>true ));

		$lists['currency'] = $row->GetCurrency();
		$lists['payment_method'] = $row->GetPaymentMethod();
		
		$SO = new JAuctionShipZones($database);
		$lists["shipment_prices"] = $SO->getPriceList($row->id);
		
	    $feat[]=JHTML::_('select.option', 'none', bid_none);
	    $feat[]=JHTML::_('select.option', 'gold', bid_payment_featured_gold);
	    $feat[]=JHTML::_('select.option', 'silver', bid_payment_featured_silver);
	    $feat[]=JHTML::_('select.option', 'bronze', bid_payment_featured_bronze);
	
		$lists['featured']=JHTML::_('select.genericlist',$feat,'featured','class="inputbox" id="featured" style="width:120px;"','value', 'text',$row->featured);
	
		HTML_admin_auctions::editAuction( $row, $lists,$bids,  $pageNav, $user,$adminMessages);
	}
	
	function closed(){
		
		$database = & JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(), '', 'array' );
		if(count($cid)==0)
			FactoryLayer::redirect("index.php?option=com_bids&task=offers","Select one or more auctions to close!");
		
		$cids = implode( ',', $cid );
		
		// closed
		$close_by_admin=1;
		$publish=0;
		
		$query = "UPDATE #__bid_auctions"
		. "\n SET close_by_admin = ". intval( $close_by_admin ).", closed_date = '".date('Y-m-d',time())."',published=".intval($publish)
		. "\n WHERE id IN ( $cids )"
		;
		$database->setQuery( $query );
		$database->query();
		
		FactoryLayer::redirect("index.php?option=com_bids&task=offers",count($cid)." auctions closed!");
	}
	
	function opened(){
		
	    $database = & JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(), '', 'array' );
		if(count($cid)==0)
			FactoryLayer::redirect("index.php?option=com_bids&task=offers","Select one or more auctions to open!");
		
		$cids = implode( ',', $cid );
		
		// open
		$close_by_admin=0;
		$publish=1;
		
		
		$query = "UPDATE #__bid_auctions"
		. "\n SET close_by_admin = ". intval( $close_by_admin ).", closed_date = '".date('Y-m-d',time())."',published=".intval($publish)
		. "\n WHERE id IN ( $cids )"
		;
		$database->setQuery( $query );
		$database->query();
		FactoryLayer::redirect("index.php?option=com_bids&task=offers",count($cid)." auctions opened!");
	}

	function resethits()
	{
	    $database = & JFactory::getDBO();
	    
		$cid	= JRequest::getVar( 'cid', array(), '', 'array' );
		$id=$cid[0];
	
        $database->setQuery("update #__bid_auctions set hits='0' where id='$id'");
        $database->query();
	    
		FactoryLayer::redirect( JURI::root()."/administrator/index.php?option=com_bids&task=editoffer&id=$id",bid_succes);
	
	}
	
	function category()
	{
	    $database = & JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(), '', 'array' );
		$id = FactoryLayer::getRequest($_REQUEST,"id");
	
	    $category=JRequest::getInt('category',0);
	
	    if (!$id) $id=$cid[0];
	
	    if ($category>=0){
	        $database->setQuery("update #__bid_auctions set cat='$category' where id='$id'");
	        $database->query();
	    }
	
	    
		FactoryLayer::redirect( JURI::root()."/administrator/index.php?option=com_bids&task=editoffer&id=$id",bid_succes);
	
	}
	
	function set_featured()
	{
	    $database = & JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(), '', 'array' );
		$id = FactoryLayer::getRequest($_REQUEST,"id");
	
	    $feat=JRequest::getString('featured','');
	
	    if (!$id) $id=$cid[0];
	    if ($feat){
	        $database->setQuery("update #__bid_auctions set featured='$feat' where id='$id'");
	        $database->query();
	    }
	
		FactoryLayer::redirect( JURI::root()."/administrator/index.php?option=com_bids&task=editoffer&id=$id",bid_succes);
	}
	
	function increment_list()
	{
		$database = & JFactory::getDBO();
		$increment = new JAuctionBidIncrement($database);
		$increment_list = $increment->getList();
		JHTML::_("behavior.modal");
		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS."tmpl".DS."increment".DS."increment_list.php");
	}
	
	function increment_edit()
	{
		$database = & JFactory::getDBO();
		$id = FactoryLayer::getRequest($_REQUEST,"id");
		
		ob_end_clean();
		$increment = new JAuctionBidIncrement($database);
		$increment->load($id);
		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS."tmpl".DS."increment".DS."increment_edit.php");
		jexit();
	
	}
	
	function increment_save()
	{
		$database = & JFactory::getDBO();
		$id = FactoryLayer::getRequest($_REQUEST,"id");
		$increment = new JAuctionBidIncrement($database);
		$increment->bind($_POST);
		$increment->store();
		
		FactoryLayer::redirect( JURI::root()."/administrator/index.php?option=com_bids&task=increment_list", bid_item_saved);
	}
	
	function increment_del(){
		
		$database = & JFactory::getDBO();
		$id = FactoryLayer::getRequest($_REQUEST,"id");
		$increment = new JAuctionBidIncrement($database);
		$increment->delete($id);
		FactoryLayer::redirect( JURI::root()."/administrator/index.php?option=com_bids&task=increment_list", bid_item_deleted );
		
	}
	
	function dashbord(){
		
		HTML_admin_auctions::showDashbord($lists);
	}
	
	function settings( ) {
		global $gallery_list;
		
		$database = & JFactory::getDBO();
		$acl = & JFactory::getACL();
	
		$lists=array();
	
		$date_format[] = JHTML::_('select.option', 'Y-m-d', 'Y-m-d');
		$date_format[] = JHTML::_('select.option', 'Y-d-m', 'Y-d-m');
		$date_format[] = JHTML::_('select.option', 'm/d/Y', 'm/d/Y');
		$date_format[] = JHTML::_('select.option', 'd/m/Y', 'd/m/Y');
		$date_format[] = JHTML::_('select.option', 'D, F d Y', 'D, F d Y');
		$lists['date_format'] = JHTML::_('select.genericlist',$date_format,'date_format',"id='format' onChange='showDateInFormat(this.value);' " ,'value', 'text',bid_opt_date_format);
	
		$time_format[] = JHTML::_('select.option', 'H:i', 'H:i');
		$time_format[] = JHTML::_('select.option', 'h:iA', 'h:iA');
		$lists['date_time_format'] = JHTML::_('select.genericlist',$time_format,'bid_opt_date_time_format',"id='formatt' onChange='showTimeInFormat(this.value);'",'value', 'text',bid_opt_date_time_format);
	
		$database->setQuery("select content from #__bid_mails where mail_type='terms_and_conditions' ");
		$lists['terms']= $database->loadResult();
	
		$lists['proxy'] = JHTML::_('select.booleanlist', 'proxy','',bid_opt_allow_proxy,$yes=_CMN_YES,$no=_CMN_NO);
	
		if(CB_DETECT){
			$lists['uCB'] = JHTML::_('select.booleanlist',  'uCB', '', bid_opt_onlyCB );
		}else {
			$lists['uCB'] = bid_CB_not_found;
		}
		$lists['icsv'] = JHTML::_('select.booleanlist',  'icsv', '', bid_opt_allow_import );
	
		$lists['allow_messages'] = JHTML::_('select.booleanlist', 'allow_messages','',bid_opt_allow_messages,$yes=_CMN_YES,$no=_CMN_NO);
	
		$nr_items[] = JHTML::_('select.option', '10', '10');
		$nr_items[] = JHTML::_('select.option', '15', '15');
		$nr_items[] = JHTML::_('select.option', '20', '20');
		$nr_items[] = JHTML::_('select.option', '25', '25');
		$nr_items[] = JHTML::_('select.option', '30', '40');
		$nr_items[] = JHTML::_('select.option', '40', '40');
		$nr_items[] = JHTML::_('select.option', '50', '50');
		$nr_items[] = JHTML::_('select.option', '100', '100');
		$lists['bid_opt_nr_items_per_page'] = JHTML::_('select.genericlist',$nr_items,'items_per_page',"",'value', 'text',bid_opt_nr_items_per_page);
	
		$query = "SELECT * FROM #__bid_currency";
		$database->setQuery( $query );
		$lists['currency']=$database->loadObjectList();
	
		$query = "SELECT * FROM #__bid_payment";
		$database->setQuery( $query );
		$lists['payment']=$database->loadObjectList();
	
		$feedtype[] = JHTML::_('select.option', 'RSS2.0', 'RSS2.0');
		$feedtype[] = JHTML::_('select.option', 'RSS1.0', 'RSS1.0');
		$feedtype[] = JHTML::_('select.option', 'RSS0.91', 'RSS0.91');
		$feedtype[] = JHTML::_('select.option', 'PIE0.1', 'PIE0.1');
		$feedtype[] = JHTML::_('select.option', 'MBOX', 'MBOX');
		$feedtype[] = JHTML::_('select.option', 'OPML', 'OPML');
		$feedtype[] = JHTML::_('select.option', 'ATOM', 'ATOM');
		$feedtype[] = JHTML::_('select.option', 'ATOM0.3', 'ATOM0.3');
		$lists['feedtype'] = JHTML::_('select.genericlist',$feedtype,'rss_feedtype',"",'value', 'text',bid_opt_RSS_feedtype);
	
	
		$acl_type[] = JHTML::_('select.option', 'groups', bid_acltype_groups);
		$acl_type[] = JHTML::_('select.option', 'profile', bid_acltype_profile);
		$lists['acl_type'] = JHTML::_('select.genericlist',$acl_type,'acl_type'," onchange='change_acl_type();'",'value', 'text',bid_opt_acl_type);
	
		$my_groups = $acl->get_object_groups( 'users', 0, 'ARO' );
		if (is_array( $my_groups ) && count( $my_groups ) > 0) {
			$ex_groups = $acl->get_group_children( $my_groups[0], 'ARO', 'RECURSE' );
		} else {
			$ex_groups = array();
		}
	
		$gtree = $acl->get_group_children_tree( null, 'USERS', false );
	
		// remove users 'above' me
		$i = 0;
		while ($i < count( $gtree )) {
			if (in_array( $gtree[$i]->value, $ex_groups )) {
				array_splice( $gtree, $i, 1 );
			} else {
				$i++;
			}
		}
	
		$lists['group_bidder'] 		= JHTML::_('select.genericlist', $gtree, 'bidder_group', 'size="1"', 'value', 'text', bid_opt_acl_bidder );
		$lists['group_seller'] 		= JHTML::_('select.genericlist', $gtree, 'seller_group', 'size="1"', 'value', 'text', bid_opt_acl_seller );
		
	    foreach($gallery_list as $key=>$value)
	    {
	    	$galleries_plugins[] = JHTML::_('select.option', $key, $value);
	    }
		$lists['gallery_plugin'] = JHTML::_('select.genericlist',$galleries_plugins,'gallery_plugin',"" ,'value', 'text',bid_opt_gallery);
		
		$lists['min_increase_select'] = JHTML::_('select.booleanlist', 'min_increase_select','',bid_opt_min_increase_select,$yes=_CMN_YES,$no=_CMN_NO);
		
		// since - 1.3.8
		$lists['bid_opt_allow_retract'] = JHTML::_('select.booleanlist', 'bid_opt_allow_retract','',bid_opt_allow_retract,$yes=_CMN_YES,$no=_CMN_NO);
		$lists['bid_opt_allow_guest_messaging'] = JHTML::_('select.booleanlist', 'bid_opt_allow_guest_messaging','',bid_opt_allow_guest_messaging,$yes=_CMN_YES,$no=_CMN_NO);
		$lists['bid_opt_inner_categories'] = JHTML::_('select.booleanlist', 'bid_opt_inner_categories','',bid_opt_inner_categories,$yes=_CMN_YES,$no=_CMN_NO);
		$lists['bid_opt_enable_captcha'] = JHTML::_('select.booleanlist', 'bid_opt_enable_captcha','',bid_opt_enable_captcha,$yes=_CMN_YES,$no=_CMN_NO);
		
	
	
		// [+] since - 1.3.9
		$lists['bid_opt_preferential_cats'] = JHTML::_('select.booleanlist', 'bid_opt_preferential_cats','',bid_opt_preferential_cats,$yes=_CMN_YES,$no=_CMN_NO);
		$js_event = "if(this.value=='1') document.getElementById('bid_opt_commission_cats').disabled='disabled'; else  document.getElementById('bid_opt_commission_cats').disabled='';"; 
		$js = " onclick=\"$js_event\" ";
		$lists['bid_opt_only_payperlist_cats'] = JHTML::_('select.booleanlist', 'bid_opt_only_payperlist_cats',"$js",bid_opt_only_payperlist_cats,$yes=_CMN_YES,$no=_CMN_NO);
		$lists['bid_opt_various_commissions'] = JHTML::_('select.booleanlist', 'bid_opt_various_commissions',"",bid_opt_various_commissions,$yes=_CMN_YES,$no=_CMN_NO);
	
		$lists['bid_opt_uddeim'] = JHTML::_('select.booleanlist', 'bid_opt_uddeim',(UDDEIM_DETECT)?"":"disabled",bid_opt_uddeim,$yes=_CMN_YES,$no=_CMN_NO);
		$lists['bid_opt_auto_extent'] = JHTML::_('select.booleanlist', 'bid_opt_auto_extent',"onclick='change_autoextend(this)'",bid_opt_auto_extent,$yes=_CMN_YES,$no=_CMN_NO);
		
		$lists['payment_select_mode'] = JHTML::_('select.booleanlist', 'bid_opt_payment_select_mode','',bid_opt_payment_select_mode,$yes='Single option',$no='Multiple options');
		
		$lists['bid_multiple_shipping'] = JHTML::_('select.booleanlist', 'bid_opt_multiple_shipping','',bid_opt_multiple_shipping,$yes=_CMN_YES,$no=_CMN_NO);
	
		$lists['bid_opt_allow_user_settings'] = JHTML::_('select.booleanlist', 'bid_opt_allow_user_settings', '', bid_opt_allow_user_settings, $yes=_CMN_YES,$no=_CMN_NO);
		
		$lists['bid_opt_range_increment'] = JHTML::_('select.booleanlist', 'bid_opt_range_increment', ' ', bid_opt_range_increment, $yes = _CMN_YES, $no = _CMN_NO );
	
		$lists['bid_opt_ilustration_band'] = JHTML::_('select.booleanlist', 'bid_opt_ilustration_band', "", bid_opt_ilustration_band, $yes = _CMN_YES, $no = _CMN_NO );
	
	
		$lists['bid_opt_enable_date'] = JHTML::_('select.booleanlist', 'bid_opt_enable_date', "onclick='change_date_settings(this)'", bid_opt_enable_date, $yes = _CMN_YES, $no = _CMN_NO );
		
		$lists['bid_opt_global_enable_bin'] = JHTML::_('select.booleanlist', 'bid_opt_global_enable_bin', '', bid_opt_global_enable_bin, $yes = _CMN_YES, $no = _CMN_NO );
	
		$lists['bid_opt_global_enable_reserve_price'] = JHTML::_('select.booleanlist', 'bid_opt_global_enable_reserve_price', '', bid_opt_global_enable_reserve_price, $yes = _CMN_YES, $no = _CMN_NO );
	
		$lists['bid_opt_global_enable_private'] = JHTML::_('select.booleanlist', 'bid_opt_global_enable_private', '', bid_opt_global_enable_private, $yes = _CMN_YES, $no = _CMN_NO );
	
		$lists['bid_opt_enable_bin_only'] = JHTML::_('select.booleanlist', 'bid_opt_enable_bin_only', '', bid_opt_enable_bin_only, $yes = _CMN_YES, $no = _CMN_NO );
	
		$lists['bid_opt_show_parameter_tab'] = JHTML::_('select.booleanlist', 'bid_opt_show_parameter_tab', '', bid_opt_show_parameter_tab, $yes = bid_show, $no = bid_hide );
		
		
		$js = " onclick = 'var sel = this.value; curSelect(sel);' ";
		$lists['bin_opt_price_suggestion'] = JHTML::_('select.booleanlist', 'bin_opt_price_suggestion', "$js", bin_opt_price_suggestion, $yes = _CMN_YES, $no = _CMN_NO );
		
		$disabled = ' disabled="disabled" ';
		if(bin_opt_price_suggestion)
			$disabled = ' ';
		if(defined("bin_opt_limit_suggestions") && bin_opt_limit_suggestions!="")
			$var = bin_opt_limit_suggestions;
		else
			$var= "";		
		$lists['bin_opt_limit_suggestions'] = '<input type="text" id="bin_opt_limit_suggestions" name="bin_opt_limit_suggestions" value="'.$var.'" '.$disabled.' />';
		$lists['bid_opt_quantity_enabled'] = JHTML::_('select.booleanlist', 'bid_opt_quantity_enabled', "", defined("bid_opt_quantity_enabled")?bid_opt_quantity_enabled:0, $yes = _CMN_YES, $no = _CMN_NO );
		$lists['bid_opt_category_page'] = JHTML::_('select.booleanlist', 'bid_opt_category_page', "", defined("bid_opt_category_page")?bid_opt_category_page:0, $yes = _CMN_YES, $no = _CMN_NO );
		
		$lists['bid_opt_automatic_auction_select'] = JHTML::_('select.booleanlist', 'bid_opt_automatic_auction_select', "onchange='var cucu=document.getElementById(\"automatic_auction_default_option\"); if(this.value==0) cucu.style.display=\"\"; else cucu.style.display=\"none\";' ", defined("bid_opt_automatic_auction_select")?bid_opt_automatic_auction_select:1, $yes = _CMN_YES, $no = _CMN_NO );
		$lists['bid_opt_automatic_auction_default'] = JHTML::_('select.booleanlist', 'bid_opt_automatic_auction_default', "", defined("bid_opt_automatic_auction_default")?bid_opt_automatic_auction_default:0, $yes = bid_enabled, $no = bid_disabled );
		

		$config = & JFactory::getConfig();
		$offset = $config->getValue("offset");
		
		if(defined("bid_opt_component_offset") && bid_opt_component_offset !="" )
			$sel_offset = bid_opt_component_offset;
		else
			$sel_offset = $offset;
		
		// LOCALE SETTINGS
		$timeoffset = array (
			JHTML::_('select.option', -12, JText::_('(UTC -12:00) International Date Line West')),
			JHTML::_('select.option', -11, JText::_('(UTC -11:00) Midway Island, Samoa')),
			JHTML::_('select.option', -10, JText::_('(UTC -10:00) Hawaii')),
			JHTML::_('select.option', -9.5, JText::_('(UTC -09:30) Taiohae, Marquesas Islands')),
			JHTML::_('select.option', -9, JText::_('(UTC -09:00) Alaska')),
			JHTML::_('select.option', -8, JText::_('(UTC -08:00) Pacific Time (US &amp; Canada)')),
			JHTML::_('select.option', -7, JText::_('(UTC -07:00) Mountain Time (US &amp; Canada)')),
			JHTML::_('select.option', -6, JText::_('(UTC -06:00) Central Time (US &amp; Canada), Mexico City')),
			JHTML::_('select.option', -5, JText::_('(UTC -05:00) Eastern Time (US &amp; Canada), Bogota, Lima')),
			JHTML::_('select.option', -4.5, JText::_('(UTC -04:30) Venezuela')),
			JHTML::_('select.option', -4, JText::_('(UTC -04:00) Atlantic Time (Canada), Caracas, La Paz')),
			JHTML::_('select.option', -3.5, JText::_('(UTC -03:30) St. John\'s, Newfoundland, Labrador')),
			JHTML::_('select.option', -3, JText::_('(UTC -03:00) Brazil, Buenos Aires, Georgetown')),
			JHTML::_('select.option', -2, JText::_('(UTC -02:00) Mid-Atlantic')),
			JHTML::_('select.option', -1, JText::_('(UTC -01:00) Azores, Cape Verde Islands')),
			JHTML::_('select.option', 0, JText::_('(UTC 00:00) Western Europe Time, London, Lisbon, Casablanca')),
			JHTML::_('select.option', 1, JText::_('(UTC +01:00) Amsterdam, Berlin, Brussels, Copenhagen, Madrid, Paris')),
			JHTML::_('select.option', 2, JText::_('(UTC +02:00) Istanbul, Jerusalem, Kaliningrad, South Africa')),
			JHTML::_('select.option', 3, JText::_('(UTC +03:00) Baghdad, Riyadh, Moscow, St. Petersburg')),
			JHTML::_('select.option', 3.5, JText::_('(UTC +03:30) Tehran')),
			JHTML::_('select.option', 4, JText::_('(UTC +04:00) Abu Dhabi, Muscat, Baku, Tbilisi')),
			JHTML::_('select.option', 4.5, JText::_('(UTC +04:30) Kabul')),
			JHTML::_('select.option', 5, JText::_('(UTC +05:00) Ekaterinburg, Islamabad, Karachi, Tashkent')),
			JHTML::_('select.option', 5.5, JText::_('(UTC +05:30) Bombay, Calcutta, Madras, New Delhi, Colombo')),
			JHTML::_('select.option', 5.75, JText::_('(UTC +05:45) Kathmandu')),
			JHTML::_('select.option', 6, JText::_('(UTC +06:00) Almaty, Dhaka')),
			JHTML::_('select.option', 6.30, JText::_('(UTC +06:30) Yagoon')),
			JHTML::_('select.option', 7, JText::_('(UTC +07:00) Bangkok, Hanoi, Jakarta')),
			JHTML::_('select.option', 8, JText::_('(UTC +08:00) Beijing, Perth, Singapore, Hong Kong')),
			JHTML::_('select.option', 8.75, JText::_('(UTC +08:00) Ulaanbaatar, Western Australia')),
			JHTML::_('select.option', 9, JText::_('(UTC +09:00) Tokyo, Seoul, Osaka, Sapporo, Yakutsk')),
			JHTML::_('select.option', 9.5, JText::_('(UTC +09:30) Adelaide, Darwin, Yakutsk')),
			JHTML::_('select.option', 10, JText::_('(UTC +10:00) Eastern Australia, Guam, Vladivostok')),
			JHTML::_('select.option', 10.5, JText::_('(UTC +10:30) Lord Howe Island (Australia)')),
			JHTML::_('select.option', 11, JText::_('(UTC +11:00) Magadan, Solomon Islands, New Caledonia')),
			JHTML::_('select.option', 11.30, JText::_('(UTC +11:30) Norfolk Island')),
			JHTML::_('select.option', 12, JText::_('(UTC +12:00) Auckland, Wellington, Fiji, Kamchatka')),
			JHTML::_('select.option', 12.75, JText::_('(UTC +12:45) Chatham Island')),
			JHTML::_('select.option', 13, JText::_('(UTC +13:00) Tonga')),
			JHTML::_('select.option', 14, JText::_('(UTC +14:00) Kiribati')),);
		$lists['bid_opt_component_offset'] = JHTML::_('select.genericlist',  $timeoffset, 'bid_opt_component_offset', 'class="inputbox" size="1"', 'value', 'text', $sel_offset);

		
		$row = new JConfig();
		$errors 	= array ( -1 => JText::_('System Default'), 0=> JText::_('None'),  E_ERROR | E_WARNING | E_PARSE => JText::_('Simple'), E_ALL=> JText::_('Maximum'));
		$lists["error_reporting"] = $errors[$row->error_reporting];

		
		$lists["local_time"] = JHTML::_('date',  'now', JText::_('DATE_FORMAT_LC2'));
		$lists["gmt_time"] = gmdate('l, d F Y H:i',time());
		
    	
		jimport('joomla.filesystem.folder');
		$cache_files = JFolder::files(JPATH_ROOT.DS."components".DS."com_bids".DS."templates".DS."cache".DS);
		$lists["cache_stats"]["cache_size"] = 0;
		$lists["cache_stats"]["no_files"] = 0;
		$lists["cache_stats"]["last_cached"] = $lists["cache_stats"]["first_cached"] = "nothing cached";
		if($cache_files){
			foreach ($cache_files as $file){
				$lists["cache_stats"]["cache_size"] += filesize(JPATH_ROOT.DS."components".DS."com_bids".DS."templates".DS."cache".DS.$file);
				$lists["cache_files"][] = date("d M Y H:i:s", filemtime(JPATH_ROOT.DS."components".DS."com_bids".DS."templates".DS."cache".DS.$file));
			}
			$lists["cache_stats"]["no_files"] = count($lists["cache_files"]);
			$lists["cache_stats"]["last_cached"] = max($lists["cache_files"]);
			$lists["cache_stats"]["first_cached"] = min($lists["cache_files"]);
		}
		
// Privacy Settings		
		$lists["recaptcha"]["public_key"]="";
		if(defined('bid_opt_recaptcha_public_key'))
			$lists["recaptcha"]["public_key"]= @bid_opt_recaptcha_public_key;

			
		$lists["recaptcha"]["private_key"]="";
		if(defined('bid_opt_recaptcha_private_key'))
			$lists["recaptcha"]["private_key"]=@bid_opt_recaptcha_private_key;
		
		$lists["mailcaptcha"]["public_key"]="";
		if(defined('bid_opt_mailcaptcha_public_key'))
			$lists["mailcaptcha"]["public_key"]= @bid_opt_mailcaptcha_public_key;

			
		$lists["mailcaptcha"]["private_key"]="";
		if(defined('opt_mailcaptcha_private_key'))
			$lists["mailcaptcha"]["private_key"]=@bid_opt_mailcaptcha_private_key;
		

		$captcha_themes = array();
		$captcha_themes[] = JHTML::_('select.option', 'red', 'Red');
		$captcha_themes[] = JHTML::_('select.option', 'white', 'White');
		$captcha_themes[] = JHTML::_('select.option', 'blackglass', 'Blackglass');
		$captcha_themes[] = JHTML::_('select.option', 'clean', 'Clean');
		$lists["recaptcha_themes"] = JHTML::_("select.genericlist", $captcha_themes,'bid_opt_recaptcha_theme',"" ,'value', 'text', defined("bid_opt_recaptcha_theme")?bid_opt_recaptcha_theme:"red");
		
		$lists['bid_opt_enable_antispam_bot'] = JHTML::_("select.booleanlist",'bid_opt_enable_antispam_bot','',defined("bid_opt_enable_antispam_bot")?bid_opt_enable_antispam_bot:1);
		
		
		$antispam_bots = array();
		$antispam_bots[] = JHTML::_('select.option', 'joomla', 'Joomla');
		$antispam_bots[] = JHTML::_('select.option', 'smarty', 'Smarty');
		$antispam_bots[] = JHTML::_('select.option', 'recaptcha', 'reCaptcha');
		$lists['opt_choose_antispam_bot'] = JHTML::_("select.radiolist",$antispam_bots,'bid_opt_choose_antispam_bot',' onchange="toggleMailCaptcha(this.value);"' ,'value', 'text',defined("bid_opt_choose_antispam_bot")?bid_opt_choose_antispam_bot:"joomla");

		$profile_modes = array();
		//$profile_modes[] = JHTML::_('select.option', 'none', 'None');
		$profile_modes[] = JHTML::_('select.option', 'component', 'Component Profile');
		$profile_modes[] = JHTML::_('select.option', 'cb', 'Community Builder');
		$lists['opt_profile_mode'] = JHTML::_("select.genericlist",$profile_modes,'bid_opt_profile_mode','' ,'value', 'text',defined("bid_opt_profile_mode")?bid_opt_profile_mode:"component");
		
		$themes = JFolder::folders(JPATH_ROOT.DS."components".DS."com_bids".DS."templates".DS);
		
		
		if($themes){
			
			$themeOptions = array();
			
			foreach ($themes as $file){
				if($file!="cache" && $file!="configs")
					$themeOptions[] = JHTML::_('select.option', $file, $file);
			}
		}
		
		$lists['TPL_THEME'] = JHTML::_("select.genericlist",$themeOptions,'BID_TPL_THEME','' ,'value', 'text',defined("BID_TPL_THEME")?BID_TPL_THEME:"default");
		
		HTML_admin_auctions::showsettings($lists);
		//HTML_admin_auctions::_showsettings($lists);
	}
	
	function saveSettings() {
	
		require_once(JPATH_ADMINISTRATOR.DS."components/com_bids/admin.bids.class.php");
		$database = & JFactory::getDBO();
	
	// repair space tags
		$database->setQuery("UPDATE #__bid_tags SET tagname= TRIM(tagname)");
		$database->query();
		
		$opts=new Bids_Options($database);
	    if ($opts->saveOptions()) $msg=bid_alt_settings_saved;
	    else $msg=bid_err_file_write_failed;
		FactoryLayer::redirect( "index.php?option=com_bids&task=settings",$msg );
	}

}
?>