<?php
class JTheFactoryAbout extends JObject{
	var $latestversion=null;
	var $downloadlink=null;
	var $newsletter=null;
	var $announcements=null;
	var $releasenotes=null;
	var $_componentname=null;

	function __construct()
    {
        define('DOMIT_INCLUDE_PATH', JPATH_ROOT . DS . 'libraries' . DS . 'domit' . DS );
 		$this->_componentname=APP_EXTENSION;
		return $this->GetInfo();

    }
	function &getInstance()
	{
		static $instances;

		if (!isset( $instances ))
			$instances = new JTheFactoryAbout();

		return $instances;
	}

	function GetInfo(){

		require_once(JPATH_ROOT.DS.'libraries'.DS.'joomla'.DS.'utilities'.DS.'simplexml.php');
		@set_time_limit(60);
		
        $app=&JTheFactoryApp::getInstance();

		$filename=$app->getIniValue('version_root').'/'.$this->_componentname.".xml";
		
		$fileContents =@JTheFactoryHelper::remote_read_url($filename,10);
		
		if (!$fileContents){
			require_once(DOMIT_INCLUDE_PATH . 'php_file_utilities.php');
		
			$fileContents =& php_file_utilities::getDataFromFile($filename, 'r');
		}
		if (!$fileContents) return ;
		
		$xmlparser = new JSimpleXML;
		
		if (!$xmlparser->loadString($fileContents))
		{
			return false;
		}
		$xmldoc = $xmlparser->document;
		
		
		$element = $xmldoc->getElementByPath('/latestversion');
		$this->latestversion = $element ? $element->toString() : '';
		$element = $xmldoc->getElementByPath('/downloadlink');
		$this->downloadlink =$element ? $element->toString() : '';
		
		$element= $xmldoc->getElementByPath('/version_info/newdownloadlink', 1);
		$this->newdownloadlink =$element ? $element->getText() : '';
		$element = $xmldoc->getElementByPath('/newsletter');
		$this->newsletter = $element ? $element->toString() : '';
		$element = $xmldoc->getElementByPath('/announcements');
		$this->announcements = $element ? html_entity_decode($element->toString()) : '';
		$element = $xmldoc->getElementByPath('/notes');
		$this->releasenotes = $element ? html_entity_decode($element->toString()) : '';
		
		$element = $xmldoc->getElementByPath('/build');
		$this->build = $element ? $element->toString() : '';
		
		return true;

	}
	function showAbout()
	{
    	$ver1=explode('.',COMPONENT_VERSION);
    	$ver2=explode('.',$this->latestversion);
    	
    	$isNew=false;
        	for($i=0;$i<count($ver1);$i++){
    	    if (intval($ver1[$i])<intval($ver2[$i])){
    	        $isNew=true;
        	    $ver_info= JText::_('New Version Available!');
    	        break;
    	    }
    	    if (intval($ver1[$i])>=intval($ver2[$i])){
    	        $isNew=false;
          	    $ver_info= JText::_('Your Version is Up to Date');
    	    }
    	}
    	?>
    	    <div id="info_ver">
    	        <span style="color:red"><?php echo $ver_info; ?> </span><br/>
    	    </div>
    	    <div id="info_div" style="border:1px solid black;width:350px;margin-top:20px;">
    	        Your installed version : <?php echo COMPONENT_VERSION; ?><br/>
    	        Latest version available : <?php echo $this->latestversion; ?><br/>
    	    </div>
    	<?php
    	if ($isNew)
    	{?>
    	    <div id="download_div" style="border:1px solid black;width:350px;margin-top:20px;">
    	    <?php echo $this->newdownloadlink; ?>
    	    </div>
    	<?php
    	}
    	if ($this->newsletter)
    	{?>
    	    <div style="margin-top:20px;">
    	    To subscribe to the newsletter please follow this
    	    <a href="<?php echo $this->newsletter; ?>" target="_blank">link</a>
    	    </div>
    	<?php
    	}
    	if ($this->announcements)
    	{?>
    	    <div style="margin-top:20px;">
    	    Latest Announcements: <br>
    	    <?php echo $this->announcements; ?>
    	    </div>
    	<?php
    	}
    	if ($this->releasenotes)
    	{?>
    		<div style="margin-top:20px;">
    	    Latest Release Notes: <br>
    	    <?php echo $this->releasenotes; ?>
    	    </div>
    	<?php
    	}
    	?>
    	<form action="index.php" method="post" name="adminForm">
    	<input type="hidden" name="option" value="<?php echo $option ?>" />
    	<input type="hidden" name="task" value="" />
    	</form>
    	<?php

	}

}

?>