<?php 
/**
 * Abstract layer for acces to : database, table,
 * etc curent site objects
 * and miscelanious system, utilities as pagination, redirect,
 * REQUEST processing
 *  .. etc
 *    
 * Available in Different versions for various systems 
 * and versions of same system 
 *  
 * ----------------------------------------------------------
 * Bridge for Joomla 1.0.x , Joomla 1.5.x and  Joomla 1.6.x
 * ----------------------------------------------------------
 * 
 * @version 1.2.0 (JTheFactory version)
 * 
 * @package:JTheFactory Framework
 * @subpackage:Framework CMS Layers
 * 
**/
if(defined("JOOMLA_VERSION"))
	define("F_JOOMLA_OS_VERSION", JOOMLA_VERSION);
else
	define("F_JOOMLA_OS_VERSION", FactoryLayer::getJoomlaOSVersion());

// @hash
define("F_DS", DIRECTORY_SEPARATOR);

// TO DO replace with Aplication Constants
if(F_JOOMLA_OS_VERSION=="5"){
	define("F_ROOT_DIR", JPATH_ROOT);
	define("F_ROOT_URI", JURI::root());
	
}elseif(F_JOOMLA_OS_VERSION=="1"){
	global $mosConfig_live_site, $mosConfig_absolute_path;
	
	define("F_ROOT_DIR", $mosConfig_absolute_path);
	define("F_ROOT_URI", $mosConfig_live_site);
	
}

class FactoryLayer{
	
	/**
	 * Returns database curent Object   
	 *
	 */
	function &getDB(){
		
		if(F_JOOMLA_OS_VERSION=="1"){
			// Joomla 1.0.x
			global $database;
			return $database;
		}elseif(F_JOOMLA_OS_VERSION=="5"){
			// Joomla 1.5.x
			$db =&JFactory::getDBO();
			return $db;
		}
		
	}
	
	/**
	 * Returns current user logged 
	 *
	 */
	function &getUser(){
		if(F_JOOMLA_OS_VERSION=="1"){
			// Joomla 1.0.x
			global $my;
			return $my;
		}elseif(F_JOOMLA_OS_VERSION=="5"){
			// Joomla 1.5.x
			$my = &JFactory::getUser(); 
			return $my;
		}
	}
	
	
	/**
	 * Requires, instantiates and returns refference to pagination object 
	 * 
	 **/
	 function initPagination($total, $limitstart, $limit){
	 	
		if(F_JOOMLA_OS_VERSION=="1"){
			// Joomla 1.0.x
			require_once( F_ROOT_DIR. '/administrator/includes/pageNavigation.php' );
			return new mosPageNav( $total, $limitstart, $limit  );
		}elseif(F_JOOMLA_OS_VERSION=="5"){
			// Joomla 1.5.x
			jimport('joomla.html.pagination');
			return new JPagination($total, $limitstart, $limit);
		}
	 	
	 	
	 }
	 
	 function getRequest(&$arrName, $name, $default=null){
		if(F_JOOMLA_OS_VERSION=="1"){
			// Joomla 1.0.x
		 	$tmp = mosGetParam($arrName,$name,$default);
		}elseif(F_JOOMLA_OS_VERSION=="5"){
			// Joomla 1.5.x
			$tmp = &JRequest::getVar($name,$default);
		}
	 	return $tmp;  
	 }
	 
	 function redirect($uri, $msg=null){
	 	
	 	
	 	$uri = str_replace("///","/",$uri);
	 	
		if ( F_JOOMLA_OS_VERSION=="1" ){
			// Joomla 1.0.x
			mosRedirect($uri,$msg);
		}elseif(F_JOOMLA_OS_VERSION=="5"){
			// Joomla 1.5.x, 1.6.x
			$app	= JFactory::getApplication();
		 	$app->redirect($uri,$msg);
		}
	 }
	 
	function getJoomlaOSVersion(){
	    if (class_exists('JConfig')){
	        return "5";
	    }else{
	    	return "1";
	    }
	}
	
}


/**
 * 
 * Factory Framework HTML Methods
 * Joomla 1.0.x & 1.5.x
 * 
*/
class FactoryHTML{
	/**
	 * 
	 * Calls Current Framework select list 
	 * idiot mi: TO DO switch $attributes with $filter_value
	 * 
	*/
	function selectGenericList($options, $control_name, $filter_value, $attributes="", $value="value", $text="text" )
	{
		
		if(F_JOOMLA_OS_VERSION=="1"){
			
			// Joomla 1.0.x
			$opts = array();
			if (count($options))
				foreach($options as $i => $o){
					$opts[]=mosHTML::makeOption($i, $o);
				}
	
			return mosHTML::selectList($opts, $control_name, $attributes,$value, $text,$filter_value );
			
		}elseif(F_JOOMLA_OS_VERSION=="5"){
			$opts = array();
			if (count($options))
				foreach($options as $i => $o){
					$opts[]=JHTML::_('select.option', $i, $o);
				}
			if($opts)	
			return JHTML::_( 'select.genericlist', $opts, $control_name, $attributes, $value, $text,$filter_value );
			else 
				return "";
		}


	}
	
	function selectBooleanList($tag_name, $tag_attribs, $selected, $yes=null, $no=null){

		if(F_JOOMLA_OS_VERSION=="1"){
			
			// Joomla 1.0.x
			return mosHTML::yesnoSelectList( $tag_name, $tag_attribs, $selected, $yes=_CMN_YES, $no=_CMN_NO );
			
		}elseif(F_JOOMLA_OS_VERSION=="5"){
			
			// Joomla 1.5.x
			return JHTML::_("select.booleanlist",$tag_name, $tag_attribs, $selected, $yes=JText::_("Yes"), $no=JText::_("No") );
		}
	}
	
	/**
	 * Calls current Framework backend tooltip method 
	 *
	 */
	function tooltip($t){
		if(F_JOOMLA_OS_VERSION=="1"){
			
			// Joomla 1.0.x
			return mosToolTip($t);
			
		}elseif(F_JOOMLA_OS_VERSION=="5"){
			
			JHTML::_('behavior.tooltip'); //load the tooltip behavior
			// Joomla 1.5.x
			return JHTML::tooltip($t);
		}
	}
	
	
}

?>