<?php
/**
 * TheFactory Standard Auto Loaded Controller
 * 
 *
 */
class JTheFactoryIntegration{
	
    /**
     * Added INIT Method to load all dependencies both on front & backend
     *
     * @since 13/01/2010 (dd/mm/YYYY)
     */
	function init(&$application){

		if($application){
			$T_app=$application;
		}
		else 
			$T_app=&JTheFactoryApp::getInstance(null,null);
		
		$this->detectIntegration($T_app);	

	}

	/**
	 * Backend Application Router
	 *
	 * @param $task
	 * @param $act
	 * @return bool
	 */
	function route(){
		
		$task = & JRequest::getVar("task","");
		$act = & JRequest::getVar("act","");
		
		if (method_exists($this,$task)){
			return $this->$task($act);
		}
        
	}
	
	/**
	 * Backend Main Controller task
	 *
	 * @param $act
	 * @return bool
	*/
    function integration( &$act )
    {
    	if( $act=="" ){
			require_once(dirname(__FILE__).DS."tmpl".DS."main.php");
			return true;
    	}else{

			$type = FactoryLayer::getRequest($_REQUEST,"type");
			if( $type=="cb" ){
				
				JLoader::register('FCBController', dirname(__FILE__).DS.'controllers'.DS.'cb.php');
				$FController = new FCBController();
				return $FController->checkTask( $act );
				
			}elseif( $type=="lovefactory" ){
				
				JLoader::register('FLovefactoryController', dirname(__FILE__).DS.'controllers'.DS.'lovefactory.php');
				$FController = new FLovefactoryController();
				return $FController->checkTask( $act );
				
			}

			return false;

    	}

	}
	
	function detectIntegration($application){
		
		$database =& JFactory::getDBO();
		$database->setQuery("SELECT count(*) FROM #__components WHERE `option`='com_joomfish'");
		
		if($database->loadResult()>0){
			define('JOOMFISH_DETECT',1);
		}else {
		  define('JOOMFISH_DETECT',0);
		}
	   
		if (!file_exists(JPATH_ROOT.'/components/com_uddeim/uddeim.php')) {
			define("UDDEIM_DETECT",0);
		}else{
			define("UDDEIM_DETECT",1);
		}
	    
		
		require_once(dirname(__FILE__).DS."cb.php");
		cb_integration::_detectIntegration($application);
		
		require_once(dirname(__FILE__).DS."lovefactory.php");
		lovefactory_integration::_detectIntegration($application);
	}
	
	function getIntegrationArray($key){
		$integration_arr = array();
		
		$application = &JTheFactoryApp::getInstance(null,null);
		if(CB_DETECT){
			require_once(dirname(__FILE__).DS."cb.php");
			$integration_arr["CB"] = cb_integration::getIntegrationArr($application);
		}
		
		if(LOVE_DETECT){
			require_once(dirname(__FILE__).DS."lovefactory.php");
			$integration_arr["LOVE"] = lovefactory_integration::getIntegrationArr($application);
		}
		return $integration_arr[$key];
	}
	
	function integrationFields($T_app=null){
		if(!$T_app)
			$T_app = &JTheFactoryApp::getInstance(null,null);
			
    	$f=$T_app->getIniValue("fields_list","cb-integration");
    	if($f != "")
	    	return explode(",",$f);
	    else 
	    	return null;	
	}
	
}

?>