<?php

// CB INTEGRATION LIB

class cb_integration extends JTheFactoryIntegration{
	
	function _detectIntegration($T_app)
	{
		$database =& JFactory::getDBO();
	    $database->setQuery("SELECT count(*) FROM #__components WHERE `option`='com_comprofiler'");
	    
	    if($database->loadResult()>0){
	    	define('CB_DETECT',1);
	    	cb_integration::getIntegrationArr($T_app);
	    }else {
	        define('CB_DETECT',0);
	    }
	}
	
	function getIntegrationArr($T_app){
		
		static $integration_arr;
		
		if(!isset($integration_arr["cb"])){
			$database =& JFactory::getDBO();
			
		    $integration_arr=array();
		    $cb_fieldmap=array();
		    
	    	$table=$T_app->getIniValue("field_map_table","cb-integration");
			
	    	$database->setQuery("SELECT field,cb_field FROM `".$table."`");
	    	$r=$database->loadAssocList();
	    	for($i=0;$i<count($r);$i++){
	    	    $cb_fieldmap[$r[$i]['field']]=$r[$i]['cb_field'];
	    	}
	    	$integration_arr["CB"]=$cb_fieldmap;
		}
		return $integration_arr["CB"];
	}
	
	function getProfile(&$user_obj){
		
	    // CB Fields
	    require_once(JPATH_ADMINISTRATOR.DS."components".DS."com_comprofiler".DS."plugin.foundation.php");
		cbimport( 'cb.database' );
	    
		$cbUser			=&	CBuser::getInstance( $user_obj->userid );
		if ( $cbUser ) {
			$user		=&	$cbUser->getUserData();
		}
		$cb_fieldmap = JTheFactoryIntegration::getIntegrationArray("CB");
		$integrationFields = JTheFactoryIntegration::integrationFields();
		
       	$user_obj->username = $user->username;
       	
		foreach ($integrationFields as $pm => $fld){
            if ($cb_fieldmap[$fld])
            	$user_obj->$fld=$user->$cb_fieldmap[$fld];
		}
		
	}
	
	function getListJoins(&$Joins, &$cols, $exclusive ){
		
		
		
		if($exclusive==1){
			
	    	$Joins[] = " RIGHT JOIN `#__comprofiler` AS `prof` ON `a`.`userid` = `prof`.`user_id` " ;	
			
		}else{
			
	    	$Joins[] = " LEFT JOIN `#__comprofiler` AS `prof` ON `a`.`userid` = `prof`.`user_id` " ;	
		    
		}
	}
	
}

?>