<?php
/**
 * @package Auctions Factory
 * @version 2.0.0
 * @copyright www.thefactory.ro
 * @license: commercial
*/

class JBidsACL{
	
	
    var $_taskmapping = array(
    
    	".viewbids"					=> "all",
    
    	"category."					=> "all", 
		"category.display"		=> "all", 
    	"category.tree"			=> "all",
    	
    	".report_auction"			=> "all",
    	
    	"auctions."					=> "all",
    	"auctions.display"		=> "all",
    	".listauctions"			=> "all",
    	"auctions.myauctions" 	=> "seller",
    	".myauctions" 				=> "seller",
    	
    	"bid.selectcat"			=> "seller",
    	"bids." 						=> "all",
    	".savemessage"				=>	"all",
    	"bids.display"				=> "all",
    	"bids.listauctions" 		=> "all",
    	".watchlist" 				=> "all",
    	"bids.watchlist" 			=> "all",
    	"bids.addwatchlist"		=> "all",
    	".delwatch"					=> "all",
    	"bids.delwatch"			=> "all",
    	
    	".showsearchresults"		=> "all",
    	"auctions.showsearchresults"		=> "all",
    	"bids.search"				=> "all",
    	"bids.showsearchresults"=> "all",
    	
    	"user." 						=> "all",
    	"user.rate" 				=> "all",
    	"user.display"				=> "all",
    	".myratings"	 			=> "all",
		".saveuserdetails" 		=> "all",
    	"user.myratings" 			=> "all",
    	"user.userratings" 		=> "all",
		"user.saveuserdetails" 	=> "all",
    	

    	".userdetails" 			=> "all",
    	".viewdetails" 			=> "all",
    	"user.userprofile" 		=> "all",
    	"user.searchusers" 		=> "all",
    	"user.showusers" 			=> "all",
    	"user.googlemap_tool" 	=> "all",
    	".reviews_show"			=> "all",
    	".reviews_save"			=> "all",
    	".buy_contact"				=> "all",
    	".purchase"					=> "all",
    	"bids.purchase"			=> "all",
    	
    	
    	".newauction" 				=> "seller",
    	"auction.newauction" 	=> "seller",
    	".editauction" 			=> "seller",
    	"auction.editauction" 	=> "seller",
    	".republish" 				=> "seller",
    	"auctions.republish" 	=> "seller",
    	".cancelauction"			=> "seller",
    	"auctions.cancelauction"=> "seller",
    	"auction.form"				=> "seller",
    	".saveauction"				=> "seller",
    	"auction.saveauction"	=> "seller",
    	".accept"					=> "seller",
    	
    	"bids.mybids"				=> "bidder",
    	"bids.sendbid"				=> "bidder",
    	".bin"						=> "bidder",
    	".bin"						=> "bidder",
    	".sendbid"					=> "all",
    	"auctions.mybids"			=> "all",
    	"auctions.mywonbids"		=> "all",
    	".mybids"					=> "all",
    	".mywonbids"				=> "all",
    	"user.viewdetails"		=>	"all",
    	"auctions.mywatchlist"	=> "all",
    	".mywatchlist"				=> "all",
    	"auctions.listsuggestions"	=> "all",
    	".listsuggestions"		=> "all",
    	"auctions.mysuggestions"=> "all",
    	".mysuggestions"			=> "all",
    	"bid.suggest"				=>"all",
    	".acceptsuggestion"		=>"seller",
    	".set_featured"			=>"seller",
    	".rss"						=> "all",
    	".terms_and_conditions"	=> "all"
    	
    );

    var $_publicTasks=array(
    
			"auctions.",
			"auctions.display",
			
			"category.", 
			"category.display", 
			"category.tree",
			
			".viewbids",
			"bids.", 
			".listauctions",
			"bids.listauctions",
			"bids.search",
			".showsearchresults",
			"bids.showsearchresults",
			
			
			"user.searchusers",
			"user.showusers",
			".searchusers"
			
    );
    
    var $_anonTasks=array(
    
    	".listauctions",
    	
    	"auctions.",
    	"auctions.display",
    	
    	".viewbids",
    	"bids.", 
    	"bids.listauctions",
    	"bids.search",
    	".showsearchresults",
    	"bids.showsearchresults",
    	"category.", 
    	"category.display", 
    	"category.tree",
    	
    	"user.searchusers",
    	"user.showusers",
    	".searchusers",
    	
    	"user.",
    	"user.display",
    	"user.saveuserdetails",
    	".saveuserdetails",
      "user.googlemap_tool"
    );
    var $_my = null;
    

    function JBidsACL()
    {
		$my = &JFactory::getUser();
		$this->_my=$my;
		if(bid_opt_allow_guest_messaging){
			$this->_publicTasks[] = ".savemessage";
			$this->_anonTasks[] = ".savemessage";
		}
    }
    
    
    function tpl_acl_check($task){
    	
    	$view = "";
    	$msg = null;
        if (!$this->_checkPublicTask(strtolower($view),strtolower($task))){
        	
			$msg .= JText::_('ALERTNOTAUTH');
			$msg .= "<br />" . JText::_( 'You need to login.' );
	        return $msg;
        }
        
        if ( !$this->_checkProfile(strtolower($view),strtolower($task)) ) {
	        $msg .= JText::_("bid_err_more_user_details");
            return $msg;
        }
        
        if ( bid_opt_enable_acl ){
			if(!$this->_checkTaskACL(strtolower($view),strtolower($task))){
				$msg .= "<br />You do not have permissions for this!";
		        return $msg;
            }
        }
        
        return true;
    	
    }
    
    function acl_check($view,$task){

			//var_dump($view);var_dump($task);
			//exit;
		
			if (!$this->_checkPublicTask(strtolower($view),strtolower($task))){
				echo JText::_('ALERTNOTAUTH');
				echo "<br />" . JText::_( 'You need to login.' );
				return false;
			}
			
			if ( !$this->_checkProfile(strtolower($view),strtolower($task)) ) {
			
				$r = BidsUtilities::redirectToProfile( );
				if( !$r ){
					$tmp_id = BidsUtilities::getMenuItemId(array("task"=>"userprofile"));
					if( !$tmp_id )
					  $tmp_id = BidsUtilities::getMenuItemId(array("view"=>"user", "layout"=>""));

					$r = "index.php?option=com_bids&view=user&Itemid=$tmp_id";
				}
				FactoryLayer::redirect($r, JText::_("bid_err_more_user_details") );
				
				return false;
			}
        if ( bid_opt_enable_acl ){
			if( !$this->_checkTaskACL(strtolower($view),strtolower($task)) ){
					echo JText::_('ALERTNOTAUTH');
		        	return false;
            }
        }
        return true;
    }
    /**
     * 
     *
     * @param $view
     * @param $task
     * @return boolean
     */
    function _checkPublicTask($view,$task)
    {
        if ((!$this->_my->id)&& !in_array($view.".".$task,$this->_publicTasks)){
        	return false;
        }
        return true;
    }
    
	function _checkProfile($view,$task){
	
		$database = &JFactory::getDBO();
		
		if (in_array($view.".".$task,$this->_anonTasks)) 
			return true;
		
		$BidUser = new JAuctionUsers($database);
		$uProfile = $BidUser->getUserDetails($this->_my->id);
		if( $uProfile->name )
			return true;
		
		return false;
	}
    
	function _checkTaskACL($view,$task,$user=null)
	{
		$database = &JFactory::getDBO();
		$acl = & JFactory::getACL();
	
		if (!$user) $user=$this->_my;
	
		if (@$this->_taskmapping[$view.".".$task]=='all'){
		   return true;
		}
		
		if (!$user->id){
			return false;
		}
	
		$isBidder=false;
		$isSeller=false;
	
		if (bid_opt_acl_type=='groups'){
			$user_groups = $acl->acl_get_groups('users',$user->id);
		   if (!is_array($user_groups)) 
		   	return false;
		   if (in_array(bid_opt_acl_bidder,$user_groups)) $isBidder = true;
		   if (in_array(bid_opt_acl_seller,$user_groups)) $isSeller = true;
		
		}
	
		if (bid_opt_acl_type=='profile'){
			$BidUser = new JAuctionUsers($database);
			$uProfile = $BidUser->getUserDetails($user->id);
			$isBidder = $uProfile->isBidder;
			$isSeller = $uProfile->isSeller;
		}
		
		if (@$this->_taskmapping[$view.".".$task]=='seller' && $isSeller){
		 return true;
		}
		if (@$this->_taskmapping[$view.".".$task]=='bidder' && $isBidder){
		 return true;
		}
		
		return false;
	}
    
    
    
    function isBidder()
    {
		$database = &JFactory::getDBO();
		$acl = & JFactory::getACL();

        if (bid_opt_acl_type=='groups'){
            $user_groups=$acl->get_object_groups('users',$this->_my->id,'aro');
            if (!is_array($user_groups)) return false;
            if (in_array(bid_opt_acl_bidder,$user_groups)) return true;

         }
        if (bid_opt_acl_type=='profile'){
        		$cb_fieldmap = JThefactoryIntegration::getIntegrationArray("cb");
            if (CB_DETECT){
                $bidder_field=$cb_fieldmap['isBidder'];
                if($bidder_field){
                    $database->setQuery("select $bidder_field from #__comprofiler where user_id='".$this->_my->id."'");
                    return $database->loadResult();
                }else{
                    //if no field defined, all are sellers
                    return true;
                }

            }else{
                $database->setQuery("select isBidder from #__bid_users where userid='".$this->_my->id."'");
                return $database->loadResult();
            }

        }

    }
    function isSeller()
    {
		$database = &JFactory::getDBO();
		$acl = & JFactory::getACL();
		
      if (bid_opt_acl_type=='groups'){
            $user_groups=$acl->get_object_groups('users',$this->_my->id,'aro');
            if (!is_array($user_groups)) return false;
            if (in_array(bid_opt_acl_seller,$user_groups)) return true;

      }
      if (bid_opt_acl_type=='profile'){
        		$cb_fieldmap = JThefactoryIntegration::getIntegrationArray("cb");
         if (CB_DETECT){
             $seller_field=$cb_fieldmap['isSeller'];

             if($seller_field){
                 $database->setQuery("select $seller_field from #__comprofiler where user_id='".$this->_my->id."'");

                 return $database->loadResult();
             }else{
                 //if no field defined, all are sellers
                 return true;
             }
         }else{
             $database->setQuery("select isSeller from #__bid_users where userid='".$this->_my->id."'");
             return $database->loadResult();
         }

     }

    }

    /**
     * deprecated
     */
    function _isVerified($userid)
    {
        global $cb_fieldmap;
        
        $database = & JFactory::getDBO();
        $acl = & JFactory::getACL();

        if (CB_DETECT){
            $seller_field=$cb_fieldmap['verified'];

            if($seller_field){
                $database->setQuery("select `$seller_field` from #__comprofiler where user_id='$userid'");
                return $database->loadResult();
            }else{
                //if no field defined, all are sellers
                return false;
            }
        }else{
            $database->setQuery("select `verified` from #__bid_users where userid='$userid'");
            return $database->loadResult();
        }

    }
    
    function isVerified()
    {
        return $this->_isVerified($this->_my->id);
    }

}


?>