<?php
function smarty_get_now(){
	return BidTimeUtilities::getNow();
}
function smarty_add_day($string, $offset="1"){
	return strtotime($string) + 86400*$offset;
}
function get_file_extension($path, $leading_dot = false) {
	$filename = basename($path);
	$dot_offset = (boolean) $leading_dot ? 0 : 1;
	if( ($pos = strrpos($filename, '.')) !== false ) {
		return substr($filename, $pos + $dot_offset, strlen($filename));
	} // if
	return '';
} // get_file_extension
function smarty_infobullet($params, &$smarty)
{
    $res="";
    if(!empty($params['text'])) {
        $res=JHTML::tooltip($params['text']);
    }
    return $res;
}
function smarty_printdate($params, &$smarty)
{
    $res="";
    if(!empty($params['date'])) {
        $dateformat=bid_opt_date_format;
        if ($params['use_hour']) $dateformat.=" H:i";
        $res=date($dateformat,strtotime($params['date']));
    }
    return $res;
}
function smarty_set_css($params, &$smarty)
{
	$jdoc = & JFactory::getDocument();
	$theme = BID_TPL_THEME;
	$jdoc->addStyleSheet(JURI::root()."components/com_bids/templates/{$theme}/bid_template.css");
    if ($jdoc->getType()=='raw')
        $res="<link href=\"".JURI::root()."/components/com_bids/templates/{$theme}/bid_template.css\" rel=\"stylesheet\" type=\"text/css\">";
    else    
        $res="";
        
    return $res;
}
function smarty_init_behavior($params, &$smarty)
{
    if(!empty($params['type'])) {
        $type=$params['type'];
    }else
        $type='modal';
    JHTML::_('behavior.'.$type); 
}

function smarty_show_editor($params, &$smarty)
{
    $editor=&JFactory::getEditor();
	/**
	 * Present a text area
	 * function display($name, $html, $width, $height, $col, $row, $buttons = true, $params = array())
	 * @param	string	The control name
	 * @param	string	The contents of the text area
	 * @param	string	The width of the text area (px or %)
	 * @param	string	The height of the text area (px or %)
	 * @param	int		The number of columns for the textarea
	 * @param	int		The number of rows for the textarea
	 * @param	boolean	True and the editor buttons will be displayed
	 * @param	array	Associative array of editor parameters
	 */
    $name=empty($params['name'])?'editor':$params['name'];
    $html=empty($params['html'])?'':$params['html'];
    $width=empty($params['width'])?'400':$params['width'];
    $height=empty($params['height'])?'250':$params['height'];
    $col=empty($params['col'])?'65':$params['col'];
    $row=empty($params['row'])?'50':$params['row'];
    $buttons=empty($params['buttons'])?'editor':$params['buttons'];
     
    echo $editor->display($name, $html, $width, $height, $col, $row, $buttons  );
}

function smarty_import_js_file($params, &$smarty)
{
    if (empty($params['url'])) return;
    $doc=&JFactory::getDocument();
    $doc->addScript($params['url']);
    if ($doc->getType()=='raw')
        return "<script type=\"text/javascript\" src=\"".$params['url']."\"></script>";
    
}

function smarty_import_css_file($params, &$smarty)
{
    if (empty($params['url'])) return;
    $doc=&JFactory::getDocument();
    $doc->addStyleSheet($params['url']);
    if ($doc->getType()=='raw')
        return "<link href=\"".$params['url']."\" rel=\"stylesheet\" type=\"text/css\">";
}
function smarty_import_js_block($params, $content, &$smarty, &$repeat)
{
    if ($repeat) return; //ignore opening tag
    $doc =& JFactory::getDocument();
    $doc->addScriptDeclaration( $content );
    if ($doc->getType()=='raw')
        return "<script type=\"text/javascript\">$content</script>";
    
}
function smarty_import_css_block($params, $content, &$smarty, &$repeat)
{
    if ($repeat) return; //ignore opening tag
    $doc =& JFactory::getDocument();
    $doc->addStyleDeclaration( $content );
    if ($doc->getType()=='raw')
        return "<style type=\"text/css\">$content</style>";
    
}
	
function smarty_print_price($params, &$smarty)
{
    $auction=$params['auction'];
    $price=$params['price'];
    $currency='';
    if (is_object($auction))
        $currency=$auction->currency_name;

    if($price)    
		echo number_format($price,2).'&nbsp;'.$currency;
	else 
		echo "-";
	
}
function smarty_translate_txt_block($params, $content, &$smarty, &$repeat)
{
    if ($repeat) return; //ignore opening tag
    if (defined($content))
        return constant($content);
    else
        return $content;
}

function smarty_createtab($params, &$smarty)
{
		//$res="<link id=\"luna-tab-style-sheet\" type=\"text/css\" rel=\"stylesheet\" href=\"" . JURI::root(). "/includes/js/tabs/tabpane.css\" />";
	$res="<script type=\"text/javascript\" src=\"". JURI::root() . "/includes/js/tabs/tabpane_mini.js\"></script>";
    return $res;
}
function smarty_startpane($params, &$smarty)
{
    if (!empty($params['id'])){
       $useCookies = (empty($params['usecookies']))?0:$params['usecookies'];
	   $res="<div class=\"tab-page\" id=\"".$params['id']."\">";
	   $res.="<script type=\"text/javascript\">\n";
	   $res.="	var tabPane1 = new WebFXTabPane( document.getElementById( \"".$params['id']."\" ), ".$useCookies." )\n";
	   $res.="</script>\n";
    }
    return $res;
}
function smarty_endpane($params, &$smarty)
{
   return "</div>";
}
function smarty_starttab($params, &$smarty)
{
    $paneid=$params['paneid'];
    $tabText=$params['text'];
	$res= "<div class=\"tab-page\" id=\"".$paneid."\">";
	$res.="<h2 class=\"tab\">".$tabText."</h2>";
	$res.="<script type=\"text/javascript\">\n";
	$res.= "  tabPane1.addTabPage( document.getElementById( \"".$paneid."\" ) );";
	$res.= "</script>";
    return $res;
}
function smarty_endtab($params, &$smarty)
{
   return "</div>";
}


function smarty_jroute($uri){
	return JRoute::_($uri);
}



?>