<?php
// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.application.component.helper');


/**
 * @package		Auctions Factory
 * @since 2.0
 */
class bidsModelAuctions extends JModel
{
	var $_name='Auctions';
	var $_where = null;
	var $_join = null;
	var $_filters = null;
	/**
	 * Default Filtered Listings
	 * 
	 * values 
	 * 0 - published and active
	 * 1 - unpublished
	 * 2 - closed
	 * 3 - won auctions
	 */
	var $_filter_order_Dir = null;
	var $_filter_order = null;
	var $_task = null;
	var $order_fields = array(
		'start_date' => "a.start_date",
		'title' => "a.title",
		'username' => "u.username",
		'end_date' => "a.end_date",
		'start_price' => "a.initial_price+0",
		'bin_price' => "a.BIN_price+0",
		'hits' => "a.hits",
		'catname' => "cat.catname",
		'id' => "a.id",
		'nr_bidders' => "nr_bidders",
		'nr_bids' => "nr_bids"
		
	);
	
    function getfilter_order_Dir()
    {
        return $this->getState('filter_order_Dir');
    }

    function getreversefilter_order_Dir()
    {
        if ($this->getState('filter_order_Dir') == "ASC")
            return "DESC";
        else
            return "ASC";
    }

    function getfilter_order()
    {
        return $this->getState('filter_order');
    }

    function getCurrentFilters()
    {
        return $this->_filters;
    }
    
    function getAuctions()
    {
		$app	= JFactory::getApplication();
		$context = "com_bids.{$this->_task}";
        
        $this->setFiltersList();
        $this->buildFiltersQuery();
        $config = &JFactory::getConfig();
        
        if ( defined("bid_opt_nr_items_per_page") && bid_opt_nr_items_per_page > 0 )
        	$list_limit = bid_opt_nr_items_per_page;
        else
			$list_limit = $config->getValue('config.list_limit');
			

        // Get the pagination request variables
        $this->setState('limit', $app->getUserStateFromRequest($context.'.limit','limit', $list_limit, 'int'));
        
        $this->setState('limitstart', JRequest::getVar('limitstart', 0, '', 'int'));
        // In case limit has been changed, adjust limitstart accordingly
        $this->setState('limitstart', ($this->getState('limit') != 0 ? (floor($this->getState('limitstart') / $this->getState('limit')) * $this->getState('limit')) :0));

        $this->setState('filter_order_Dir', $app->getUserStateFromRequest($context.'.filter_order_Dir', 'filter_order_Dir', "ASC"));
        $this->setState('filter_order', $app->getUserStateFromRequest($context.'.filter_order','filter_order', "start_date"));

		$query = $this->buildQuery();
		$list = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
        
		return $list;
    }
    
    function getSuggestions(){
		$app	= JFactory::getApplication();
        
        $config = &JFactory::getConfig();
        
        if ( defined("bid_opt_nr_items_per_page") && bid_opt_nr_items_per_page > 0 )
        	$list_limit = bid_opt_nr_items_per_page;
        else
			$list_limit = $config->getValue('config.list_limit');
			

        // Get the pagination request variables
        $this->setState('limit', $app->getUserStateFromRequest('com_bids.limit','limit', $list_limit, 'int'));
        $this->setState('limitstart', JRequest::getVar('limitstart', 0, '', 'int'));
        // In case limit has been changed, adjust limitstart accordingly
        $this->setState('limitstart', ($this->getState('limit') != 0 ? (floor($this->getState('limitstart') / $this->getState('limit')) * $this->getState('limit')) :0));

        $this->setState('filter_order_Dir', $app->getUserStateFromRequest($context.'.filter_order_Dir', 'filter_order_Dir', "ASC"));
        $this->setState('filter_order', $app->getUserStateFromRequest($context.'.filter_order','filter_order', "start_date"));

		$query = $this->buildSuggestionsQuery();
		$list = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
        
		return $list;
    }

    function setFiltersList()
    {
    	/*@var $app JApplication*/
		$app	= JFactory::getApplication();
        $filters = array();
		$context = "com_bids.auctions.{$this->_task}";
        
        $reset = JRequest::getVar('reset', "");

        if ($reset != "all") {
            $filters["keyword"] = JRequest::getVar('keyword',$app->getUserStateFromRequest($context.'.keyword', 'keyword'));
            $filters["filter_bidtype"] = JRequest::getVar('filter_bidtype',$app->getUserStateFromRequest($context.'.filter_bidtype', 'filter_bidtype', 0));
            $filters["filter_archive"] = JRequest::getVar('filter_archive',$app->getUserStateFromRequest($context.'.filter_archive', 'filter_archive', 0));
            $filters["userid"] = JRequest::getVar('userid',$app->getUserStateFromRequest($context.'.userid', 'userid', 0));
            $filters["users"] = JRequest::getVar('users',$app->getUserStateFromRequest($context.'.users', 'users', array()));
            $filters["cat"] = JRequest::getVar('cat',$app->getUserStateFromRequest($context.'.cat', 'cat', 0));
            $filters["filter_type"] = JRequest::getVar('filter_type',$app->getUserStateFromRequest($context.'.filter_type', 'filter_type', null));
            $filters["tag"] = JRequest::getVar('tag', $app->getUserStateFromRequest($context.'.tag','tag'));
			$app->setUserState($context.'.filter_type', '');
            
        } else {
			// reset filters; set null to state
			$this->setState("filters", array());
			$app->setUserState($context.'.keyword', '');
			$app->setUserState($context.'.filter_bidtype', '');
			$app->setUserState($context.'.userid', '');
			$app->setUserState($context.'.users', '');
			$app->setUserState($context.'.cat', '');
			$app->setUserState($context.'.filter_type', '');
			$app->setUserState($context.'.tag', '');
        }


		$Fi = & FactoryFieldsFront::getInstance();
		$Fi->setFiltersToState($filters, $reset);
        $this->_filters = $filters;
    }
    
    /**
     * Deprecated Model
     *
     */
    function buildSuggestionsQuery(){
    	
		$database = &JFactory::getDBO();
		$my = &JFactory::getUser();
		if(!$my->id){
			echo "<br />" . JText::_( 'You need to login.' );
			return;
		}
		
	    $where = "";
	    
	    if($this->_task=="mysuggestions"){
	    	
		    $where .= " where  ( ss.userid='$my->id' OR a.userid = '$my->id' )  ";
		    
	    }elseif( $this->_task=="listsuggestions" || $this->_task=="suggestions" ){
	    	
			$where .= " where ( (ss.userid='$my->id' OR b.userid ='$my->id' )  and a.userid <> '$my->id' ) ";
		    
	    }
	    
	    $filter_bidtype = JRequest::getInt('filter_bidtype', 0);
	    switch ($filter_bidtype)
	    {
	        case '0':
	            $where .= " and b.close_offer=0 and b.published=1 ";
	            break;
	        case '1':
	            $where .= " and b.close_offer=1 and b.published=1 ";
	            break;
	    }

		
		$query = "select a.id as parent_message,a.price as suggested_price, a.modified as bid_date,
	        	b.newmessages as bid_newmessages,
	        	a.status as accept, a.replyto as resuggest ,
	         	b.*,c.name as currency_name, u.name as name, u.username ,a.quantity, ss.userid as repliedto 
	        	FROM #__bid_suggest as a 
	        	LEFT JOIN #__bid_auctions as b on a.auctionid = b.id 
	        	LEFT JOIN #__bid_suggest as ss ON a.replyto=ss.id 
	        	";
		
	    $query .= "left join #__bid_currency c on b.currency=c.id
	        	 left join #__users u on u.id=a.userid
	        ";
		$query .= "$where order by featured='gold' desc";
		
	    return $query;
    	
    }
    
    function buildQuery()
    {
		$user = &JFactory::getUser();

        $filters = $this->_filters;
		
		if(isset($this->_task)){
			switch ($this->_task){
				case "myauctions":{
					$myauctions = 1;
					break;
				}
				case "watchlist":{
					$watchlist = 1;
					break;
				}
				case "mybids":{
					$mybids = 1;
					break;
				}
			}
		}
		
    	
    	$SelectCols 	= array();
    	$JoinList 		= array();
    	$WhereClauses 	= array();
		$Orderings	 	= array();

        $filter_order_Dir 	= $this->_db->getEscaped($this->getState('filter_order_Dir'));
        $filter_order 		= $this->_db->getEscaped($this->getState('filter_order'));
		
/**
 * 
 *  Table Fields to select
 * 
 * 
 **/		
		$SelectCols[] 	= " DISTINCT `a`.* ";
		$SelectCols[] 	= " `cat`.`id` as cati, `cat`.`catname`, `catsef`.`categories` as catslug ";
		$SelectCols[] 	= " `cur`.`name` as currency_name ";
		$SelectCols[] 	= " `u`.`username` \r\n ";
		$SelectCols[] 	= " GROUP_CONCAT(DISTINCT `t`.`tagname`) AS alltags  \r\n";
		$SelectCols[] 	= " IF ( COUNT(`pics`.`id`) >0 , 1, 0 ) AS more_pictures  \r\n";
		$SelectCols[] 	= "	COUNT(distinct bids.userid) as nr_bidders \r\n";
		$SelectCols[] 	= "	MAX(bids.bid_price+0) as highest_bid  \r\n";
		if( JOOMFISH_DETECT )
			$SelectCols[] 	= ' jfl.code as jflang, jfl.name as jflname';
		
/**
 * 
 *  Where conditions
 *
 *  
 **/
		if ( $w=$this->getState("where") )
			$WhereClauses=$w;

		if(!$myauctions){
		    switch ($filters["filter_bidtype"])
		    {
		        default:
		        case 0:{
					$WhereClauses[] 	= " (`cat`.`status`=1 OR `cat`.`status` IS NULL ) ";
					$WhereClauses[] 	= " `a`.`close_by_admin` = 0 ";
					$WhereClauses[] 	= " `a`.`close_offer` = 0 ";
					$WhereClauses[] 	= " `a`.`published` = 1 ";
		        }
	            break;
		        case 1:{
					$WhereClauses[] 	= " `a`.`close_by_admin` = 0 ";
					$WhereClauses[] 	= " `a`.`close_offer` = 1 ";
		            break;
			    }
		    }
		}else{
		
			switch ($filters["filter_archive"]){
				default:
				case 0:{
					$WhereClauses[] 	= " (`cat`.`status`=1 OR `cat`.`status` IS NULL ) ";
					$WhereClauses[] 	= " `a`.`close_by_admin` = 0 ";
					$WhereClauses[] 	= " `a`.`close_offer` = 0 ";
					$WhereClauses[] 	= " `a`.`published` = 1 ";
					break;
				}
				case 1:{
					$WhereClauses[] 	= " (`cat`.`status`=1 OR `cat`.`status` IS NULL ) ";
					$WhereClauses[] 	= " `a`.`close_by_admin` = 0 ";
					$WhereClauses[] 	= " `a`.`close_offer` = 0 ";
					$WhereClauses[] 	= " `a`.`published` = 0 ";
					break;
				}
				case 2:{
					$WhereClauses[] 	= " (`cat`.`status`=1 OR `cat`.`status` IS NULL ) ";
					$WhereClauses[] 	= " ((`a`.`close_by_admin` = 1 ) OR (`a`.`close_offer` = 1) OR (`a`.`published` = 0)) ";
					break;
				}
				case 3:{
					$WhereClauses[] 	= " (`cat`.`status`=1 OR `cat`.`status` IS NULL ) ";
					$WhereClauses[] 	= " (`a`.`winner_id` =0 ) ";
					break;
				}
				case 4:{
					$WhereClauses[] 	= " (`cat`.`status`=1 OR `cat`.`status` IS NULL ) ";
					$WhereClauses[] 	= " (`a`.`winner_id` !=0 ) ";
					break;
				}
			}
		}
		
		if( JOOMFISH_DETECT ){
			
			$registry =& JFactory::getConfig();
			$lang = $registry->getValue("config.jflang");
			$activeLang = 1;
			$ln = & JFactory::getLanguage();
			$defa = $ln->getDefault();
	
			if($activeLang==1 && $lang != $defa ){
				
				$WhereClauses[] = " jfc.reference_table = 'bid_auctions' ";
				$WhereClauses[] = " jfl.code = '$lang' " ;
				
			}
			
		}
		


		// USER LOGGED COMMON
		if($user->id){
		
			if ( isset($mybids) && $mybids==1 ) {
				$JoinList[] = " INNER JOIN `#__bids` AS bids ON `bids`.`id_offer`=`a`.`id` AND `bids`.`userid` = '".$user->id."'  \r\n";
			}else{
				$JoinList[] = " LEFT JOIN `#__bids` AS `bids` ON `a`.`id`=`bids`.`id_offer` ";
			}
		
			$SelectCols[] 	= "  IF ( `a`.`userid` = '" . (int)$user->id . "', 1, 0 ) AS `is_my_auction` ";
	
			if ( isset($myauctions) && $myauctions==1 ) 
				$WhereClauses[] = " `a`.`userid` = '" . (int)$user->id . "'";
	        
			// Is Favourite join
			$SelectCols["fav"] 	= "  IF ( `fav_table`.`id` >0, 1, 0 )  AS favorite ";
			if ( isset($watchlist) && $watchlist==1 ) 
				$JoinList[] = " INNER JOIN `#__bid_watchlist` AS fav_table ON `fav_table`.`auctionid`=`a`.`id` AND `fav_table`.`userid` = '".$user->id."' ";
			else
				$JoinList[] = " LEFT JOIN `#__bid_watchlist` AS fav_table ON `fav_table`.`auctionid`=`a`.`id` AND `fav_table`.`userid` = '".$user->id."' ";
			
				
		}else{
			$SelectCols["fav"] 	= "  -1 AS `favorite` ";
			$JoinList[] = " LEFT JOIN `#__bids` AS `bids` ON `a`.`id`=`bids`.`id_offer` ";

		}
		
		
		$where = "";
		if(count($WhereClauses)>0)
			$where = "WHERE ".implode(" AND ",$WhereClauses);

/**
 * 
 *  Joins
 * 
 **/
		
		$JoinList[] = " LEFT JOIN `#__bid_categories` AS `cat` ON  `a`.`cat`=`cat`.`id` ";
		$JoinList[] = " LEFT JOIN `#__bid_categories_sef` AS `catsef` ON  `a`.`cat`=`catsef`.`catid` ";
		
		$JoinList[] = " LEFT JOIN `#__users` AS `u` ON `u`.`id` = `a`.`userid` ";
        $JoinList[] = " LEFT JOIN `#__bid_users` AS `prof` ON `a`.`userid` = `prof`.`userid` " ;
        
        $JoinList[] = " LEFT JOIN `#__bid_tags` AS `t` ON  `t`.`auction_id`=`a`.`id`  ";
        $JoinList[] = " LEFT JOIN `#__bid_currency` AS `cur` ON  `cur`.`id`=`a`.`currency` ";
        $JoinList[] = " LEFT JOIN `#__bid_pictures` AS `pics` ON `pics`.`id_offer` = `a`.`id` ";
        
		if( JOOMFISH_DETECT ){
			$JoinList[] = " LEFT JOIN #__jf_content as jfc ON reference_id = a.id";
			$JoinList[] = " LEFT JOIN #__languages as jfl ON jfc.language_id = jfl.id";
		}
		

// modifies the Join List and the select list
		FactoryFieldsFront::getCustomFieldsJoin($JoinList, $SelectCols, null, array("#__bid_users"=>"prof","#__bid_auctions"=>"a"));


// Featurings first
		$Orderings[]	= "`a`.featured='gold' DESC";
// Required ordering filter		
if($filter_order)
		$Orderings[]	= "{$this->order_fields[$filter_order]} $filter_order_Dir";
		//$Orderings[]	= "`a`.`id` $filter_order_Dir ";
		

$query = " SELECT ".implode(",",$SelectCols)." \r\n ".
		 " FROM `#__bid_auctions` AS `a` \r\n".
		 implode(" \r\n ",$JoinList)."\r\n".
		 $where."\r\n".
		 " GROUP BY `a`.`id` ".
		 " ORDER BY ".implode(",",$Orderings)." \r\n"; 
		
		//echo "<strong>Auctions List QUERY</strong><br /><br />".(str_replace("#__","jos_",  nl2br($query)));
		//exit;
		return $query;
	}
	
    function buildFiltersQuery()
    {
        global $cb_fieldmap;
        $filters = $this->_filters;
        //AdsUtilities::sanitize($filters);

        $where = array();
        
        if (!empty($filters["filter_type"])) {
			// filtering
		    switch ($filters["filter_type"])
		    {
		        default:
		        case 'all':
		            //nothing
		            break;
		        case 'auctions_only':
		            $where[] = ' a.BIN_price<=0 ';
		            break;
		        case 'bin_only':
		            $where[] = ' a.BIN_price>0 ';
		            break;
		    }
        }

        
        if (!empty($filters["keyword"])) {
        	
			if( JOOMFISH_DETECT ){
	            $where[] = "  jfc.value LIKE ('%" . $filters["keyword"] . "%') ";
			}else{
	            $where[] = "  a.title LIKE ('%" . $filters["keyword"] . "%') ";
			}
            
        }
        
        if (!empty($filters["city"])) {
            if (!CB_DETECT) {
                $where[] = " prof.city = '" . $filters["city"] . "' ";
            } else
                $where[] = " cb." . $cb_fieldmap['city'] . "='" . $filters["city"] . "' ";

        }
        if (!empty($filters["userid"])) {
            $where[] = " a.userid = '" . $filters["userid"] . "' ";
        }
        
        if (!empty($filters["users"]) && is_array($filters["users"]) && count($filters["users"]) > 0 && !empty($filters["users"][0])  ) {
        	
			array_walk($filters["users"], "auctions_filter_this");
            $where[] = " a.userid  IN (" . implode(",",$filters["users"]) . " ) ";
        }
        
        if (!empty($filters["country"])) {
            if (!CB_DETECT)
                $where[] = " prof.country = '" . $filters["country"] . "' ";
            else {
                $where[] = " cb." . $cb_fieldmap['country'] . "='" . $filters["country"] . "' ";
            }
        }
        if (!empty($filters["tag"])) {
            $where[] = " t.tagname = '" . $filters["tag"] . "' ";
        }
        
        if (!empty($filters["cat"])) {
            if (!bid_opt_inner_categories)
                $where[] = " a.cat= '" . $filters["cat"] . "' ";
            else{
            	$cat = new JTheFactoryCategoryObj();
            	
            	$cTree = $cat->build_child($filters["cat"],true);
            	$cat_ids = array();
            	if($cTree){
            		foreach ($cTree as $cc){
            			if(isset($cc["id"]) && $cc["id"]!="")
            				$cat_ids[] = $cc["id"];
            		}
            	}
            	if( count($cat_ids) )
            		$cat_ids = implode(",", $cat_ids);
                $where[] = " ( a.cat  IN (" . $cat_ids . ") )";
            }
        }
        
		$Fi = & FactoryFieldsFront::getInstance();
		$Fi->setSQLFilters($where);
        $this->setState( "where", $where );
    }
    
    function getTotal()
    {
        $query = $this->buildQuery();
        return $this->_getListCount($query);
    }
    
    function getPagination()
    {
    	
        // Lets load the content if it doesn't already exist
        if (empty($this->_pagination)) {
            jimport('joomla.html.pagination');
            $this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'),$this->getState('limit'));
        }
        return $this->_pagination;
    }
}
?>