<?php
// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');
jimport('joomla.application.component.helper');


/**
 * @package		Auctions Factory
 * @since 2.0
 */
class bidsModelBid extends JModel
{
	var $_name='Bid';
	var $_filters = null;


    function getBids()
    {
		$app	= JFactory::getApplication();
		$context = "com_bids.bids.{$this->_task}";
        
        $this->setFiltersList();
        $this->buildFiltersQuery();
        $config = &JFactory::getConfig();
        
        if ( defined("bid_opt_nr_items_per_page") && bid_opt_nr_items_per_page > 0 )
        	$list_limit = bid_opt_nr_items_per_page;
        else
			$list_limit = $config->getValue('config.list_limit');
			

        // Get the pagination request variables
        $this->setState('limit', $app->getUserStateFromRequest($context.'.limit','limit', $list_limit, 'int'));
        $this->setState('limitstart', JRequest::getVar('limitstart', 0, '', 'int'));
        // In case limit has been changed, adjust limitstart accordingly
        $this->setState('limitstart', ($this->getState('limit') != 0 ? (floor($this->getState('limitstart') / $this->getState('limit')) * $this->getState('limit')) :0));

        $this->setState('filter_order_Dir', $app->getUserStateFromRequest($context.'.filter_order_Dir', 'filter_order_Dir', "ASC"));
        $this->setState('filter_order', $app->getUserStateFromRequest($context.'.filter_order','filter_order', "start_date"));

		$query = $this->buildQuery();
		$list = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
        
		return $list;
    }
    
    function setFiltersList()
    {
    	/*@var $app JApplication*/
		$app	= JFactory::getApplication();
		$context = "com_bids.bids.{$this->_task}";
        $filters = array();
        
        $reset = JRequest::getVar('reset', "");

        if ($reset != "all") {
            $filters["keyword"] = JRequest::getVar('keyword',$app->getUserStateFromRequest($context.'.keyword', 'keyword'));
            $filters["filter_bidtype"] = JRequest::getVar('filter_bidtype',$app->getUserStateFromRequest($context.'.filter_bidtype', 'filter_bidtype', 0));
            $filters["userid"] = JRequest::getVar('userid',$app->getUserStateFromRequest($context.'.userid', 'userid', 0));
            $filters["users"] = JRequest::getVar('users',$app->getUserStateFromRequest($context.'.users', 'users', array()));
            $filters["cat"] = JRequest::getVar('cat',$app->getUserStateFromRequest($context.'.cat', 'cat', 0));
            $filters["filter_type"] = JRequest::getVar('filter_type',$app->getUserStateFromRequest($context.'.filter_type', 'filter_type', null));
			$app->setUserState('com_bids.filter_type', '');
            
        } else {
			// reset filters; set null to state
			$this->setState("filters", array());
			$app->setUserState($context.'.keyword', '');
			$app->setUserState($context.'.filter_bidtype', '');
			$app->setUserState($context.'.userid', '');
			$app->setUserState($context.'.users', '');
			$app->setUserState($context.'.cat', '');
			$app->setUserState($context.'.filter_type', '');
        }


		$Fi = & FactoryFieldsFront::getInstance();
		$Fi->setFiltersToState($filters, $reset);
        $this->_filters = $filters;
    }
	
    function buildQuery()
    {
		$user = &JFactory::getUser();

        $filters = $this->_filters;
		
		if(isset($this->_task)){
			switch ($this->_task){
				case "mybids":{
					$mybids = 1;
					break;
				}
				case "mywonbids":{
					$mywonbids = 1;
					break;
				}
			}
		}
		
    	
		$SelectCols 	= array();
		$JoinList 		= array();
		$WhereClauses 	= array();
		$Orderings	 	= array();

        $filter_order_Dir 	= $this->_db->getEscaped($this->getState('filter_order_Dir'));
        $filter_order 		= $this->_db->getEscaped($this->getState('filter_order'));
		
/**
 * 
 *  Table Fields to select
 * 
 * 
 **/		
		$SelectCols[] 	= " DISTINCT `a`.* ";
		$SelectCols[] 	= " `cat`.`id` as cati, `cat`.`catname`, `catsef`.`categories` as catslug ";
		$SelectCols[] 	= " `cur`.`name` as currency_name ";
		$SelectCols[] 	= " `u`.`username` \r\n ";
		$SelectCols[] 	= " GROUP_CONCAT(DISTINCT `t`.`tagname`) AS alltags  \r\n";
		$SelectCols[] 	= " IF ( COUNT(`pics`.`id`) >0 , 1, 0 ) AS more_pictures  \r\n";
		$SelectCols[] 	= "	COUNT(distinct bids.userid) as nr_bidders \r\n";
		$SelectCols[] 	= "	MAX(bids.bid_price+0) as highest_bid  \r\n";
		$SelectCols[] 	= "	mybids.bid_price as mybid \r\n";
		$SelectCols[] 	= "	MAX(bids.accept) as won_bid \r\n";
		$SelectCols[] 	= "	proxy.max_proxy_price as my_proxy_bid \r\n";
		$SelectCols[] 	= "	mybids.bid_price as total_price \r\n";
		
		
/**
 * 
 *  Where conditions
 *
 *  
 **/
		if ( $w=$this->getState("where") )
			$WhereClauses=$w;

		if(!empty($filters["filter_bidtype"])){
		    switch ($filters["filter_bidtype"])
		    {
		        default:
		        case 0:{
					$WhereClauses[] 	= " (`cat`.`status`=1 OR `cat`.`status` IS NULL ) ";
					$WhereClauses[] 	= " `a`.`close_by_admin` = 0 ";
					$WhereClauses[] 	= " `a`.`close_offer` = 0 ";
					$WhereClauses[] 	= " `a`.`published` = 1 ";
		        }
	            break;
		        case 1:{
					$WhereClauses[] 	= " `a`.`close_by_admin` = 0 ";
					$WhereClauses[] 	= " `a`.`close_offer` = 1 ";
		            break;
			    }
		    }
		}

		if(!empty($filters["filter_bidtype"])){
			switch ($filters["filter_archive"]){
				default:
				case 1:{
					$WhereClauses[] 	= " (`cat`.`status`=1 OR `cat`.`status` IS NULL ) ";
					$WhereClauses[] 	= " `a`.`close_by_admin` = 0 ";
					$WhereClauses[] 	= " `a`.`close_offer` = 0 ";
					$WhereClauses[] 	= " `a`.`published` = 0 ";
					break;
				}
				case 2:{
					$WhereClauses[] 	= " (`cat`.`status`=1 OR `cat`.`status` IS NULL ) ";
					$WhereClauses[] 	= " ((`a`.`close_by_admin` = 1 ) OR (`a`.`close_offer` = 1) OR (`a`.`published` = 0)) ";
					break;
				}
				case 3:{
					$WhereClauses[] 	= " (`cat`.`status`=1 OR `cat`.`status` IS NULL ) ";
					$WhereClauses[] 	= " (`a`.`winner_id` !=0 ) ";
					break;
				}
			}
		}

		// USER LOGGED COMMON
		if($user->id){
		
			$JoinList[] = " LEFT JOIN `#__bids` AS `bids` ON `a`.`id`=`bids`.`id_offer` ";
			if ( ( isset($mybids) && $mybids==1 ) ||   isset($mywonbids) && $mywonbids==1) {
				$JoinList[] = " INNER JOIN `#__bids` AS mybids ON `mybids`.`id_offer`=`a`.`id` AND `mybids`.`userid` = '".$user->id."'  \r\n";
				$JoinList[] = " LEFT JOIN `#__bid_proxy` AS `proxy` ON `mybids`.`id_proxy`=`proxy`.`id` ";
			}
			if(isset($mywonbids) && $mywonbids==1){
				
				$WhereClauses[] = " mybids.accept = 1 ";
			}
		
			$SelectCols[] 	= "  IF ( `a`.`userid` = '" . (int)$user->id . "', 1, 0 ) AS `is_my_auction` ";
	
		}else{

		}
		
		
		$where = "";
		if(count($WhereClauses)>0)
			$where = "WHERE ".implode(" AND ",$WhereClauses);

/**
 * 
 *  Joins
 * 
 **/
		
		$JoinList[] = " LEFT JOIN `#__bid_categories` AS `cat` ON  `a`.`cat`=`cat`.`id` ";
		$JoinList[] = " LEFT JOIN `#__bid_categories_sef` AS `catsef` ON  `a`.`cat`=`catsef`.`catid` ";
		
		$JoinList[] = " LEFT JOIN `#__users` AS `u` ON `u`.`id` = `a`.`userid` ";
        $JoinList[] = " LEFT JOIN `#__bid_users` AS `prof` ON `a`.`userid` = `prof`.`userid` " ;
        
        $JoinList[] = " LEFT JOIN `#__bid_tags` AS `t` ON  `t`.`auction_id`=`a`.`id`  ";
        $JoinList[] = " LEFT JOIN `#__bid_currency` AS `cur` ON  `cur`.`id`=`a`.`currency` ";
        $JoinList[] = " LEFT JOIN `#__bid_pictures` AS `pics` ON `pics`.`id_offer` = `a`.`id` ";
		

// modifies the Join List and the select list
		FactoryFieldsFront::getCustomFieldsJoin($JoinList, $SelectCols, null, array("#__bid_users"=>"prof","#__bid_auctions"=>"a"));


// Featurings first
		$Orderings[]	= "`a`.featured='gold' DESC";
// Required ordering filter		
/*
if($filter_order)
		$Orderings[]	= "{$this->order_fields[$filter_order]} $filter_order_Dir";
*/		
		$Orderings[]	= "`a`.`id` $filter_order_Dir ";
		

$query = " SELECT ".implode(",",$SelectCols)." \r\n ".
		 " FROM `#__bid_auctions` AS `a` \r\n".
		 implode(" \r\n ",$JoinList)."\r\n".
		 $where."\r\n".
		 " GROUP BY `a`.`id` ".
		 " ORDER BY ".implode(",",$Orderings)." \r\n"; 
		
		//echo "<strong>Auctions Bids List QUERY</strong><br /><br />".(str_replace("#__","jos_",  nl2br($query)));exit;
		return $query;
	}
	
    function buildFiltersQuery()
    {
        global $cb_fieldmap;
        $filters = $this->_filters;
        //AdsUtilities::sanitize($filters);

        $where = array();
        
        if (!empty($filters["filter_type"])) {
			// filtering
		    switch ($filters["filter_type"])
		    {
		        default:
		        case 'all':
		            //nothing
		            break;
		        case 'auctions_only':
		            $where[] = ' a.BIN_price<=0 ';
		            break;
		        case 'bin_only':
		            $where[] = ' a.BIN_price>0 ';
		            break;
		    }
        }

        if (!empty($filters["keyword"])) {
            $where[] = "  UCASE(a.title) LIKE UCASE('%" . $filters["keyword"] . "%') ";
        }
        if (!empty($filters["city"])) {
            if (!CB_DETECT) {
                $where[] = " prof.city = '" . $filters["city"] . "' ";
            } else
                $where[] = " cb." . $cb_fieldmap['city'] . "='" . $filters["city"] . "' ";

        }
        if (!empty($filters["userid"])) {
            $where[] = " a.userid = '" . $filters["userid"] . "' ";
        }
        
        if (!empty($filters["users"]) && is_array($filters["users"]) && count($filters["users"]) > 0 ) {
        	
			array_walk($filters["users"], "filter_this");
            $where[] = " a.userid  IN (" . implode(",",$filters["users"]) . " ) ";
        }
        
        if (!empty($filters["country"])) {
            if (!CB_DETECT)
                $where[] = " prof.country = '" . $filters["country"] . "' ";
            else {
                $where[] = " cb." . $cb_fieldmap['country'] . "='" . $filters["country"] . "' ";
            }
        }
        if (!empty($filters["tag"])) {
            $where[] = " t.tagname = '" . $filters["tag"] . "' ";
        }
        
        if (!empty($filters["cat"])) {
            if (!bid_opt_inner_categories)
                $where[] = " a.cat= '" . $filters["cat"] . "' ";
            else{
            	$cat = new JTheFactoryCategoryObj();
            	
            	$cTree = $cat->build_child($filters["cat"],true);
            	$cat_ids = array();
            	if($cTree){
            		foreach ($cTree as $cc){
            			if(isset($cc["id"]) && $cc["id"]!="")
            				$cat_ids[] = $cc["id"];
            		}
            	}
            	if( count($cat_ids) )
            		$cat_ids = implode(",", $cat_ids);
                $where[] = " ( a.cat  IN (" . $cat_ids . ") )";
            }
        }
        
		$Fi = & FactoryFieldsFront::getInstance();
		$Fi->setSQLFilters($where);
        $this->setState( "where", $where );
    }
    
    function getTotal()
    {
        $query = $this->buildQuery();
        return $this->_getListCount($query);
    }
    
    function getPagination()
    {
    	
        // Lets load the content if it doesn't already exist
        if (empty($this->_pagination)) {
            jimport('joomla.html.pagination');
            $this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'),$this->getState('limit'));
        }
        return $this->_pagination;
    }

}
?>