<?php 
// no direct access
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );
jimport( 'joomla.application.component.helper' );

/**
 * @package		Auction Factory
 * @subpackage User Model
 * 
 * @since 2.0
 */
class bidsModelUser extends JModel
{
	var $_name='User';
	
	function getUserData($id)
	{
		$user = new JAuctionUsers($this->_db);
		$user = $user->getUserDetails( $id );
        return $user;
	}
	
    function getCurrentFilters()
    {
        return $this->_filters;
    }
	
	function saveUserDetails(){
		
		$my =& JFactory::getUser();
		$database =& JFactory::getDBO();
		$user = new JAuctionUsers($database);
		if (!$user->load($my->id)){
			//no record yet
			$user->_tbl_key='id';
			$user->id=null;
		}else{
			$user->_tbl_key='userid';
		}
		$user->bind($_POST);
		$user->userid=$my->id;
		$date =& JFactory::getDate(time());
		$user->modified = $date->toMySQL();
		$s = $user->store();
		
		if($s==true){
			
			$act = JRequest::getCmd("act",null);
			if($act=="savesettings"){
			    if (bid_opt_allow_user_settings)
			    {
			
					$us = new JAuctionUserDefaults($database);
			        $us->userid = $my->id;
			        $settings = array();
			        //Yes/No Option
			        $settings["show_reserve"] =JRequest::getInt("show_reserve",0);
			        $settings["picture"] =JRequest::getInt("picture",0);
			        $settings["add_picture"] = JRequest::getInt( "add_picture",0);
			        $settings["auto_accept_bin"] =JRequest::getInt( "auto_accept_bin",0);
			        $settings["bid_counts"] =JRequest::getInt("bid_counts",0);
			        $settings["max_price"] =JRequest::getInt("max_price",0);
			        
			        //Time and Date
			        $settings["end_hour"] =JRequest::getString("end_hour",'');
			        $settings["end_minute"] = JRequest::getString("end_minute",'');
			
			        $settings["auction_type"] = JRequest::getInt("auction_type",null);
			        $settings["currency"] = JRequest::getInt( "currency",0);
			        $settings["shipment_info"] = JRequest::getString("shipment_info",'');
			        $settings["shipment_price"] = JRequest::getFloat("shipment_price",0);
			        $settings["payment_info"] = JRequest::getString( "payment_info",'');
			
			        if (bid_opt_payment_select_mode == 0)
			        {
			
			            $o = JRequest::getVar( "payment_options",null);
			
			            $settings["payment_options"] = implode(",", $o);
			
			        }
			
			        $us->saveUserSettings($settings);
			    }
			}
			
		}
		
		return $s;
	}
	
	function getUsers(){
		$app	= JFactory::getApplication();
        
        $this->setFiltersList();
        $this->buildFiltersQuery();
        $config = &JFactory::getConfig();
        
        if ( defined("bid_opt_nr_items_per_page") && bid_opt_nr_items_per_page > 0 )
        	$list_limit = bid_opt_nr_items_per_page;
        else
			$list_limit = $config->getValue('config.list_limit');
			

        // Get the pagination request variables
        $this->setState('limit', $app->getUserStateFromRequest('com_bids.limit','limit', $list_limit, 'int'));
        $this->setState('limitstart', JRequest::getVar('limitstart', 0, '', 'int'));
        // In case limit has been changed, adjust limitstart accordingly
        $this->setState('limitstart', ($this->getState('limit') != 0 ? (floor($this->getState('limitstart') / $this->getState('limit')) * $this->getState('limit')) :0));

        $this->setState('filter_order_Dir', $app->getUserStateFromRequest('com_bids.filter_order_Dir', 'filter_order_Dir', "ASC"));
        $this->setState('filter_order', $app->getUserStateFromRequest('com_bids.filter_order','filter_order', "start_date"));

		$query = $this->buildQuery();
		$list = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
        
		return $list;
	}
	
    function setFiltersList()
    {
    	
    	$context = "com_bids.user";
		$app	= JFactory::getApplication();
        $filters = array();
        
		$this->setState('filter_archive', $app->getUserStateFromRequest("$context.filter_archive", 'filter_archive', "0"));

        $reset = JRequest::getVar('reset', "");

        if ($reset != "all") {
            $filters["search_type"] = JRequest::getVar('search_type',$app->getUserStateFromRequest("$context.search_type", 'search_type'));
            $filters["keyword"] = JRequest::getVar('keyword',$app->getUserStateFromRequest("$context.keyword", 'keyword'));
            $filters["name"] = JRequest::getVar('name',$app->getUserStateFromRequest("$context.name", 'name'));
            $filters["country"] = JRequest::getVar('country', $app->getUserStateFromRequest("$context.country", 'country'));
            $filters["city"] = JRequest::getVar('city', $app->getUserStateFromRequest("$context.city", 'city'));
            $filters["email"] = JRequest::getVar('email', $app->getUserStateFromRequest("$context.email", 'email'));
            $filters["im"] = JRequest::getVar('skype', $app->getUserStateFromRequest("$context.im", 'im'));

        } else {
			// reset filters; set null to state
			$this->setState("filters", array());
			$app->setUserState("context.search_type", '');
			$app->setUserState("context.keyword", '');
            $app->setUserState("context.country", null);
            $app->setUserState("context.city", null);
        }

		$Fi = & FactoryFieldsFront::getInstance();
		$Fi->setFiltersToState($filters, $reset);
        $this->_filters = $filters;
    }
    
    function buildQuery()
    {
		$user = &JFactory::getUser();
		
    	$SelectCols 	= array();
    	$JoinList 		= array();
    	$WhereClauses 	= array();
		$Orderings	 	= array();

        $filter_order_Dir 	= $this->_db->getEscaped($this->getState('filter_order_Dir'));
        $filter_order 		= $this->_db->getEscaped($this->getState('filter_order'));
		
/**
 * 
 *  Table Fields to select
 * 
 * 
 **/		
		$SelectCols[] 	= " `u`.* ";
		
		JTheFactoryUserProfile::getListJoin(defined("bid_opt_profile_mode")?bid_opt_profile_mode:"",1,$JoinList,$SelectCols);
/**
 * 
 *  Where conditions
 *
 *  
 **/
		if ( $w=$this->getState("where") )
			$WhereClauses=$w;
			
		
		$where = "";
		if(count($WhereClauses)>0)
			$where = "WHERE ".implode(" AND ",$WhereClauses);
		
		if (!defined("bid_opt_profile_mode") || bid_opt_profile_mode=="component"){
			FactoryFieldsFront::getCustomFieldsJoin($JoinList, $SelectCols, "user_profile", array("#__bid_users"=>"prof"));
			$SelectCols[] = "`cnt`.name as country_name ";
	      $JoinList[] = " LEFT JOIN `#__bid_country` AS `cnt` ON  `cnt`.`id`=`prof`.`country`  ";
		}

		$SelectCols[] = "'null' as password";
		$SelectCols[] = "sum(rating)/count(*) as rating_overall";
		$SelectCols[] = "count(DISTINCT au.id) as nr_auctions";
		$SelectCols[] = "count(DISTINCT bi.id) as nr_bids";
		$JoinList[] = " LEFT JOIN `#__bid_rate` AS `r` ON  `r`.user_rated=`u`.`id`  ";
		$JoinList[] = " LEFT JOIN `#__bid_auctions` AS `au` ON  `au`.userid=`u`.`id`  ";
		$JoinList[] = " LEFT JOIN `#__bids` AS `bi` ON  `bi`.userid=`u`.`id`  ";

// Required ordering filter		
if(isset($filter_order) && isset($this->order_fields[$filter_order]) )
		$Orderings[]	= "{$this->order_fields[$filter_order]} $filter_order_Dir";
		
		$Orderings[]	= "`u`.`id` $filter_order_Dir ";
		

$query = " SELECT ".implode(",",$SelectCols)." \r\n ".
		 " FROM `#__users` AS `u` \r\n".
		 implode(" \r\n ",$JoinList)."\r\n".
		 $where."\r\n".
		 " GROUP BY `u`.`id` ".
		 " ORDER BY ".implode(",",$Orderings)." \r\n"; 
		
		//echo "<strong>Users List QUERY</strong><br /><br />".(str_replace("#__","jos_",  nl2br($query)));exit;
		return $query;
	}
	
    function buildFiltersQuery()
    {
        global $cb_fieldmap;
        $filters = $this->_filters;
        $where = array();

        if (!empty($filters["keyword"])) {
            $keword = array();
            $keword[] = "  u.username LIKE ('%" . $filters["keyword"] . "%') ";
            $keword[] = "  prof.name LIKE ('%" . $filters["keyword"] . "%') ";
            $keword[] = "  prof.surname LIKE ('%" . $filters["keyword"] . "%') ";
            $where[] = "(" . implode(" OR", $keword) . " )";
        }
        
        if (!empty($filters["name"])) {
            $keword = array();
            $keword[] = "  prof.name LIKE ('%" . $filters["name"] . "%') ";
            $keword[] = "  prof.surname LIKE ('%" . $filters["name"] . "%') ";
            $where[] = "(" . implode(" OR", $keword) . " )";
        }
        
		if (!empty($filters["country"])) {
			
			$where[] = "( prof.country = '".$filters["country"]."' )";
			
        }

		if (!empty($filters["search_type"])) {
			
			switch ($filters["search_type"]){
				default:{
					break;
				}
				case "1":{
					$where[] = "( prof.isBidder = '1' )";
					break;
				}
				case "2":{
					$where[] = "( prof.isSeller = '1' )";
					break;
				}
			}

        }
        
        
		$Fi = & FactoryFieldsFront::getInstance();
		$Fi->setSQLFilters($where);
        $this->setState( "where", $where );
    }
    
    function getTotal()
    {
        $query = $this->buildQuery();
        return $this->_getListCount($query);
    }
    
    function getPagination()
    {
    	
        // Lets load the content if it doesn't already exist
        if (empty($this->_pagination)) {
            jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'),$this->getState('limit'));
        }
        return $this->_pagination;
    }
	
}


?>