<?php
/**
 * @package AuctionsFactory
 * @version 2.0.0
 * @copyright www.thefactory.ro
 * @license: commercial
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

global $allow_counter, $display_subcategories_nr;

$allow_counter					= (int) $params->get('category_counter', 0);
$display_subcategories_nr	= (int) $params->get('display_subcategories_nr', 0);
$collapsed						= $params->get('collapsed', true);
$fold_speed						= (int) $params->get('fold_speed', 250);
$theming							= $params->get('theming', "default");


$jdoc = &JFactory::getDocument();

/**
 * JQuery Loading
 */
$j_loaded = false;

foreach ($jdoc->_scripts as $j => $jj)
	if (strstr($j, "jquery.js") !== false){
		$j_loaded = true;
		break;
	}

if( !$j_loaded ){
	$jdoc->addScript('components/com_bids/js/jquery/jquery.js');
	$jdoc->addScript('components/com_bids/js/jquery/jquery.noconflict.js');
}


$jdoc->addScript('components/com_bids/js/jquery/jquery.cookie.js');
$jdoc->addScript('components/com_bids/js/jquery/tree/jquery.treeview.js');

$theme_css = "";
switch ($theming) {
	case "default":
		$theme_css = JURI::root()."components/com_bids/js/jquery/tree/jquery.treeview.css";
		break;
		
	case "red":
		$theme_css = JURI::root()."components/com_bids/js/jquery/tree/themes/red/jquery.treeview.css";
		break;

	case "azuro":
		$theme_css = JURI::root()."components/com_bids/js/jquery/tree/themes/azuro/jquery.treeview.css";
		break;
		
	case "green":
		$theme_css = JURI::root()."components/com_bids/js/jquery/tree/themes/green/jquery.treeview.css";
		break;
	default:
		$theme_css = JURI::root()."components/com_bids/js/jquery/tree/jquery.treeview.css";
		break;
}
$jdoc->addStyleSheet($theme_css);

$mod_rbids_js = "
		jQuery(document).ready(function(){
			jQuery(\"#bids_treecontainer_{$module->id}\").treeview( { collapsed: {$collapsed}, animated: {$fold_speed},	persist: \"cookie\" });
		    document.getElementById('bids_treecontainer_{$module->id}').style.display='block';
		});
";

$jdoc->addScriptDeclaration( $mod_rbids_js );

require_once(JPATH_ROOT."/components/com_bids/options.php");

if(!class_exists("modAuctionCategoryTreeHelper")){
	class modBidsCategoryTreeHelper{
		
		
		function getCategories($categoryID=0){
			
			$database = &JFactory::getDbo();
			
			$cat_filter = null;
			$cat = (int)$categoryID;
			$cat_filter = " c.parent = ".$database->Quote($cat);
		
			if(bid_opt_inner_categories){
				$category_join = "
		           a.cat = c.id OR  \r\n
		           a.cat = d.id OR  \r\n
		           a.cat = e.id OR  \r\n
		           a.cat = f.id OR  \r\n
		           a.cat = g.id OR  \r\n
		           a.cat = h.id OR  \r\n
		           a.cat = i.id OR  \r\n
		           a.cat = j.id \r\n
		        	";
	        }else{
	        	$category_join = " a.cat = c.id ";
	        }
			
			$database->setQuery(" 
			SELECT c . * , COUNT( DISTINCT a.id ) as nr_a   
			\r\n".
			" FROM #__bid_categories AS c  \r\n".
		    " LEFT JOIN `#__bid_categories` d ON c.id = d.parent  \r\n".
		    " LEFT JOIN `#__bid_categories` e ON d.id = e.parent  \r\n".
		    " LEFT JOIN `#__bid_categories` f ON e.id = f.parent  \r\n".
		    " LEFT JOIN `#__bid_categories` g ON f.id = g.parent  \r\n".
		    " LEFT JOIN `#__bid_categories` h ON g.id = h.parent  \r\n".
		    " LEFT JOIN `#__bid_categories` i ON h.id = i.parent  \r\n".
		    " LEFT JOIN `#__bid_categories` j ON i.id = j.parent \r\n".
		    " LEFT JOIN `#__bid_auctions` AS a ON ".
		    " ( 
				$category_join
		     AND a.close_offer=0 AND a.start_date<=now() AND a.published=1 
		    )
		    \r\n".
			" GROUP BY c.id  order by c.id,c.ordering,catname asc
			");
			
			$dbrows = $database->loadObjectList();
			//echo nl2br($database->_sql);exit;
			
			$cats = array();
			if($dbrows)
			foreach ($dbrows as $k =>$rw){
				$cats[$rw->parent][] = $rw;
			}
			
			return $cats;
			
		}
		
		function catHTML($catId=0, $allCategories, $level){
			
			global $allow_counter,$display_subcategories_nr; 
			
			if(isset($allCategories[$catId])){
				
				foreach ($allCategories[$catId] as $c => $item){
					
					$ciu = $item->id." - ".$item->catname;
					
					$link_cat = JRoute::_("index.php?option=com_bids&task=listauctions&cat=".$item->id);
					
					$class_name = isset($allCategories[$item->id])?"folder":"file";
					
					$cat_counter = "";
					$counter = "";

			/**
			 * Auction Counter HTML
			 * 
			 */
					if($allow_counter==1){
						$counter = " ( {$item->nr_a}  ) ";
					}
			/**
			 * Subcategories Counter HTML
			 * 
			 */
					if($display_subcategories_nr==1){
						
						if (isset($allCategories[$item->id])) {
							$cat_counter = " ( ".count($allCategories[$item->id]). " ) ";
						}else 
							$cat_counter = "(0)";
					}
	
					
					echo "<li  style='list-style:none'>\r\n
					<span class='{$class_name} category_css'>\r\n
						<a href='$link_cat'>".$item->catname." ".$counter.$cat_counter."</a>\r\n
					</span>\r\n";
					
					if(isset($allCategories[$item->id])){
						echo "<ul id='bids_treecontainer' class='filetree closed' style='display:none'>\r\n";
						modBidsCategoryTreeHelper::catHTML( $item->id, $allCategories, $level+1 );
						echo "</ul>\r\n";
					}
					echo "</li>\r\n";
				}
			}else
				return;
			
		}
		
	}
	
}

$cats = modBidsCategoryTreeHelper::getCategories();
echo "<ul id='bids_treecontainer_{$module->id}' class='filetree closed' style='display:none'>\r\n";
modBidsCategoryTreeHelper::catHTML(0,$cats,1);
echo "</ul>\r\n";

?>