<?php

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
/**
 * 	0 => "latest_auctions",
 * 	1 => "popular_auctions",
 * 	2 => "most_valuable",
 * 	3 => "random_auctions",
 * 	4 => "featured_auctions"
 *
 */
class modBidsHelper{
	
	
	function getRecords( &$params ){
		
		$limit = $params->get("nr_auctions_displayed",5);
		$dbo = & JFactory::getDBO();
		$dbo->setQuery( modBidsHelper::getQuery($params), 0 , $limit );
		$list = $dbo->loadObjectList();
		return $list;
	}
	
	function getQuery( &$params ){
		
		$module_type		=	$params->get("type_display",0);
		$sort_by				=	$params->get("sort_by","start_date");
		
		$selectCols = array(
			"a.id",
			"a.title",
			"a.userid",
			"a.auction_type",
			"a.initial_price",
			"a.picture",
			"c.name",
			"u.username as by_user",
			"a.start_date",
			"a.end_date"
		);
		
		$where = array(
			"a.published = 1",
			"a.close_offer!=1",
			"a.close_by_admin!=1",
			"a.start_date <= NOW()"
		);
		
		$orderings = array();
		
		modBidsHelper::_paramQuery($params, $selectCols, $where, $orderings );
		
		$orderings[] = "a.$sort_by DESC"; 
		
		$query="SELECT ".implode(",",$selectCols).PHP_EOL.
		"FROM `#__bid_auctions` as a ".PHP_EOL.
		"LEFT JOIN `#__bids` as b ON a.id=b.id_offer ".PHP_EOL.
		"LEFT JOIN `#__bid_currency` as c on a.currency=c.id ".PHP_EOL.
		"LEFT JOIN `#__users` as u on a.userid=u.id ".PHP_EOL.
		"WHERE ".implode(" AND ",$where)." ".PHP_EOL.
		"GROUP BY a.id ".PHP_EOL.
		"ORDER BY ".implode(",",$orderings);
		
		return $query;
	}
	
	function _paramQuery( $params, &$selectCols , &$where, &$orderings ){
		
		$module_type		=	$params->get("type_display",0);
		
		$filter_featured	=	$params->get("featured","");
		if ( $filter_featured ) 
			$filter_featured	=	"a.featured='$filter_featured'";
			
		
		switch ($module_type){
			case '0':
				//
			break;
			case '1':
				if ($filter_featured) {
					$where[] = $filter_featured;
				}
				$orderings[] = "a.hits";
			break;
			case '2':
				if ($filter_featured) {
					$where[] = $filter_featured;
				}
				$orderings[] = "b.bid_price+0 DESC ";
			break;
			case '3':
				if ($filter_featured) {
					$where[] = $filter_featured;
				}
				$orderings[] = "RAND()";
			break;
			case '4':
				if ($filter_featured) {
					$where[] = $filter_featured;
				}
				else
					$where[] = "a.featured<>'none'";
			break;
			default:
				//
			break;
		}
		
	}
	
	function renderAuctionTiming( &$auction ){
		
		$now = BidTimeUtilities::getNow();
		
		if ( bid_opt_enable_countdown ){
			
            $expiredate = BidTimeUtilities::getTimeStamp( $auction->end_date );
            $diff=$expiredate-$now;
            if ($diff>0){
                $s=sprintf("%02d",$diff%60);
                $diff=intval($diff/60);
                $m=sprintf("%02d",$diff%60);
                $diff=intval($diff/60);
                $h=sprintf("%02d",$diff%24);
                $d=intval($diff/24);

                if ($d>0) $auction->countdown="$d ".JText::_("days").", $h:$m:$s";
                else $auction->countdown="$h:$m:$s";

            }else{
                $auction->countdown = JText::_("Expired");
            }
		}
		if(BidTimeUtilities::getTimeStamp($auction->end_date) <= BidTimeUtilities::getNow() ){$auction->expired=true;}else $auction->expired=false;
		
	    $auction->start_date_text = date(bid_opt_date_format,strtotime($auction->start_date));
	    //$auction->start_date_text = print_formatedDate($auction->start_date,0);
		
	    if($auction->end_date && $auction->end_date!='0000-00-00 00:00:00' ) {
			if(bid_opt_enable_hour){
				$dateformat=bid_opt_date_format." H:i";
			}else $dateformat=bid_opt_date_format;

			$auction->end_date_text=date($dateformat,strtotime($auction->end_date));
		   //$auction->end_date_text = print_formatedDate($auction->end_date,1);
		}
	}
}

?>