<?php
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent( 'onSearch', 'plgSearchBids' );
$mainframe->registerEvent( 'onSearchAreas', 'plgSearchBidsAreas' );


/**
 * @return array An array of search areas
 */
function &plgSearchBidsAreas()
{
	static $areas = array(
		'bids' => 'Auctions'
	);
	return $areas;
}

function plgSearchBids( $text, $phrase='', $ordering='', $areas=null )
{
	$db		=& JFactory::getDBO();
	$user	=& JFactory::getUser();

	$searchText = $text;


	// load plugin params info
 	$plugin =& JPluginHelper::getPlugin('search', 'bids');
 	$pluginParams = new JParameter( $plugin->params );

	$limit = $pluginParams->def( 'search_limit', 50 );

	$text = trim( $text );
	if ($text == '') {
		return array();
	}
	$section 	= JText::_( 'Auction Factory' );

	$wheres 	= array();
	switch ($phrase)
	{
		case 'exact':
			$text		= $db->Quote( '%'.$db->getEscaped( $text, true ).'%', false );
			$wheres2 	= array();
			$wheres2[] 	= 'a.shortdescription LIKE '.$text;
			$wheres2[] 	= 'a.title LIKE '.$text;
			$where 		= '(' . implode( ') OR (', $wheres2 ) . ')';
			break;

		case 'all':
		case 'any':
		default:
			$words 	= explode( ' ', $text );
			$wheres = array();
			foreach ($words as $word)
			{
				$word		= $db->Quote( '%'.$db->getEscaped( $word, true ).'%', false );
				$wheres2 	= array();
				$wheres2[] 	= 'a.shortdescription LIKE '.$word;
				$wheres2[] 	= 'a.title LIKE '.$word;
				$wheres[] 	= implode( ' OR ', $wheres2 );
			}
			$where 	= '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
			break;
	}

	switch ( $ordering ) {
		case 'alpha':
			$order = 'title ASC';
			break;

		case 'category':
			$order = 'catname ASC, title ASC';
			break;

		case 'oldest':
			$order = 'start_date ASC, title ASC';
			break;
		case 'newest':
			$order = 'start_date DESC, title ASC';
			break;
		case 'popular':
		default:
			$order = 'hits DESC';
	}
	require_once (JPATH_ROOT.DS.'components'.DS.'com_bids'.DS.'helpers'.DS.'helper.php');
	$tmp_id = BidsUtilities::getMenuItemId(array("task"=>"listauctions"));
	if( !$tmp_id )
	  $tmp_id = BidsUtilities::getMenuItemId(array("view"=>"auctions", "layout"=>""));

	$query = "SELECT title AS title,"
	. "\n start_date AS created,"
	. "\n shortdescription AS text,"
	. "\n concat('Cat: ',catname) AS section,"
	. "\n CONCAT( 'index.php?option=com_bids&task=viewbids&Itemid={$tmp_id}&id=', a.id ) AS href,"
	. "\n '1' AS browsernav"
	. "\n FROM #__bid_auctions a "
	. "\n LEFT JOIN #__bid_categories AS b ON b.id = a.cat"
	. "\n WHERE ( $where )"
	. "\n AND a.published = 1 and a.start_date<now()"
	. "\n ORDER BY $order"
	;

	$db->setQuery( $query, 0, $limit );
	$rows = $db->loadObjectList();

	$return = array();
	foreach($rows AS $key => $weblink) {
		if(searchHelper::checkNoHTML($weblink, $searchText, array('url', 'text', 'title'))) {
			$return[] = $weblink;
		}
	}

	return $return;
}
