<?php
/**
 * @package Reverse Auctions Factory
 * @since 1.2.0
 * @copyright www.thefactory.ro
 * @license: commercial
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

require_once(dirname(__FILE__).DS."payment_log.php");     

class payment_object
{
    var $_db			  = null;
    var $classname		  = "payment_object";
    var $classdescription = "generic Payment method";
    var $param_text;
    var $params			  = null;
    var $enabled		  = null;
    var $isdefault		  = null;

	function payment_object(&$db)
	{
            $this->_db=$db;
            $this->_db->setQuery("select params,enabled,isdefault from #__bid_paysystems where classname='$this->classname'");
            $r=$this->_db->loadRow();

            $this->param_text=@$r[0];
            $this->enabled=@$r[1];
            $this->isdefault=@$r[2];
            
            $this->params=new JParameter($this->param_text);
            $this->loadPluginLanguage();
	}
	
	function loadPluginLanguage()
	{
		
		$lang =& JFactory::getLanguage();
    	$lng = substr($lang->_lang,0,2);
    	
	    if(file_exists(dirname(__FILE__).DS."{$this->classname}.$lng.php")){
	        require_once(dirname(__FILE__).DS."{$this->classname}.$lng.php");
	    }elseif (file_exists(dirname(__FILE__).DS."{$this->classname}.en.php"))
	        require_once(dirname(__FILE__).DS."{$this->classname}.en.php");
	    
	}
	
	function ipn($d)
	{
	    //IPN Processing
	    return;
	}
	
	function checkout($d)
	{

        //Checkout
       	$my = & JFactory::getUser();

        
        $itemname   	 = JArrayHelper::getValue($d,'itemname','');
        $itemamount 	 = (int)JArrayHelper::getValue($d,'itemamount',1);
        $return_url 	 = JArrayHelper::getValue($d,'return_url',null);
        $price_classname = "price_$itemname";
        
        if (file_exists(dirname(__FILE__).DS."../pricing/$price_classname.php")){
            require_once(dirname(__FILE__).DS."../pricing/$price_classname.php");
        }else{
            echo bid_err_no_payment_item;
            return;
        }

        $price_class=new $price_classname($this->_db);

        $item_description = $price_class->getDescription();
		$value = $price_class->getPrice($d);
		//$value = ;
        
        $currency = $price_class->getCurrency($d);
// Invoice actually
        $order_id = $price_class->initiateOrder();
// + since 1.4.0
// If BUY stuff for a specific item ; else could buy plain credits for later ussage
		$object_id = JRequest::getVar("id",null);

		

/**
 * Checkout starts with adding the payment to log pending like
 *  TO DO: move this in an action exactly when redirecting to the payment portal
 * 
*/
		$log = new JTheFactoryPaymentLog($this->_db);
		$log->_tbl_key = "invoice";
		
		$session  = & JFactory::getSession();	
		$cuc = $session->get("current_order");
		$log->load($order_id);
        $hour = date("H",time());
		
		if(1 || (!$log->id && $cuc!=($value*$itemamount)." ".$object_id." ".$hour) ){
			$session->set("current_order",($value*$itemamount)." ".$object_id." ".$hour);
			$log->_tbl_key = "id";
	        $log->date=date('Y-m-d h:i:s');
			$log->invoice = $order_id;
			$log->amount = ($value*$itemamount);
			$log->object_id = $object_id;
			$log->userid = $my->id;
			$log->ipn_ip = "Payment Waiting";
			$log->currency = $currency;
			$log->itemname = $itemname;
	        $log->var_name1 = trim(stripslashes($_REQUEST['var_name1']));
	        $log->var_name2 = trim(stripslashes($_REQUEST['var_name2']));
	        $log->var_name3 = trim(stripslashes($_REQUEST['var_name3']));
	        $log->var_name4 = trim(stripslashes($_REQUEST['var_name4']));
			
	        $log->var_value1 = trim(stripslashes($_REQUEST['var_value1']));
	        $log->var_value2 = trim(stripslashes($_REQUEST['var_value2']));
	        $log->var_value3 = trim(stripslashes($_REQUEST['var_value3']));
	        $log->var_value4 = trim(stripslashes($_REQUEST['var_value4']));
			$log->store();
		}
		$this->show_payment_form($order_id,$item_description,$itemname,$itemamount,$value,$currency,$return_url);
    }
    
	function show_payment_form($order_id,$item_description,$itemname,$quantity,$price,$currency,$return_url=null)
    {
        //Here comes the HTML for the payment form

    }
    
	function show_admin_config()
    {
        //admin

    }
    
	function save_admin_config()
    {
        //save
    }
    
	function accept_ipn($d,$order_id,$price_classname,$quantity,$amount_received,$currency_code)
    {
        if (file_exists(dirname(__FILE__).DS."../pricing/$price_classname.php")){
            require_once(dirname(__FILE__).DS."../pricing/$price_classname.php");

            $price_class=new $price_classname($this->_db);

            $value=$quantity*$price_class->getPrice($d);
            $currency=$price_class->getCurrency($d);

            if($amount_received==$value && $currency_code==$currency){
                $price_class->acceptOrder($order_id,$quantity);
                return true;
            }else{
                return false;
            }
        }else return false;

    }

	function getLogo()
	{
	   $base = JURI::root();
	   
	   if (file_exists(dirname(__FILE__).DS."{$this->classname}.gif"))
			return $base."components/com_bids/plugins/payment/{$this->classname}.gif";
	   if (file_exists(dirname(__FILE__).DS."{$this->classname}.png"))
			return $base."components/com_bids/plugins/payment/{$this->classname}.png";
	   if (file_exists(dirname(__FILE__).DS."{$this->classname}.jpg"))
	       return $base."components/com_bids/plugins/payment/{$this->classname}.jpg";
	
	   return $base."components/com_bids/plugins/payment/payment.jpg";
	}

}



?>