<?php

/**
 * @package Auctions Factory
 * @version 2.0.0
 * @copyright www.thefactory.ro
 * @license: commercial
*/

// no direct access
//defined( '_JEXEC' ) or die( 'Restricted access' );
require_once(dirname(__FILE__).DS."pricing_object.php");


class price_comission extends generic_pricing
{

	var $_param_members = array(
		'preferential_categories', 
		'default_price_categories', 
		'prices_categories', 
		'commisionable_categories'
	);
	
    function price_comission(&$db) {
        $this->classname = 'price_comission';
        $this->classdescription='Module for Auction Winners Commission';
        parent::generic_pricing($db);
    }
    function getCurrency($d) {
        $currency = JRequest::getVar('var_value1','');
        return $currency;
    }
    
    function getPrice($d){
    	
        $price = JRequest::getVar('itemprice','');
        // For checkout
        if(isset($price) && $price!="") return $price;
        
		if($this->preferential_categories==1){
			$cati = JRequest::getVar('category','');
			$id = JRequest::getVar('id','');
			if(isset($cati) && $cati>0)
				return $this->price*price_comission_DBHelper::getPrice($cati);
			elseif( isset($id) && $id>0 && $cati = price_comission_DBHelper::getCategory($id) )
				return $this->price*price_comission_DBHelper::getPrice($cati);
			else	
				return $this->price;
		}else 
			return $this->price;
    }

    function acceptOrder($order_id,$amount, $currency_name="")
    {
		if( $order_id!="" ){
			if($currency_name){
				$this->_db->setQuery("select * from #__bid_currency where name='$currency_name'");
				$currency = $this->_db->loadObject();
			}else{
        		$cati = (int)JRequest::getVar('id',0);
			    if (!$id){
            		$cid = JRequest::getVar('cid',array());
			    	$id=$cid[0];
			    }
				$this->_db->setQuery("select currency from #__bid_paylog where id='$id'");
				$currency_tmp = $this->_db->loadObject();
				$this->_db->setQuery("select * from #__bid_currency where name='{$currency_tmp->currency}'");
				$currency = $this->_db->loadObject();
			}
			
         $amount = $order_id->amount;
			$this->updateBalance($order_id->userid,-$amount,$currency->id,1);
		}
    }
    
    
    function checktask($task,$d) {
    	
		require_once(dirname(__FILE__).DS."../payment/pay_paypal.en.php");	    
		
		global $Itemid;
		$my = & JFactory::getUser();
		$db = & JFactory::getDBO();
		
		$credits = $this->getCredits($my->id);
		
		$id = JRequest::getVar('id', null);
		$islogged = 0;
		
		if($id){
		
			$sql = "SELECT COUNT(*) FROM ".PAYTABLE_PAYLOG." WHERE object_id = '$id' AND itemname = '{$this->itemname}' AND ( status <> 'ok' OR ISNULL(status ) )  ";
			$db->setQuery($sql);
			$islogged = $db->loadResult();
		
		}

		$this_price = $this->price;
		
		if ($task=='accept'){
			
			$bid_id = JRequest::getVar('bid', null);
			
			$this->_db->setQuery("select * from #__bids where id='$bid_id'");
			$bid_res = $this->_db->loadObject();
			
			// auction_id
			$auct_id = $bid_res->id_offer;
			   
			$bid_price = $bid_res->bid_price;
			$cati = price_comission_DBHelper::getCategory($auct_id);
			$procent = price_comission_DBHelper::getPrice($cati);
			
			// comission calculation
			$bid_comission = ($bid_price * $procent ) / 100;
			$auction = new JAuctions($this->_db);
			$auction->load($auct_id);
			$userid = $auction->userid;
			
			$this->_db->setQuery("INSERT INTO #__bid_comissions SET userid='$userid', bid_id='$bid_id', auction_id='$auct_id', amount = '$bid_comission', comission_date = NOW(), currency = '$auction->currency'");
			$this->_db->query();
			
			$this->updateBalance($userid,$bid_comission, $auction->currency);
			
		}
        
		if ($task=='pay_comission' ){
		
			$d['return_url']=JURI::root().'/index.php?option=com_bids&task=pay_comission_set';
			$this->ShowPurchaseDialog( $d );
			return true;
			
		}
		
		if ($task=='payment'){
	        
			// The Order Number (not order_id !)
			$invoice =  trim(stripslashes($_POST['invoice']));
			$payment_status = trim(stripslashes($_POST['payment_status']));
			
			if($invoice){
			require_once(dirname(__FILE__).DS."..".DS."payment".DS."payment_log.php");
			$log = new JTheFactoryPaymentLog($this->_db);
			$log->_tbl_key = "invoice";
			
			$log->load($invoice);
			
			// If pending (IPN not runned yet for misc reasons )
			if( ( $payment_status == "Completed" || $payment_status == "Processed" || $payment_status == "In-Progress" || $payment_status == "Pending" ) && $log->status!="ok"){
			if($aid = $log->object_id)
				FactoryLayer::redirect('index.php?option=com_bids&task=viewbids&id='.$aid,"Payment Succesfully! Waiting for approval!");
			else
				FactoryLayer::redirect('index.php?option=com_bids',"Payment Succesfully! Waiting for approval!");
			return true;
			}else{
			if($aid = $log->object_id)
				FactoryLayer::redirect('index.php?option=com_bids&task=details&id='.$aid,"Payment Succesfully!");
			}
			}
			
		}
			
		return false;
    }
    
	// CONSUME CREDITS
    function consume_credits($nr_credits=1,$user_id){
    	// not based on credits
    }

    function ShowPurchaseDialog($d) {
        
        global $Itemid;
        $database = & JFactory::getDBo();
			$id=JRequest::getVar('id','');
			$return_url=JURI::root()."/index.php?option=com_bids&view=bids&task=myuserprofile&&Itemid={$Itemid}";

		$my= & JFactory::getUser();
		$smarty = BidsUtilities::SmartyLoaderHelper();

		$userid = $my->id;
		$opts=null;
		$database->setQuery( "SELECT c.name as text, c.name as value, b.* FROM #__bid_balance b LEFT JOIN #__bid_currency c ON b.currency = c.id WHERE b.auctioneer = $my->id" );
		$opts = $database->loadObjectList();
        
		$currency = "";
		$lists['currency']=	JHTML::_("select.genericlist", $opts, 'currency', 'class="inputbox" ',  'value', 'text');

        $rows=$this->_db->LoadObjectList();
        $smarty->assign('pricing',$opts);
        $smarty->assign('user',$my);
        $smarty->assign('item_object',$this);
        $smarty->assign('paymenttype','');
        $smarty->assign('return_url',$return_url);
		$smarty->display('plugins/t_buy_commission.tpl');
    }
    
    /**
     * This is the same for Featuring Listing
     * override function in pricing class for custom handling
     * 
     *
     * @param int/object $order (ad id or log object)
     */
    function update_object($order){
		// no object assignable
    }


    
/**
 * 
 * 
 * ADMINISTRATION TASKS
 * 
 * 
 * 
 */
    
    function show_admin_config() {
    	
        $action = JRequest::getVar('action','');
        ?>
		<fieldset>
			<legend><?php echo JText::_("Payment Item")." ".$this->itemname;?></legend>
        <h2><?php echo JText::_("Payment Item")." ".$this->itemname;?></h2>
        <table class="admintable" width="100%">
        	<tr>
        		<td valign="top" class="paramlist key"><?php price_comission_AdminHelper::plugin_menu();?></td>
        		<td valign="top" style="border:2px solid #DEDEDE;">
			        <?php
					
					switch ($action){
						case "list": price_comission_AdminHelper::list_items(); break;
						case "view": price_comission_AdminHelper::list_comissions_list(); break;
						case "payments": price_comission_AdminHelper::list_payments_list();break;
						case "add_payment": price_comission_AdminHelper::add_payment();break;
						case "save_payment": price_comission_AdminHelper::save_payment();break;
						case "send_notice": price_comission_AdminHelper::sendNotice(); break;
						case "send_notice_form": price_comission_AdminHelper::sendNoticeForm(); break;
						case "send_notice_all": price_comission_AdminHelper::sendNoticeAll(); break;
						default:price_comission_AdminHelper::config();break;
					}
					
			    	?>
        		</td>
        	</tr>
        </table>
        </fieldset>
	     <?php
    }
    
    
    function save_admin_config()
    {
        $action = JRequest::getVar('action','');
        
		$commisionable_categories = JRequest::getVar('commisionable_categories',null,$_REQUEST,'array');
		if($commisionable_categories){
			$_REQUEST["commisionable_categories"] = implode(",",$commisionable_categories);
		}
		//exit;
        switch($action){
        	case "add_custom_pricing":
        		$this->add_custom_pricing();
				FactoryLayer::redirect("index.php?option=com_bids&task=paymentitemsconfig&itemname=$this->itemname", JText::_("Price Added!"));
        		return;
        	break;
        	case "del_custom_price":
        		$this->delete_custom_pricing();
				FactoryLayer::redirect("index.php?option=com_bids&task=paymentitemsconfig&itemname=$this->itemname", JText::_("Price Removed!"));
        		return;
        	break;
        }
		parent::save_admin_config();
		FactoryLayer::redirect("index.php?option=com_bids&task=paymentitemsconfig&itemname=$this->itemname", "Settings saved");
		
    }
    
    function delete_custom_pricing(){
        $cat = JRequest::getVar('cat','');
        $price_type = "commission";
        $database = & JFactory::getDBO();
        $database->setQuery("DELETE FROM #__bid_custom_prices WHERE category = '{$cat}'  AND price_type ='$price_type' ");
        $database->query();
        //echo $database->_sql;exit;
    }
    
    function add_custom_pricing(){
    	
        $cat = JRequest::getVar('custom_pricing_category','');
        $price = (int)JRequest::getVar('custom_pricing_category_price','');
        $price_type = "commission";
        
        // some low validation: administrators ain't hackers
        if( $price >= 0){
	        $this->_db->setQuery("SELECT * FROM #__bid_custom_prices WHERE category = '{$cat}' AND price_type ='$price_type' ");
	        $this->_db->query();
	        $cur = $this->_db->getNumRows();
	        if($cur==0){
		        $this->_db->setQuery("INSERT INTO #__bid_custom_prices SET category = '{$cat}', price = '{$price}', price_type ='$price_type'");
		        $this->_db->query();
	        }
        }

    }
    
    function updateBalance($userid,$amount,$currency,$update_date=null)
    {
    	
		$this->_db->setQuery("select count(*) from #__bid_balance where auctioneer='$userid' AND currency  = $currency");
		if ($update_date) $date=",last_pay = NOW()";
		else $date="";
		if($this->_db->LoadResult()){
			$this->_db->setQuery("UPDATE #__bid_balance SET amount =amount+0+'$amount' $date where auctioneer = '$userid' AND  currency = $currency ");
			$this->_db->query();
		}else{
		 	$this->_db->setQuery("INSERT INTO #__bid_balance SET currency = $currency, amount = '$amount' ,auctioneer = '$userid' $date");
		 	$this->_db->query();
		}

    }
    
}






class price_comission_AdminHelper extends price_object_AdminHelper {

	function config(){
		
		?>
<?php

	$categories_exist = 0;
	$this->_db->setQuery("SELECT count(*) as n FROM ".APP_CATEGORY_TABLE);
	$categories_exist = $this->_db->loadResult();


// Price Per Category Enabled
	$preferential_categories = (isset($this->preferential_categories))?$this->preferential_categories:null;
	$prices_categories 		 = (isset($this->prices_categories))?$this->prices_categories:null;
	
	if($categories_exist==0)
		$preferential_categories = 0;
		
	if ( $preferential_categories ){
		$commisionable_categories = (isset($this->commisionable_categories))?$this->commisionable_categories:null;
		if($commisionable_categories){
			$carr = explode(",",$commisionable_categories);
			$catoblist = array();
			for($ii=0; $ii< count($carr); $ii++){
				$t = new stdClass();
				$t->value = $carr[$ii];
				$catoblist[$ii] = $t;
			}
			$ListingPricesCategories = price_comission_DBHelper::getCategoriesSelect("tmp_cat", $commisionable_categories);
			
		}
		
	}
	
	$categories_select = price_comission_DBHelper::getCategoriesHTML("commisionable_categories[]",$catoblist,array("multiple"=>1));
	
	$customListingPricesCategories = price_comission_DBHelper::getCategoriesPrices($commisionable_categories);
	
	$js = "window.addEvent('domready', function(){ toggle_Price_Category({$preferential_categories}); });";
	$jdoc = & JFactory::getDocument();
	$jdoc->addScriptDeclaration($js);
	
?>
<script type="text/javascript">
	function allcategories() {
		var e = document.getElementById('commisionable_categories');
		
		if(e.disabled){
			return;
		}
		
		var i = 0;
		var n = e.options.length;
		for (i = 0; i < n; i++) {
			e.options[i].selected = true;
		}
	}
	
	function nocategory() {
		var e = document.getElementById('commisionable_categories');
		
		var i = 0;
		var n = e.options.length;
		for (i = 0; i < n; i++) {
			e.options[i].selected = false;
		}
	}
	
	var pitem;
	function resize(){
		document.getElementById(pitem).style.border =  "none";
	}

	function popup(item){
		document.getElementById(item).style.border =  "1px solid #FF0000";
		pitem = item;
		setTimeout("resize()",1000);
	}

	function toggle_Price_Category(val){
		if(val==0){
			
			document.getElementById("default_price_categories").disabled="disabled";
			document.getElementById("commisionable_categories").disabled="disabled";
			document.getElementById("prices_categories0").disabled="disabled";
			document.getElementById("prices_categories1").disabled="disabled";
			document.getElementById("custom_prices_info").style.display="";
			
			
		}else{
			
			document.getElementById("default_price_categories").disabled="";
			document.getElementById("commisionable_categories").disabled="";
			document.getElementById("prices_categories0").disabled="";
			document.getElementById("prices_categories1").disabled="";
			if( document.getElementById("prices_categories0").checked )
				document.getElementById("custom_prices_info").style.display="";
			else	
				document.getElementById("custom_prices_info").style.display="none";
			
		}
	}
	
	function toggle_Custom_Prices(val){
		if(val==0){
				document.getElementById("custom_prices_info").style.display="";
		}else{
				document.getElementById("custom_prices_info").style.display="none";
		}
		
	}
	
</script>
<form action="index.php" method="post" name="adminForm">

<table width="100%" class="paramlist admintable">
	<tr>
		<td valign="top" colspan="2">
		<table style="width:auto !important;">
		<tr>
			<td valign="top">
			<fieldset>
				<legend><?php echo JText::_("Price Commission");?></legend>
		        <table class="paramlist admintable" width="100%">
		        <tr>
		            <td class="paramlist key" width="120px"><?php echo JText::_("Commission");?>: </td>
		            <td><input size="5" name="price" class="inputbox" value="<?php echo $this->price;?>"> ( % )</td>
		        </tr>
		        <tr>
		            <td class="paramlist key" width="120px"><?php echo JText::_("Commission For Powerseller Users");?>: </td>
		            <td><input size="5" name="price_powerseller" class="inputbox" value="<?php echo $this->price_powerseller;?>"> ( % )</td>
		        </tr>
		        <tr>
		            <td class="paramlist key" width="120px"><?php echo JText::_("Commission For Verified Users");?>: </td>
		            <td><input size="5" name="price_verified" class="inputbox" value="<?php echo $this->price_verified;?>"> ( % ) </td>
		        </tr>
		        </table>
			</fieldset>
			</td>
		</tr>
		</table>
		</td>
	</tr>
	<tr>
		<td valign="top" width="350">
		<fieldset>
			<legend><?php echo JText::_("Price Commission on Categories");?></legend>
			<table class="paramlist admintable" width="100%">
			<tr>
				<td class="paramlist key">
				<div id="price_listing_categories">
					<?php echo JText::_("Price Commission on Categories");?><br />
					<?php echo FactoryHTML::selectBooleanList("preferential_categories", " onclick='sel=this.value; toggle_Price_Category(sel);'", $preferential_categories ); ?>
				</div>	
				</td>
			</tr>
			</table>
			<table class="paramlist admintable" width="100%">
				<tr>
				    <td class="paramlist key" title="<?php echo JText::_("You can override this price setting by Enableing Custom Prices and adding the custom prices for the selected categories ");?>" align="right"><?php echo JText::_("Default Category Commission");?>:</td>
					<td><input <?php if(!$preferential_categories) echo "disabled"; ?> type="text" id="default_price_categories" name="default_price_categories" value="<?php echo (isset($this->default_price_categories))?$this->default_price_categories:'';?>" style="width:40px;" /> ( % ) </td>
				</tr>
				<tr>
					<td class="paramlist key" valign="top"><?php echo JText::_("Commissioned categories");?></td>
					<td>
					<a href="javascript:allcategories();">Select all</a> | <a href="javascript:nocategory();">Select none</a>
					<?php echo $categories_select; ?>
					</td>
				</tr>
				<tr>
					<td colspan="2">
					 <table id="custom_prices" width="100%">
					 	<tr>
							<td class="paramlist key" title="<?php echo JText::_("When activated Custom Prices you can chose each category a price for commission , if not the default price will be the commission price for all categories.");?>" align="right"><?php echo JText::_("Custom Prices");?>:</td>
							<td><?php echo FactoryHTML::selectBooleanList("prices_categories", "  id='sl_prices_categories'  onclick='sel1=this.value; toggle_Custom_Prices(sel1);'", $prices_categories); ?></td>
						</tr>
					 </table>
					</td>
				</tr>
			</table>
		</fieldset>
		</td>
		<td valign="top">
			<div id="custom_prices_info" style="opacity:0.9; filter:alpha(opacity=90); background:#FFF; position:absolute; z-index:10000; height:250px; width:60%;">
				<img src="templates/system/images/notice-note.png" style="text-align:top;" />
				Enable <a href="#price_listing_categories" onclick="popup('price_listing_categories');" ><?php echo JText::_("Price Commission on Categories");?></a> and <a href="#custom_prices" onclick="popup('custom_prices');" >"Custom Prices"</a> for:
				<br />
				<h2>Custom prices</h2><br />
				If no category price added but preferential pay per comission categories is enabled,
				the price will be the default
			</div>
			<table id="idx_custom_pricelist" class="paramlist admintable" width="100%">
				<tr>
					<td>
					<fieldset>
						<legend>Add custom price</legend>
						<table class="paramlist admintable">
							<?php if($ListingPricesCategories!="") { ?>
							<tr>
								<td class="paramlist key">Category:</td>
								<td>
									<?php
										echo $ListingPricesCategories; 
									?>
								</td>
							</tr>
							<tr>
								<td class="paramlist key">Price</td>
								<td>
								<input name="custom_pricing_category_price" type="text" /> ( % ) 
								<a href="#" onclick="document.getElementById('pl_task').value='add_custom_pricing';document.adminForm.submit();">Add</a>
								</td>
							</tr>
							<tr>
								<td colspan="2">
								 <?php echo JHTML::tooltip("If no category price added but preferential pay per comission categories is enabled, the price will be the default setted above");?>	If no category price added but preferential pay commission categories is enabled, the price will be the default setted above.
								</td>
							</tr>
							<?php } ?>
						</table>
					</fieldset>
					</td>
				</tr>
			</table>
			<table id="custom_price_list_table" class="adminlist">
				<thead>
					<tr id="idx_custom_pricelist_header">
						<th width="80" ></th>
						<th>Category</th>
						<th width="200" >Price</th>
					</tr>
				</thead>
	<?php	if( $customListingPricesCategories )
				foreach( $customListingPricesCategories as $i => $customCategory ){ ?>
				<tr class="row<?php if($i%2) echo "1"; else echo "0";?>">
					<td align="right">
						<?php if($customCategory->price > 0) { ?>
							<a style="color:#FF0000 !important;" href="index.php?option=com_bids&task=savepaymentitemsconfig&itemname=comission&action=del_custom_price&cat=<?php echo $customCategory->catid; ?>">remove x</a>
						<?php } ?>
					</td>
					<td><?php echo $customCategory->catname;?></td>
					<td align="center" ><strong><?php if($customCategory->price>=0) echo $customCategory->price; else echo (isset($this->default_price_categories))?"Default category price: ".$this->default_price_categories:'--' ;?></strong> ( % ) </td>
				</tr>
			<?php } ?>
			</table>
			<?php // <== Custom Prices enabled
			?>
		</td>
	</tr>
</table>
            
			<input type="hidden" id="pl_task" name="action" value="" /> 
			<input type="hidden" name="option" value="com_bids"/>
            <input type="hidden" name="task" value="savepaymentitemsconfig"/>
            <input type="hidden" name="itemname" value="<?php echo $this->itemname;?>"/>
            </form>
            <?php
		
	}

    function list_comissions_list()
    {
    	$userid = intval( JRequest::getVar('auctioneer', "") );
    	$currency = JRequest::getVar('currency', "");
        
		if($userid!=""){
			$rows = price_comission_DBHelper::getAuctioneerComissionList($userid, $currency);
			$info = price_comission_DBHelper::getAuctioneerInfo($userid, $currency);
    	}
    	else
    		FactoryLayer::redirect("index.php?option=com_bids&task=paymentitemsconfig&itemname=".$this->itemname."&action=list", "Select an bidder to view comissions!");
		?>
	<table class="adminform" style="width:500px !important;">
		<tr><td colspan="2"><a href="index.php?option=com_bids&task=paymentitemsconfig&itemname=<?php echo $this->itemname;?>&action=list">Back</a></td></tr>
		<tr>
			<td><strong>Bidder:</strong></td> <td><?php echo $info->username;?></td>
		</tr>
		<tr>
			<td><strong>Balance:</strong></td> <td><?php echo $info->amount." ".$info->currency_name;?></td>
		</tr>
		<tr>
			<td><strong>Last comission payment:</strong></td> <td><?php echo $info->last_pay;?></td>
		</tr>
		<tr>
			<td colspan="2" align="center">
			  <input type="button" onclick="document.location='index.php?option=com_bids&task=paymentitemsconfig&itemname=<?php echo $this->itemname;?>&action=send_notice&auctioneer=<?php echo $userid;?>'" value="Send payment notice" >
			</td>
		</tr>
	</table>
	<table width="100%" class="adminlist">
		<thead>
			<tr>
				<th>#</th><th>Auction Name</th><th align="center">Winning BID</th><th>Amount</th><th>Comission date</th>
			</tr>
		</thead>
		<tbody>
		<?php if(count($rows)>0) { ?>
		<?php foreach ($rows as $key => $row) { ?>
			<tr class="row<?php echo (int)($key%2);?>">
				<td width="25" align="center"><?php echo $key+1;?></td>
				<td><a href="<?php echo JURI::root();?>/administrator/index.php?option=com_bids&task=editoffer&id=<?php echo $row->id; ?>" target="_blank"><?php echo $row->title;?></a></td>
				<td align="center"><?php echo $row->bid_price;?></td>
				<td align="center"><?php echo $row->amount." ".$row->currency_name;?></td>
				<td width="250" align="center"><?php echo $row->comission_date; ?></td>
			</tr>
		<?php }
			} ?>
		</tbody>
	</table>
		<?php
    }
	
	function list_items(){
		
	
    	$limit 		= intval( JRequest::getVar('limit',  20) );
		$limitstart = intval( JRequest::getVar(  'limitstart', 0 ) );
		
		$pageNav = null;
		
		$rows = price_comission_DBHelper::getComissionList($limitstart, $limit, $pageNav);
		$total = count($rows);
		

		?>
	<form name="adminForm">
		<input type="hidden" name="option" value="com_bids" >
		<input type="hidden" name="task" value="paymentitemsconfig">
		<input type="hidden" name="itemname" value="<?php echo $this->itemname;?>" >
		<input type="hidden" name="action" value="list" >
	<table width="100%" class="adminlist">
    	<tr>
    		<th>#</th><th width="*%" align="left">Bidder</th><th width="15%">Current Balance</th>
    		<th width="15%">Last Payment Date</th><th width="15%">Details</th>
    	</tr>
			<?php
			 if(count($rows)>0) {
			     for($i=0;$i<count($rows);$i++) {
			    $row=$rows[$i];
			    ?>
    	<tr>
    		<td width="25" align="center"><?php echo $i+1;?></td>
    		<td><?php echo $row->username;?></td>
    		<td align="center"><?php echo $row->amount." ".$row->currency_name;?></td>
    		<td width="250" align="center"><?php echo $row->last_pay; ?></td>
    		<td width="25" align="center">
    		  <a href="index.php?option=com_bids&task=paymentitemsconfig&itemname=<?php echo $this->itemname;?>&action=view&auctioneer=<?php echo $row->userid;?>&currency=<?php echo $row->currency;?>">
    		      <img src="<?php echo JURI::root();?>/images/edit_f2.png" width="20" border="0" ></a>
            </td>
    	</tr>
			<?php }
			} ?>
	</table>
	<?php echo $pageNav->getListFooter();?>
	</form>
	<?php
	}
	
	function list_payments_list(){

    	$limit 		= intval( JRequest::getVar('limit',  20) );
		$limitstart = intval( JRequest::getVar(  'limitstart', 0 ) );
		
		$pageNav = null;

		$rows = price_comission_DBHelper::getPayments($limitstart, $limit, $pageNav);
		?>
	<br />
	<form name="adminForm">
		<input type="hidden" name="option" value="com_bids" >
		<input type="hidden" name="task" value="paymentitemsconfig">
		<input type="hidden" name="itemname" value="<?php echo $this->itemname;?>" >
		<input type="hidden" name="action" value="payments" >
	<table class="adminlist">
	<tr>
		<td>
		  <a href="index.php?option=com_bids&task=paymentitemsconfig&itemname=<?php echo $this->itemname?>&action=add_payment">
		  <img src="<?php echo JURI::root();?>/administrator/components/com_bids/img/menu/add_db.png" height="40" border="0"><br>
		  <strong>Add manual Payment</strong></a>
		</td>
	</tr>
	</table>
	<table class="adminlist">
		<thead>
	    	<tr>
	    		<th>#</th><th>Bidder</th><th>Amount</th><th>Payment Mode</th><th>Date</th>
	    	</tr>
    	</thead>
		<?php if(count($rows)>0) { ?>
		<?php foreach ($rows as $key => $row) { ?>
    	<tr class="row<?php echo (int)($key%2);?>">
    		<td width="25" align="center"><?php echo $key+1;?></td>
    		<td><?php echo $row->username;?></td>
    		<td align="center"><?php echo $row->amount;?></td>
    		<td align="center"><?php if($row->automatic) echo "Automatic"; else echo "Manual";?></td>
    		<td width="250" align="center"><?php echo $row->paydate;?></td>
    	</tr>
		<?php }
			} ?>
	</table>
	<?php echo $pageNav->getListFooter();?>
	</form>
		<?php
		
	}
	
/**
 * Manual add payment
 *
 */
    function add_payment(){
    	
    	$userList = array();
    	$sql = "SELECT * FROM #__users";
    	$this->_db->setQuery($sql);
    	$users = $this->_db->loadObjectList();
		$query = "SELECT id as value, name as text "
		. "\n FROM #__bid_currency"
		. "\n ORDER BY id"
		;
		
		$opts = null;
		$this->_db->setQuery( $query );
		$opts = $this->_db->loadObjectList();
		$currency_list =	JHTML::_("select.genericlist", $opts, 'currency', 'class="inputbox" size="1"',  'value', 'text');
		?>
	<form name="adminForm" method="POST" action="index.php?option=com_bids&task=paymentitemsconfig&itemname=<?php echo $this->itemname?>&action=save_payment">
	<input type="hidden" name="task" value="paymentitemsconfig" >
	<input type="hidden" name="option" value="com_bids" >
	<table width="100%" class="adminlist">
    	<tr>
    		<td width="100">User</td>
    		<td><?php echo JHTML::_("select.genericlist",$users, "user", "","id","name"); ?></td>
    	</tr>
    	<tr>
    		<td width="100">Amount</td>
    		<td><input type="text" name="amount" ></td>
    	</tr>
    	<tr>
    		<td width="100">Currency</td>
    		<td><?php echo $currency_list; ?></td>
    	</tr>
    	<tr>
    		<td colspan="2">
    		<input type="submit" value="Save" />
    		</td>
    	</tr>
	</table>
	</form>
		<?php
    }
	
/**
 * Save manual added payment
 *
 */
    function save_payment(){
    	
    	$user 		= intval( JRequest::getVar('user',  0) );
    	$amount 	= ( JRequest::getVar('amount',  0) );
    	$currency 	= ( JRequest::getVar('currency',  1) );
    	if($user && $amount)
    	{
    		$sql="INSERT INTO #__bid_payments SET user_id = '{$user}', amount = '{$amount}', currency = '{$currency}', paydate= NOW()";
    		$this->_db->setQuery($sql);
    		$this->_db->query();

    		$this->updateBalance($user,-$amount,$currency);

    		FactoryLayer::redirect("index.php?option=com_bids&task=paymentitemsconfig&itemname=".$this->itemname."&action=list", "Payment saved");
    	}
    }
	
	function plugin_menu(){
		?>
    	<a href="index.php?option=com_bids&task=paymentitemsconfig&itemname=<?php echo $this->itemname;?>">
    	<img src="<?php echo JURI::root();?>/components/com_bids/images/plugin_config.png" height="40" border="0"><br>
    	<strong>Config</strong></a>
    	<br />
   		<a href="index.php?option=com_bids&task=paymentitemsconfig&itemname=<?php echo $this->itemname;?>&action=list">
   		<img src="<?php echo JURI::root();?>/administrator/components/com_bids/img/menu/min_increase.png" height="40" border="0"><br>
   		<strong>Bidders Balances</strong></a>
    	<br />
		<a href="index.php?option=com_bids&task=paymentitemsconfig&itemname=<?php echo $this->itemname;?>&action=payments">
		<img src="<?php echo JURI::root();?>/administrator/components/com_bids/img/menu/paymentconfig.png" height="40" border="0"><br>
		<strong>Payments</strong></a>
    	<br />
	    <a href="index.php?option=com_bids&task=paymentitemsconfig&itemname=<?php echo $this->itemname;?>&action=send_notice_form">
	    <img src="<?php echo JURI::root();?>/components/com_bids/images/plugin_email.png" height="40" border="0"><br>
	    <strong>Send notices</strong></a>
    	<br />
		<?php
	}
	
/**
 * Send auctioneer a payment notification
 *
*/
	function sendNotice(){
		
		$database = & JFactory::getDBO();
		$userid = JRequest::getVar("auctioneer", "");
		$currency = JRequest::getVar("currency", "");

		// Register legacy classes for autoloading
		JLoader::register('JTableUser', JPATH_LIBRARIES.DS.'joomla'.DS.'database'.DS.'table'.DS.'user.php');
		
		$user = new JTableUser($database);
		$user->load($userid);
		$email = $user->email;
		$info = price_comission_DBHelper::getAuctioneerInfo($userid,$currency);

      require_once(JPATH_ROOT.DS."components".DS."com_bids".DS."thefactory".DS.'front.smarty.php');
		require_once(JPATH_ROOT.DS."components".DS."com_bids".DS."helpers".DS."helper.php");
		$smarty = BidsUtilities::SmartyLoaderHelper();
		$smarty->assign("info", $info);
		$html_mail = $smarty->fetch($smarty->template_dir."plugins".DS."t_plugin_mail.tpl");

		$subj = "Auction Payment Notification";
		$first_delimiter = strpos($html_mail,"##");
		if($first_delimiter){
			$snd_delimiter = strpos($html_mail,"##",$first_delimiter+2);
			if($snd_delimiter) $subj = substr($html_mail, $first_delimiter+2, $snd_delimiter- $first_delimiter-2);
		}

		$start = strpos($html_mail,"<html>");
		$html_mail = substr($html_mail, $start);

		$database->setQuery("UPDATE #__bid_balance SET sent_message = '1' WHERE auctioneer = '".$userid."' AND currency = '".$currency."' ");
		$database->query();

		$jconfig = &JFactory::getConfig();
		$mailfrom = $jconfig->getValue("mailfrom");
		$sitename = $jconfig->getValue("sitename");
		JUTility::sendMail($mailfrom, $sitename , $email, $subj, $html_mail, true);
		$japp = & JFactory::getApplication();
		$japp->redirect("index.php?option=com_bids&task=paymentitemsconfig&itemname=".$this->itemname."&action=list", "Message sent!");
    }
/**
 * Send auctioneer a payment notification
 *
*/
	function sendNoticeAll(){
		
		$database=$this->_db;
		$datesend = JRequest::getVar("datesend", 0);
		$start	 = JRequest::getVar("start_date", "");

		$filter = " WHERE amount > 0 ";
		if($datesend=="1" && $start)
			$filter .= " and last_pay < {$start} 00:00:00";


		$database->setQuery("SELECT * FROM #__bid_balance LEFT JOIN #__users u ON auctioneer = u.id {$filter}");
		$userList = $database->loadObjectList();
		$nr=0;
		if ($userList) {
			foreach ($userList as $k => $user)
			{
				$email = $user->email;
				$info = price_comission_DBHelper::getAuctioneerInfo($userid,$currency);
		
		      require_once(JPATH_ROOT.DS."components".DS."com_bids".DS."thefactory".DS.'front.smarty.php');
				require_once(JPATH_ROOT.DS."components".DS."com_bids".DS."helpers".DS."helper.php");
				$smarty->assign("info", $info);
				$html_mail = $smarty->fetch($smarty->template_dir."plugins".DS."t_plugin_mail.tpl");
	
				$subj = "Auction Payment Notification";
				$first_delimiter = strpos($html_mail,"##");
				if($first_delimiter){
					$snd_delimiter = strpos($html_mail,"##",$first_delimiter+2);
					if($snd_delimiter) $subj = substr($html_mail, $first_delimiter+2, $snd_delimiter- $first_delimiter-2);
				}
	
				$start = strpos($html_mail,"<html>");
				$html_mail = substr($html_mail, $start);
	            $nr++;
				$database->setQuery("UPDATE #__bid_balance SET sent_message = '1' WHERE auctioneer = '".$user->auctioneer."' AND currency = '".$user->currency."' ");
				$database->query();
				$jconfig = &JFactory::getConfig();
				$mailfrom = $jconfig->getValue("mailfrom");
				$sitename = $jconfig->getValue("sitename");
				JUTility::sendMail($mailfrom, $sitename , $email, $subj, $html_mail, true);
			}
		}

		$msg = "$nr Messages sent!";
		$japp = & JFactory::getApplication();
		$japp->redirect("index.php?option=com_bids&task=paymentitemsconfig&itemname=".$this->itemname."&action=list", $msg);
    }
/**
 * Send auctioneer a payment notification
 *
*/
	function sendNoticeForm(){
    	$database = & JFactory::getDBO();
    	
		?>
	<script type="text/javascript" src="<?php echo JURI::root(true);?>/includes/js/calendar/calendar.js"></script>
	<link rel="stylesheet" href="<?php echo JURI::root(true);?>/media/system/css/calendar-jos.css" type="text/css"  title="green"  media="all" />
	<script type="text/javascript" src="<?php echo JURI::root(true);?>/includes/js/calendar/lang/calendar-en-GB.js"></script>
    <script type="text/javascript">
    	function form_validate(){
    		var datesend = document.getElementById('datesend').checked;
    		var start_date = document.getElementById('start_date').value;
    		if(datesend==true && start_date==""){
    			alert("Select a date!");
    			return false;
    		}
    		return true;
    	}
    </script>
	<form name="adminForm" onsubmit="return form_validate();">
		<h3>Send email notification to users regarding their payment</h3>
		<input type="hidden" name="option" value="com_bids" >
		<input type="hidden" name="task" value="paymentitemsconfig">
		<input type="hidden" name="itemname" value="<?php echo $this->itemname;?>" >
		<input type="hidden" name="action" value="send_notice_all" >
		<input type="checkbox" id="datesend" value="1" name="datesend" > Send only to users with Last Payment Date newer then <input type="text" name="start_date" id="start_date" style="width:60px;" value="" >&nbsp; <input name="reset" class="button" onclick="return showCalendar('start_date', 'y-mm-dd');" value="..." type="reset">
		<br />
		<br /><br />
		<input type="submit" value="Send notices!" >
	</form>
	<?php
	}
	
}


class price_comission_DBHelper{
	
	function getCategory($id){
		
		$db = & JFactory::getDBO();
		$id = $db->getEscaped($id);
		$db->setQuery("SELECT cat FROM #__bid_auctions WHERE id = '$id'");
		return $db->loadResult();
	}
	
	function getQuant($id){
		
		$quant = 0;
		
		$cati = price_comission_DBHelper::getCategory($id);
		if($this->preferential_categories==1 && $cati){
			$quant = price_comission_DBHelper::getPrice($cati);
		}else{
			$quant = 1;
		}
		return $quant;
	}
	
	function getPrice($catid){
		
		$price = $this->price;
    	
		if( $this->preferential_categories=="1" ){
			
			if($this->default_price_categories)
				$price = $this->default_price_categories;
				
			if($catid){
				if( strstr($this->commisionable_categories, $catid) ){
					$ptype= "commission";
					$sql = " SELECT price+0 ".
							" FROM #__bid_custom_prices ".
							" WHERE category = '$catid' AND price_type= '$ptype'";
							$this->_db->setQuery($sql);
					$custom_price_Result = $this->_db->loadResult();
					
					if( isset($custom_price_Result) && (int)$custom_price_Result >= 0 ){
						$price =  $custom_price_Result;
					}
						
				}else 
					$price = 0;
			}
		}
		return $price;
    }
	
	function getComissionList($limitstart, $limit, &$pageNav){

		
		$query = "SELECT count(*) \r\n
		FROM #__users as u  \r\n
		LEFT JOIN #__bid_balance as b ON b.auctioneer = u.id
		";
		$this->_db->setQuery($query);
		$total = $this->_db->loadResult();
		
		// Create the pagination object
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);

		$query = "SELECT b.*, u.username, u.name,u.id as userid, c.name as currency_name \r\n
		FROM #__users u \r\n
		LEFT JOIN #__bid_balance b ON auctioneer = u.id 
		LEFT JOIN #__bid_currency c ON b.currency = c.id 
		";
    	$this->_db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
    	$return = $this->_db->loadObjectList();
    	

    	return $return;
    }

	function getPayments($limitstart, $limit, &$pageNav){

		$query = "
		SELECT count(*)  \r\n
		FROM #__bid_payments as p \r\n
		LEFT JOIN #__users u ON p.user_id = u.id \r\n
		";
		$this->_db->setQuery($query);
		$total = $this->_db->loadResult();
		
		// Create the pagination object
		jimport('joomla.html.pagination');
		$pageNav = new JPagination($total, $limitstart, $limit);

		$query = "
		SELECT p.*, u.username, u.name \r\n
		FROM #__bid_payments p \r\n
		LEFT JOIN #__users u ON p.user_id = u.id \r\n
		";
    	$this->_db->setQuery($query, $pageNav->limitstart, $pageNav->limit);
    	$return = $this->_db->loadObjectList();
	  	unset($query);
		return $return;
    }
    
    function getAuctioneerComissionList($userid, $currency=""){

		if($userid!="")
			$where = " WHERE c.userid = '{$userid}'";
		if($currency!="")
			$where .=" AND c.currency = $currency ";
			

		$query = "SELECT c.*, u.username, u.name, cr.name as currency_name, \r\n
		 a.id,a.title,a.closed_date, #__bids.bid_price \r\n
		FROM #__bid_comissions c \r\n
		LEFT JOIN #__users u ON c.userid = u.id \r\n
		LEFT JOIN #__bid_auctions a ON a.id = c.auction_id \r\n
		LEFT JOIN #__bid_currency as cr ON cr.id = c.currency \r\n
		LEFT JOIN #__bids ON #__bids.id = c.bid_id
		{$where}
		";
    	$this->_db->setQuery($query);
    	$return = $this->_db->loadObjectList();
    	
    	unset($query);
    	return $return;
    }

    function getAuctioneerInfo($userid, $currency=""){
		if($userid!="" && $currency!="")
			$where = " WHERE b.auctioneer = '{$userid}' AND b.currency = $currency";

		$query = "SELECT b.*, u.username, u.name, c.name as currency_name \r\n
		FROM #__bid_balance b \r\n
		LEFT JOIN #__users u ON auctioneer = u.id
		LEFT JOIN #__bid_currency c ON currency = c.id
		{$where}
		";
		$this->_db->setQuery($query);
    	$return=$this->_db->loadObject();
    	unset($query);
    	return $return;
    }
    
	function getCategoriesHTML( $name, $selected, $params=null ){
		
		$cat = new JTheFactoryCategoryObj();
		$cat->show_active_only = true;
		
		if(isset($params["multiple"]) && (int)$params["multiple"]!=0)
			return $cat->makeCatSelectMultiple($selected, $name);
		else
			return $cat->HTMLCatTree($name,$selected, $params);
		
	}
	
	function getCategoriesPrices($id_list){
		if(!$id_list) return null;
		$_sql = " SELECT ag.id,ag.catname, ag.id as catid,cp.price ". 
		" FROM ".APP_CATEGORY_TABLE." AS ag  LEFT JOIN #__bid_custom_prices as cp  ON cp.category = ag.id AND price_type='commission' ".
		" WHERE  ag.id IN ($id_list) ";
		$this->_db->setQuery( $_sql );
		return $this->_db->loadObjectList();
		
	}
	
	function getCategoriesSelect($name, $id_list){
		
		if(!$id_list) return "";
		
		$this->_db->setQuery("SELECT * FROM ".APP_CATEGORY_TABLE." WHERE id IN ($id_list)");
		$opts = $this->_db->loadObjectList();
		
		return $otherListingPricesCategories = JHTML::_('select.genericlist',$opts,'custom_pricing_category',' class="inputbox" style="width:190px;" "','id', 'catname');
		
	}
	
	
}

?>