<?php
/**
 * @package Auctions Factory
 * @version 2.0.0
 * @copyright www.thefactory.ro
 * @license: commercial
 * @modified: 10.02.10
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
require_once(dirname(__FILE__).DS."pricing_object.php");

class price_contact  extends generic_pricing
{
    function price_contact(&$db) {
		$this->classname='price_contact';
    	$this->classdescription='Module for buying contacts';
		parent::generic_pricing($db);
    }

    function getPrice($d)
    {
    	$p = JRequest::getVar('itemprice');
    	if(!$p)
    		$p = parent::getPrice($d);
    	return $p;
    }
    
    function show_admin_config() {
    	?>
            <form action="index.php" method="post" name="adminForm">
    	<?php
			price_object_AdminHelper::showCommonSettingsTab();
    	?>
			<input type="hidden" name="option" value="com_bids"/>
            <input type="hidden" name="task" value="savepaymentitemsconfig"/>
            <input type="hidden" name="itemname" value="<?php echo $this->itemname;?>"/>
            </form>
    	<?php
    }

	function checktask($task,$d) {
		global $Itemid;
		$my= & JFactory::getUser();

		if ($task=='buy_contact') {
			if (!$my->id ){
	            JError::raiseWarning(1,"Login First");
				FactoryLayer::redirect(JURI::root().'/index.php?option=com_bids&task=userprofile&id='.$_GET["id"].'&Itemid='.$Itemid);
	            return true;
			}
			$d['return_url']=JURI::root().'/index.php?option=com_bids&view=bids&task=set_contact&id='.$_GET["id"];
			$this->ShowPurchaseDialog($d);
			return true;
        }
        // pay_return
		if ($task=='set_contact'){
			$_amount = trim(stripslashes($_POST['mc_gross']));
            $_payment_status = trim(stripslashes($_POST['payment_status']));
            $msgC = ""; 
            switch  ($_payment_status){
            	case "Completed":
                case "Processed":{
		            $msgC = "Success Payed!"; 
                    $_status='ok';
                    $_balance_update = ($amount)/$this->price;
	                break;
                    }
                case "Failed":
                case "Denied":
                case "Canceled-Reversal":
                case "Expired":
                case "Voided":
                case "Reversed":
                case "Refunded":
                    $_status='error';
                break;
                default:
                case "In-Progress":
                case "Pending":
                	{
		            $msgC = JText::_("Contact Payed");
                    $_status=JText::_("Contact Payed");
                    $_balance_update = 0;
                	break;
                	}
            }
        	if($_status!="error"){
	        	$this->acceptOrder($my->id, $_balance_update, $this->getCurrency($d));
				FactoryLayer::redirect(JURI::root().'/index.php?option=com_bids&task=listauctions&view=bids&Itemid='.$Itemid,$msgC);
        	}
		}

        return false;

    }

    function ShowPurchaseDialog($d)
    {
        global $Itemid;
		$id=JRequest::getVar('id','');
		$return_url=JURI::root()."/index.php?option=com_bids&view=bids&task=set_contact&id={$id}&Itemid={$Itemid}";

        $my= & JFactory::getUser();
		$smarty = BidsUtilities::SmartyLoaderHelper();

        $this->_db->setQuery("SELECT * FROM #__bid_pricing WHERE enabled=1");
        $rows=$this->_db->LoadObjectList();
        $smarty->assign('pricing',$rows);
        $smarty->assign('user',$my);
        $smarty->assign('item_object',$this);
        $smarty->assign('paymenttype','');
        $smarty->assign('return_url',$return_url);
		$smarty->display('t_buy_contact.tpl');
    }

    function processTemplate($task,$d, &$smarty){
		global $Itemid;
		$my= & JFactory::getUser();
		if($smarty){			
			if($task=="ViewDetails" ){				       
			    require_once(JPATH_ADMINISTRATOR.'/components/com_bids/bids.class.php');
				$aid=JRequest::getVar('aid','');
				$addObj = new JAuctions($this->_db);
				$addObj->load($aid);
				$contactId = JRequest::getVar('id','');
				if ( $my->id==$contactId) return ; // my profile
				
				$uri = JURI::root().'/index.php?option=com_bids&task='.$task.'&id='.$contactId.'&Itemid='.$Itemid."&contact=1";
				if(!$my->id)
   				{ 		    				
   						$smarty->_tpl_vars["user"]->surname = "hidden";
	    				$smarty->_tpl_vars["user"]->phone = "hidden";
	    				$smarty->_tpl_vars["user"]->address = "hidden";
	    				$smarty->_tpl_vars["user"]->paypalemail = "hidden";
	    				$smarty->_tpl_vars["user"]->name = "hidden&nbsp;<a href='index.php?option=com_bids&task=buy_contact&id=".$contactId."&ItemId=".$Itemid."'>".JText::_("Buy Contact")."</a>"
							. " (".JText::_("Login first").")";
	    				return ;
  				 }
				
   				$credits = $this->getGredits($my->id, $contactId);
				$contact_bought = $this->verifyContact($my->id, $contactId);

				if($contact_bought) return;
				if( isset($credits[0])  && $credits[0]->amount>=1 ){
					// if you have not bought the contact it and no request to consume contact link to consume contact
					if(!isset($_GET["contact"]) || $_GET["contact"]!="1"){
	    				$smarty->_tpl_vars["user"]->surname = "hidden";
	    				$smarty->_tpl_vars["user"]->phone = "hidden";
	    				$smarty->_tpl_vars["user"]->address = "hidden";
	    				$smarty->_tpl_vars["user"]->paypalemail = "hidden";
	   					$smarty->_tpl_vars["user"]->name = "<a href='".$uri."'>".JText::_("Buy contact")."</a>";
   					}elseif (isset($_GET["contact"]) && $_GET["contact"]=="1"){
   						// consuming a credit and view
   						$this->decreaseCredit($my->id, $contactId);
   					}
   				}elseif($credits[0]->amount==0){
   					// no credits, buy
    				$smarty->_tpl_vars["user"]->surname = "hidden";
    				$smarty->_tpl_vars["user"]->phone = "hidden";
    				$smarty->_tpl_vars["user"]->address = "hidden";
    				$smarty->_tpl_vars["user"]->paypalemail = "hidden";
    				$smarty->_tpl_vars["user"]->name = "hidden&nbsp;<a href='index.php?option=com_bids&task=buy_contact&id=".$contactId."&ItemId=".$Itemid."'>".JText::_("Buy Contact")."</a>";
   				}
    		}
    	}
    }

    function acceptOrder($log,$amount)
    {
    	
        $this->_db->setQuery("select count(*) from #__bid_credits where userid='$log->userid' and credittype='$this->itemname'");
        if ($this->_db->LoadResult()){
            $this->_db->setQuery("update #__bid_credits set amount=amount+$amount where userid='$log->userid' and credittype='$this->itemname'");
        }else{
            $this->_db->setQuery("insert into #__bid_credits set amount=$amount , userid='$log->userid' , credittype='$this->itemname'");
        }
        $this->_db->query();
    }
    
    function getDescription() {
		$nr = JRequest::getVar('nr','');
    	if ($nr) $nr="($nr contacts)";
        return "Pay for user Contact information $nr";
    }

    function getGredits($userId, $contact_id) {
		$sql = "
			SELECT itemname,amount,price,currency,task_pay FROM 
			 #__bid_pricing AS p
			LEFT JOIN #__bid_credits c ON p.itemname=c.credittype AND c.userid='$userId'
			WHERE  p.itemname='".$this->itemname."'";
		$this->_db->setQuery( $sql );
		return $this->_db->loadObjectList() ;
    }

    function verifyContact($userId, $contact_id) {
		$sql = "
			SELECT count(*) FROM
			#__bid_contacts_buy
			WHERE  userid='".$userId."' AND contact_id = '".$contact_id."'";
		$this->_db->setQuery( $sql );
		return $this->_db->loadResult();
    }

    function decreaseCredit($userId, $contact_id){
		$this->_db->setQuery("UPDATE #__bid_credits SET amount=amount-1 WHERE userid='$userId' AND credittype='$this->itemname'");
		
		$this->_db->query();
		$this->_db->setQuery("INSERT INTO #__bid_contacts_buy SET userid='$userId' , contact_id = '$contact_id'");
		$this->_db->query();
	}
}
?>