<?php
/**
 * @package Auctions Factory
 * @version 2.0.0
 * @copyright www.thefactory.ro
 * @license: commercial
*/

// no direct access
//defined( '_JEXEC' ) or die( 'Restricted access' );
require_once(dirname(__FILE__).DS."pricing_object.php");

class price_listing extends generic_pricing
{

	var $_param_members = array(
		'price_powerseller',
		'price_verified',
		'preferential_categories', 
		'default_price_categories', 
		'prices_categories', 
		'commisionable_categories'
	);
	
    function price_listing(&$db) {
        $this->classname = 'price_listing';
        $this->classdescription='Module for buying Ad listings';
        parent::generic_pricing($db);
    }
    
    function getPrice($d){
    	
    	if ($u->powerseller){
			return $this->price_powerseller;
    	}
    	
		if ($u->verified){
    		return $this->price_verified;
    	}
    	
		if($this->preferential_categories==1){
			$cati = JRequest::getVar('category','');
			$id = JRequest::getVar('id','');
			if(isset($cati) && $cati>0)
				return $this->price*price_listing_DBHelper::getPrice($cati);
			elseif( isset($id) && $id>0 && $cati = price_listing_DBHelper::getCategory($id) )
				return $this->price*price_listing_DBHelper::getPrice($cati);
			else	
				return $this->price;
		}else 
			return $this->price;
			
    }

    
    
    function checktask($task,$d) {
    	
		require_once(dirname(__FILE__).DS."../payment/pay_paypal.en.php");
		
		global $Itemid, $id;
		$my = & JFactory::getUser();
		$db = & JFactory::getDBO();

		$credits = $this->getCredits($my->id);
		
		$id = JRequest::getVar('id', null);
		$islogged = 0;
		
		if($id){

			$sql = "SELECT COUNT(*) FROM ".PAYTABLE_PAYLOG." WHERE object_id = '$id' AND itemname = '{$this->itemname}' AND ( status <> 'ok' OR ISNULL(status ) )  ";
			$db->setQuery($sql);
			$islogged = $db->loadResult();

		}

		$this_price = $this->price;
		
		if($task=='republish' || $task=="newauction" || ( ($task=="form" || $task=="edit") && !$id  ) ){
			
			// display Price
			$quant = price_listing_DBHelper::getQuant();
			// IF FREE, than,.. carry on
			if ($quant==0 || $this_price==0){
				return false;
			}
			
			// if not free print the price
			echo sprintf(bid_paypal_listing_is_not_free, $quant,$quant*$this_price, $this->currency);
			if( $credits >0 )
				echo sprintf(bid_paypal_credit_situation, $credits);
			else{
				echo sprintf(bid_paypal_credit_situation, $credits);
			}
			return false;
			
		}elseif ($task =="editauction" && $id){
			
			if($islogged==1){
				
				echo bid_paypal_allready_processing;
				return false;
				
			}
		}
		
		
		if ( $task=="extend_auction" ){
        	
			$this->_db->setQuery("SELECT sum(amount) FROM #__bid_credits WHERE userid='$my->id' AND credittype='$this->itemname'");
			
			if ($this->_db->LoadResult()<=0){
				
				$this->ShowPurchaseDialog($d);
				return true;
				
			}elseif($task=="extend_add"){
            	
				$this->_db->setQuery("UPDATE #__bid_credits SET amount=amount-1 WHERE userid='$my->id' AND credittype='$this->itemname'");
            $this->_db->query();
			}
		}
        
		if ($task=='saveauction' ){

			global $Itemid;
			$quant = price_listing_DBHelper::getQuant();
			
			// IF FREE, than,.. carry on
			if ($quant==0 || $this_price==0){
				return false;
			}
			
			$database = &JFactory::getDBO();
			$id = JRequest::getVar('id','');
			
			$add = new JAuctions($db);
			if($id){  $add->load($id);}
			
			
			$user_published_op = JRequest::getVar("published");;

			// IF NO CREDITS unpublished!
			if( $credits<=0 ){
				if(!$id)
					$_POST["published"] = 0;
				elseif($add->published==0){
					// Prevent publishing unpublished Auctions with no money
					$_POST["published"] = 0;
				}
			}
	        
			// Allways published no matter of  credits
			// IF edit and published => publish
			if($id){
				if( $add->published==1 )
					$_POST["published"] = 1;
				elseif( $add->published == 0 )
					$_POST["published"] = 0;
			}
			
			$old_state = $add->published;
	        
			// ALways unpublished no matter of  credits
			if( $islogged==1 ){
				$_POST["published"] = 0;
			}
			
			// do the saving
			$msg = saveAuction($id);
			if (!$msg) $msg = bid_succes;
            
			if($id){  $add->load($id);}
	      
			
			if ( ( $id && $old_state!=1 && $user_published_op == "1" ) ) {
				if ( $credits >= $quant ) {
				
					$this->consume_credits($quant, $add->userid);
					FactoryLayer::redirect("index.php?option=com_bids&task=viewbids&id={$id}&Itemid={$Itemid}", bid_saved );
				
				}else{
				
					if(!$islogged){
						
						$d["id"] = $id;
	            	$d["category"] = $add->cat;
	            	$d["id"] = $add->id;
	            	$d["itemamount"] = $quant;
	            	$this->info["payment_description"] = $add->title;
						$this->ShowPurchaseDialog($d);
						return true;
						
					}else{
						
						FactoryLayer::redirect("index.php?option=com_bids&task=viewbids&id=$id&Itemid=$Itemid", bid_paypal_allready_processing );
						
					}
				
				}
			}
			
			if ($id) {
					FactoryLayer::redirect("index.php?option=com_bids&task=viewbids&id=$id&Itemid=$Itemid" );
			}
			return true;
			
			
		}

		if ($task=='buy_listing' ){
		   $this->ShowPurchaseDialog($d);
		   return true;
		}
        
        if ($task=='payment'){
	        
        	// The Order Number (not order_id !)
	        $invoice =  trim(stripslashes($_POST['invoice']));
	        $payment_status = trim(stripslashes($_POST['payment_status']));
	        
	        if($invoice){
	        	require_once(dirname(__FILE__).DS."..".DS."payment".DS."payment_log.php");
				$log = new JTheFactoryPaymentLog($this->_db);
				$log->_tbl_key = "invoice";
		
				$log->load($invoice);
				
				// If pending (IPN not runned yet for misc reasons )
				if( ( $payment_status == "Completed" || $payment_status == "Processed" || $payment_status == "In-Progress" || $payment_status == "Pending" ) && $log->status!="ok"){
					if($aid = $log->object_id)
						FactoryLayer::redirect('index.php?option=com_bids&task=viewbids&id='.$aid,"Payment Succesfully! Waiting for approval!");
					else
						FactoryLayer::redirect('index.php?option=com_bids',"Payment Succesfully! Waiting for approval!");
					return true;
				}else{
					if($aid = $log->object_id)
						FactoryLayer::redirect('index.php?option=com_bids&task=details&id='.$aid,"Payment Succesfully!");
				}
	        }
	        
        }
        if ($task=='importcsv' || $task=='bulkimport'){
            echo bid_payment_listing_bulkimport;
            echo "<br>";
            return true;
        }
        return false;
    }
    
	// CONSUME CREDITS
    function consume_credits($nr_credits=1,$user_id){
		$this->_db->setQuery("UPDATE #__bid_credits SET amount=amount-$nr_credits WHERE userid='$user_id' and credittype='$this->itemname'");
		$this->_db->query();
    }

    
    /**
     * This is the same for Featuring Listing
     * override function in pricing class for custom handling
     * 
     *
     * @param int/object $order (ad id or log object)
     */
    function update_object($order){
    	// 
    	$my= & JFactory::getUser();
    	$user_id = $my->id;
    	
    	$credits = 1;
    	if ( is_object($order) ){
    		$aid = $order->object_id;
	    	$user_id = $order->userid;
	    	$credits = $order->amount / $this->price;
	    	
    	}else 
    		$aid = $order;
    	
		// UPDATE OBJECT	
		$this->_db->setQuery("UPDATE #__bid_auctions SET published='1' where id='$aid'");
		$this->_db->query();
		
		// CONSUME CREDITS
		$this->_db->setQuery("UPDATE #__bid_credits SET amount=amount-{$credits} WHERE userid='$user_id' and credittype='$this->itemname'");
		$this->_db->query();
		
    }


    
/**
 * 
 * 
 * ADMINISTRATION TASKS
 * 
 * 
 * 
 */
    
    function show_admin_config() {
    	
    	
        ?>
            
            <form action="index.php" method="post" name="adminForm">
<?php

	$categories_exist = 0;
	$this->_db->setQuery("SELECT count(*) as n FROM ".APP_CATEGORY_TABLE);
	$categories_exist = $this->_db->loadResult();


// Price Per Category Enabled
	$preferential_categories = (isset($this->preferential_categories))?$this->preferential_categories:null;
	$prices_categories 		 = (isset($this->prices_categories))?$this->prices_categories:null;
	
	if($categories_exist==0)
		$preferential_categories = 0;
		
	if ( $preferential_categories ){
		$commisionable_categories = (isset($this->commisionable_categories))?$this->commisionable_categories:null;
		if($commisionable_categories){
			$carr = explode(",",$commisionable_categories);
			$catoblist = array();
			for($ii=0; $ii< count($carr); $ii++){
				$t = new stdClass();
				$t->value = $carr[$ii];
				$catoblist[$ii] = $t;
			}
			$ListingPricesCategories = price_listing_DBHelper::getCategoriesSelect("tmp_cat", $commisionable_categories);
			
		}
		
	}
	
	$categories_select = price_listing_DBHelper::getCategoriesHTML("commisionable_categories[]",$catoblist,array("multiple"=>1));
	
	$customListingPricesCategories = price_listing_DBHelper::getCategoriesPrices($commisionable_categories);
	
	$js = "window.addEvent('domready', function(){ toggle_Price_Category({$preferential_categories}); });";
	$jdoc = & JFactory::getDocument();
	$jdoc->addScriptDeclaration($js);
	
?>
<script type="text/javascript">
	function allcategories() {
		var e = document.getElementById('commisionable_categories');
		
		if(e.disabled){
			return;
		}
		
		var i = 0;
		var n = e.options.length;
		for (i = 0; i < n; i++) {
			e.options[i].selected = true;
		}
	}
	
	function nocategory() {
		var e = document.getElementById('commisionable_categories');
		
		var i = 0;
		var n = e.options.length;
		for (i = 0; i < n; i++) {
			e.options[i].selected = false;
		}
	}
	
	var pitem;
	function resize(){
		document.getElementById(pitem).style.border =  "none";
	}

	function popup(item){
		document.getElementById(item).style.border =  "1px solid #FF0000";
		pitem = item;
		setTimeout("resize()",1000);
	}

	function toggle_Price_Category(val){
		if(val==0){
			
			document.getElementById("default_price_categories").disabled="disabled";
			document.getElementById("commisionable_categories").disabled="disabled";
			document.getElementById("prices_categories0").disabled="disabled";
			document.getElementById("prices_categories1").disabled="disabled";
			document.getElementById("custom_prices_info").style.display="";
			
			
		}else{
			
			document.getElementById("default_price_categories").disabled="";
			document.getElementById("commisionable_categories").disabled="";
			document.getElementById("prices_categories0").disabled="";
			document.getElementById("prices_categories1").disabled="";
			if( document.getElementById("prices_categories0").checked )
				document.getElementById("custom_prices_info").style.display="";
			else	
				document.getElementById("custom_prices_info").style.display="none";
			
		}
	}
	
	function toggle_Custom_Prices(val){
		if(val==0){
				document.getElementById("custom_prices_info").style.display="";
		}else{
				document.getElementById("custom_prices_info").style.display="none";
		}
		
	}
	
</script>
<table width="100%" class="paramlist admintable">
	<tr>
		<td valign="top" colspan="2">
		<table style="width:auto !important;">
		<tr>
			<td valign="top">
				<?php
					price_object_AdminHelper::showCommonSettingsTab();
				?>
			</td>
			<td valign="top">
				<?php
					price_object_AdminHelper::showSpecialUserSettingsTab();
				?>
			</td>
		</tr>
		</table>
		</td>
	</tr>
	<tr>
		<td valign="top" width="350">
		<fieldset>
			<legend><?php echo JText::_("Price Listing on Categories");?></legend>
			<table class="paramlist admintable" width="100%">
			<tr>
				<td class="paramlist key">
				<div id="price_listing_categories">
					<?php echo JText::_("Price Listing on Categories");?><br />
					<?php echo FactoryHTML::selectBooleanList("preferential_categories", " onclick='sel=this.value; toggle_Price_Category(sel);'", $preferential_categories ); ?>
				</div>	
				</td>
			</tr>
			</table>
			<table class="paramlist admintable" width="100%">
				<tr>
				    <td class="paramlist key" title="<?php echo JText::_("You can override this price setting by Enableing Custom Prices and adding the custom prices for the selected categories ");?>" align="right"><?php echo JText::_("Default Category Listing Price");?>:</td>
					<td><input <?php if(!$preferential_categories) echo "disabled"; ?> type="text" id="default_price_categories" name="default_price_categories" value="<?php echo (isset($this->default_price_categories))?$this->default_price_categories:'';?>" style="width:40px;" /> ( <?php echo JText::_("Credits");?> ) </td>
				</tr>
				<tr>
					<td class="paramlist key" valign="top"><?php echo JText::_("Pay per list categories");?></td>
					<td>
					<a href="javascript:allcategories();">Select all</a> | <a href="javascript:nocategory();">Select none</a>
					<?php echo $categories_select; ?>
					</td>
				</tr>
				<tr>
					<td colspan="2">
					 <table id="custom_prices" width="100%">
					 	<tr>
							<td class="paramlist key" title="<?php echo JText::_("When activated Custom Prices you can chose each category a price for listing , if not the default price will be the listing price for all categories.");?>" align="right"><?php echo JText::_("Custom Prices");?>:</td>
							<td><?php echo FactoryHTML::selectBooleanList("prices_categories", "  id='sl_prices_categories'  onclick='sel1=this.value; toggle_Custom_Prices(sel1);'", $prices_categories); ?></td>
						</tr>
					 </table>
					</td>
				</tr>
			</table>
		</fieldset>
		</td>
		<td valign="top">
			<div id="custom_prices_info" style="opacity:0.7; filter:alpha(opacity=70); background:#FFF; position:absolute; z-index:10000; height:250px; width:60%;">
				<img src="templates/system/images/notice-note.png" style="text-align:top;" />
				Enable <a href="#price_listing_categories" onclick="popup('price_listing_categories');" ><?php echo JText::_("Price Listing on Categories");?></a> and <a href="#custom_prices" onclick="popup('custom_prices');" >"Custom Prices"</a> for:
				<br />
				<h2>Custom prices</h2><br />
				If no category price added but preferential pay per listing categories is enabled,
				the price will be the default
			</div>
			<table id="idx_custom_pricelist" class="paramlist admintable" width="100%">
				<tr>
					<td>
					<fieldset>
						<legend>Add custom price</legend>
						<table class="paramlist admintable">
							<?php if($ListingPricesCategories!="") { ?>
							<tr>
								<td class="paramlist key">Category:</td>
								<td>
									<?php
										echo $ListingPricesCategories; 
									?>
								</td>
							</tr>
							<tr>
								<td class="paramlist key">Price</td>
								<td>
								<input name="custom_pricing_category_price" type="text" /> credits 
								<a href="#" onclick="document.getElementById('pl_task').value='add_custom_pricing';document.adminForm.submit();">Add</a>
								</td>
							</tr>
							<tr>
								<td colspan="2">
								 <?php echo JHTML::tooltip("If no category price added but preferential pay per listing categories is enabled, the price will be the default setted above");?>	If no category price added but preferential pay per listing categories is enabled, the price will be the default setted above.
								</td>
							</tr>
							<?php } ?>
						</table>
					</fieldset>
					</td>
				</tr>
			</table>
			<table id="custom_price_list_table" class="adminlist">
				<thead>
					<tr id="idx_custom_pricelist_header">
						<th width="80" ></th>
						<th>Category</th>
						<th width="200" >Price</th>
					</tr>
				</thead>
	<?php	if( $customListingPricesCategories )
				foreach( $customListingPricesCategories as $i => $customCategory ){ ?>
				<tr class="row<?php if($i%2) echo "1"; else echo "0";?>">
					<td align="right">
						<?php if($customCategory->price > 0) { ?>
							<a style="color:#FF0000 !important;" href="index.php?option=com_bids&task=savepaymentitemsconfig&itemname=listing&action=del_custom_price&cat=<?php echo $customCategory->catid; ?>">remove x</a>
						<?php } ?>
					</td>
					<td><?php echo $customCategory->catname;?></td>
					<td align="center" ><strong><?php if($customCategory->price>=0) echo $customCategory->price; else echo (isset($this->default_price_categories))?"Default category price: ".$this->default_price_categories:'--' ;?></strong> credits </td>
				</tr>
			<?php } ?>
			</table>
			<?php // <== Custom Prices enabled
			?>
		</td>
	</tr>
</table>

			<input type="hidden" id="pl_task" name="action" value="" /> 
			<input type="hidden" name="option" value="com_bids"/>
            <input type="hidden" name="task" value="savepaymentitemsconfig"/>
            <input type="hidden" name="itemname" value="<?php echo $this->itemname;?>"/>
            </form>
            <?php
    }
    
    
    function save_admin_config()
    {
        $action = JRequest::getVar('action','');
		$commisionable_categories = JRequest::getVar('commisionable_categories',null,$_REQUEST,'array');
		if($commisionable_categories){
			$_REQUEST["commisionable_categories"] = implode(",",$commisionable_categories);
		}
		//exit;
        switch($action){
        	case "add_custom_pricing":
        		$this->add_custom_pricing();
				FactoryLayer::redirect("index.php?option=com_bids&task=paymentitemsconfig&itemname=$this->itemname", JText::_("Price Added!"));
        		return;
        	break;
        	case "del_custom_price":
        		$this->delete_custom_pricing();
				FactoryLayer::redirect("index.php?option=com_bids&task=paymentitemsconfig&itemname=$this->itemname", JText::_("Price Removed!"));
        		return;
        	break;
        }
		parent::save_admin_config();
		FactoryLayer::redirect("index.php?option=com_bids&task=paymentitemsconfig&itemname=$this->itemname", "Settings saved");
		
    }
    
    function delete_custom_pricing(){
        $cat = JRequest::getVar('cat','');
        $price_type = "listing";
        $database = & JFactory::getDBO();
        $database->setQuery("DELETE FROM #__bid_custom_prices WHERE category = '{$cat}'  AND price_type ='$price_type' ");
        $database->query();
        //echo $database->_sql;exit;
    }
    
    function add_custom_pricing(){
    	
        $cat = JRequest::getVar('custom_pricing_category','');
        $price = (int)JRequest::getVar('custom_pricing_category_price','');
        $price_type = "listing";
        
        // some low validation: administrators ain't hackers
        if( $price >= 0){
	        $this->_db->setQuery("SELECT * FROM #__bid_custom_prices WHERE category = '{$cat}' AND price_type ='$price_type' ");
	        $this->_db->query();
	        $cur = $this->_db->getNumRows();
	        if($cur==0){
		        $this->_db->setQuery("INSERT INTO #__bid_custom_prices SET category = '{$cat}', price = '{$price}',price_type ='$price_type'");
		        $this->_db->query();
	        }
        }

    }
    
}






class price_listing_AdminHelper extends price_object_AdminHelper {

	function showCategoryListingConfig(){
		
		
		
		?>
		<?php
	}
	
	
}

class price_listing_DBHelper{
	
	function getCategory($id){
		
		$db = & JFactory::getDBO();
		$id = $db->getEscaped($id);
		$db->setQuery("SELECT cat FROM #__bid_auctions WHERE id = '$id'");
		return $db->loadResult();
	}
	
	function getQuant(){
		$quant = 0;
		$cati = JRequest::getVar('category','');
		if(!$cati)
			$cati = JRequest::getVar('cat','');
		if(!$cati)
			$cati = JRequest::getVar('category_selected','');
		
		if($this->preferential_categories==1){
			if( !$cati ){
				// go select a category
				FactoryLayer::redirect("index.php?option=com_bids&view=bid&task=selectcat&Itemid=$Itemid");
			}else
				// fetch the category price  ( credit price actually )
				$quant = price_listing_DBHelper::getPrice($cati);
		}else{
			$quant = 1;
		}
		return $quant;
	}
	
	function getPrice($catid){
		
		$price = 0;
    	
		if( $this->preferential_categories=="1" ){
			
			if($this->default_price_categories)
				$price = $this->default_price_categories;
				
			if($catid){
				$money_takin_categories = explode(",",$this->commisionable_categories);
				if( in_array($catid,$money_takin_categories) ){
					$ptype= "listing";
					$sql = " SELECT price+0 ".
							" FROM #__bid_custom_prices ".
							" WHERE category = '$catid' AND price_type= '$ptype'";
							$this->_db->setQuery($sql);
					$custom_price_Result = $this->_db->loadResult();
					
					if( isset($custom_price_Result) && (int)$custom_price_Result >= 0 ){
						$price =  $custom_price_Result;
					}
						
				}else{ 
					$price = 0;
				}	
			}
		}
		
		return $price;
    }
	
    
	function getCategoriesHTML( $name, $selected, $params=null ){
		
		$cat = new JTheFactoryCategoryObj();
		$cat->show_active_only = true;
		
		if(isset($params["multiple"]) && (int)$params["multiple"]!=0)
			return $cat->makeCatSelectMultiple($selected, $name);
		else
			return $cat->HTMLCatTree($name,$selected, $params);
		
	}
	
	function getCategoriesPrices($id_list){
		if(!$id_list) return null;
		$_sql = " SELECT ag.id,ag.catname, ag.id as catid,cp.price ". 
		" FROM ".APP_CATEGORY_TABLE." AS ag  LEFT JOIN #__bid_custom_prices as cp  ON cp.category = ag.id AND price_type='listing' ".
		" WHERE  ag.id IN ($id_list) ";
		$this->_db->setQuery( $_sql );
		return $this->_db->loadObjectList();
		
	}
	
	function getCategoriesSelect($name, $id_list){
		
		if(!$id_list) return "";
		
		$this->_db->setQuery("SELECT * FROM ".APP_CATEGORY_TABLE." WHERE id IN ($id_list)");
		$opts = $this->_db->loadObjectList();
		
		return $otherListingPricesCategories = JHTML::_('select.genericlist',$opts,'custom_pricing_category',' class="inputbox" style="width:190px;" "','id', 'catname');
		
	}
	
}

?>