<?php
/**
 * @package Auctions Factory
 * @version 2.0.0
 * @copyright www.thefactory.ro
 * @license: commercial
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

require_once(dirname(__FILE__).DS."pricing_object.php");

class price_packages extends generic_pricing
{
    function price_packages(&$db)
    {
        $this->classname='price_packages';
        $this->classdescription=JText::_("bid_paymentitem_desc_packages");
        parent::generic_pricing($db);
		$this->itemname = "packages";

    }
    
    function getPrice($d){
    	return ($d["itemprice"]);
    }
    
    function getDescription(){
    	
    	$key = array_search("package_id",$_REQUEST);
    	$package_id = JRequest::getVar(str_replace("var_name","var_value",$key),null);
    	$package = price_packages_DBHelper::getPackage((int)$package_id);
    	return JText::_("{$package->name} Package");
    	
    }
    
    function checktask($task,$d){
    	switch ($task) {
    		case 'buy_packages':{
	            $this->showPackagesFull($d);
		        return true;
    			break;
    		}
    		case 'buy_package':{
	            $this->ShowPurchaseDialog($d);
		        return true;
    			break;
    		}
    	}
    	
    }
    
    function acceptOrder($log,$amount)
    {
    	
    	if($log->var_name1=="package_id" && $log->var_value1!=""){
    		
    		$package_id = $log->var_value1;
	    	$pac = price_packages_DBHelper::getPackage( (int)$package_id );
	    	
	    	$payOb = JTheFactoryPaymentLib::getInstance();
	    	$payOb->loadAvailabeItems();
			$pricings = $payOb->price_plugins;
			unset($pricings["price_packages"]);
			unset($pricings["price_comission"]);
			
			$pac->pricing_list = $pricings;
			
			foreach ($pac->credits as $credit) {
				
				$pac->pricing_list["price_".$credit->pricing]->acceptOrder($log,$credit->credits);

			}
    		
    	}else 
    		return;

    }
    
	function ShowPurchaseDialog($d) {
        $my= & JFactory::getUser();
		$smarty = BidsUtilities::SmartyLoaderHelper();
		
		$selected_package = JRequest::getVar("package",null);
		
		$smarty->assign('object_id',JRequest::getVar("id",null));
		$smarty->assign('selected_type', $selected_package );
		$smarty->assign('my',$my);
		$smarty->assign_by_ref('item_object',$this);
	    $smarty->assign('paymenttype','');
		$smarty->assign('return_url',JArrayHelper::getValue($d,'return_url'));
        $smarty->assign('page_title', JText::_("Buy package ".JRequest::getVar("package",null)) ) ;
        
    	$packages = price_packages_DBHelper::getPackage( $selected_package );
    	
    	$payOb = JTheFactoryPaymentLib::getInstance();
    	$payOb->loadAvailabeItems();
		$pricings = $payOb->price_plugins;
		unset($pricings["price_packages"]);
		unset($pricings["price_comission"]);
		
		$pac = $packages;
		$pac->pricing_list = $pricings;
		
		foreach ($pac->credits as $credit) {
			
			$tmp_pricing = null;
			$tmp_pricing->price_item = $pac->pricing_list["price_".$credit->pricing]->getPrice(null);
			$tmp_pricing->credits = $credit->credits;
			$tmp_pricing->itemname = $pac->pricing_list["price_".$credit->pricing]->itemname;
			$pac->pricing_list["price_".$credit->pricing] = $tmp_pricing;
		}
			
		$smarty->assign('pac',$packages);
		$smarty->display('plugins/t_package_purchase.tpl');

	}
    
	function showPackagesFull($d) {
        $my= & JFactory::getUser();
		$smarty = BidsUtilities::SmartyLoaderHelper();
		

		$smarty->assign('object_id',JRequest::getVar("id",null));
        $smarty->assign('selected_type',JRequest::getVar("package",null));
        $smarty->assign('my',$my);
        $smarty->assign_by_ref('item_object',$this);
	    $smarty->assign('paymenttype','');
		$smarty->assign('return_url',JArrayHelper::getValue($d,'return_url'));
        $smarty->assign('page_title', JText::_("Buy package ".JRequest::getVar("package",null)) ) ;
        
    	$packages = price_packages_DBHelper::getFrontPackages();
    	$payOb = JTheFactoryPaymentLib::getInstance();
    	$payOb->loadAvailabeItems();
		$pricings = $payOb->price_plugins;
		unset($pricings["price_packages"]);
		unset($pricings["price_comission"]);

		for($ii = 0 ; $ii < count($packages); $ii++) {
			
			$pac = $packages[$ii];
			$pac->pricing_list = $pricings;
			
			foreach ($pac->credits as $credit) {
				
				$tmp_pricing = null;
				$tmp_pricing->price_item = $pac->pricing_list["price_".$credit->pricing]->getPrice(null);
				$tmp_pricing->credits = $credit->credits;
				$tmp_pricing->itemname = $pac->pricing_list["price_".$credit->pricing]->itemname;
				$pac->pricing_list["price_".$credit->pricing] = $tmp_pricing;
			}
			
		}
		
		
		
		$smarty->assign('packages',$packages);
		$smarty->display('plugins/t_packages.tpl');
    }

    function show_admin_config() {
    	
        $action = JRequest::getVar('action','');
		switch ($action){
			case "toggle_publishing":{ price_packages_AdminHelper::toggle_publishing(); break;}
			case "delete":{ price_packages_AdminHelper::del_package(); break;}
			default:{ price_packages_AdminHelper::show_config();break; }
		}
    	
    }
 
    function save_admin_config()
    {
        $itemname=JRequest::getVar('itemname','');
    	$pricings = $payOb->price_plugins;
    	unset($pricings["price_packages"]);
    	unset($pricings["price_comission"]);
        
        $package = new price_package($this->_db);
        $package->name=JRequest::getVar('name','');
        $package->price=JRequest::getVar('price','');
        $package->currency =JRequest::getVar('currency','');
        $package->store();
        
        $inserts = array();
        foreach($_REQUEST as $k => $var){
            if(substr($k,0,7)=="credits" && $var!=""){
                $inserts[] = "( {$package->id},'".str_replace("credits_","",$k)."',".$var." )";
            }
            
        }
        $insert_sql = " INSERT INTO ".PAYTABLE_PACKAGES."_credits (pid,pricing,credits) VALUES ".implode(",",$inserts);
        $this->_db->setQuery($insert_sql);
        $this->_db->query();
        $this->saveParams($_REQUEST);
    }
    
}

class price_packages_AdminHelper extends price_object_AdminHelper {
	function show_config(){
		$this->_db->setQuery("SELECT * FROM ".constant("APP_CURRENCY_TABLE_".strtoupper(APP_PREFIX)));
		$currencies = $this->_db->loadObjectList();
		
    	$packages = price_packages_DBHelper::getPackages();
    	$payOb = JTheFactoryPaymentLib::getInstance();
    	$payOb->loadAvailabeItems();
    	$pricings = $payOb->price_plugins;
    	unset($pricings["price_packages"]);
    	unset($pricings["price_comission"]);
    	
		?>
<h2><?php echo JText::_("Packages");?></h2>
<table class="adminlist">
	<tr>
		<td valign="top">
			<script type="text/javascript">
				function TryParseInt(str,defaultValue){
					var retValue = defaultValue;
					if(str!=null){
						if(str.length>0){
							if (!isNaN(str)){
								retValue = parseInt(str);
							}
						}
					}
					return retValue;
				}
				var priceInputList = new Array();
				var priceValuesList = new Array();
				var priceCurrencyList = new Array();
				var priceAvailCurrencies = new Array();
				var initAux = 0;
				function sumCurrency(currency){
					var total = 0;
					for(var i=0; i<priceInputList.length;i++){
						if(currency == priceCurrencyList[i] )
							total += (TryParseInt(document.getElementById(priceInputList[i]).value,0))*(TryParseInt(priceValuesList[i],0));
					}
					return total;
				}
				
				function pk_refreshPrice(){
					
					var iInfo = document.getElementById('unreduced_price_info');
					var str = "";
					
					var tmp = 0;
					for (var ep=0; ep < priceAvailCurrencies.length; ep++){
							tmp = sumCurrency(priceAvailCurrencies[ep]);
							str += tmp  + " " +  priceAvailCurrencies[ep] + "<br />";
					}
					iInfo.innerHTML = str;
				}
			</script>
            <form action="index.php" method="post" name="adminForm">
            <fieldset>
            <legend><?php echo JText::_("Add Package");?></legend>
			<table class="paramlist admintable" border=1 width="100%">
				<tr>
            		<td class="paramlist key" style="width:80px !important;"><?php echo JText::_("Name");?></td>
            		<td><input type="text" name="name" /></td>
            	</tr>
            	<tr>
            		<td class="paramlist key" style="width:80px !important;"><?php echo JText::_("Credits");?></td>
            		<td>
            			<table class="paramlist admintable">
            				<?php 
            				$t = 0 ;
							$tmpCurrencyList = array();
            				if($pricings){
	            				foreach ($pricings as $p => $pk ) { ?>
	            				<tr>
	            					<td>
	            					<input onchange="pk_refreshPrice()" type="text" id="credits_<?php echo $pk->itemname;?>" name="credits_<?php echo $pk->itemname;?>" size="5" />
	            					<script type="text/javascript">
	            						priceInputList[<?php echo $t;?>] = 'credits_<?php echo $pk->itemname;?>';
	            						priceValuesList[<?php echo $t;?>] = '<?php echo $pk->price;?>';
	            						priceCurrencyList[<?php echo $t;?>] = '<?php echo $pk->currency;?>';
	            						<?php 
					    				if ( !isset($tmpCurrencyList[$pk->currency] ) ){
						    				$tmpCurrencyList[$pk->currency] = $pk->currency;
					    				?>	
										priceAvailCurrencies[initAux] = '<?php echo $pk->currency; ?>';
										initAux++;
					    				<?php } ?>
	            					</script>
	            					<br />
	            					(<?php echo $pk->price." ".$pk->currency;?>)
	            					</td>
	            					<td class="paramlist key" style="text-align:left !important;"><?php echo $pk->itemname;?></td>
	            				</tr>
	            				<?php 
	            				$t++;
	            				} 
            				}else "No Pricings Enabled or defined!";
            				?>
            			</table>
            		</td>
            	</tr>
            	<tr>
            		<td class="paramlist key" style="width:80px !important;"><?php echo JText::_("Price");?></td>
            		<td>
            		<input type="text" name="price" />
            		</td>
            	</tr>
            	<tr>
            		<td class="paramlist key" style="width:80px !important;"><?php echo JText::_("Unreduced Price");?></td>
            		<td>
            		<span id="unreduced_price_info"></span>
            		</td>
            	</tr>
            	<tr>
            		<td class="paramlist key" style="width:80px !important;"><?php echo JText::_("Currency");?></td>
            		<td>
            		<?php 
            		if($currencies){
            		?>
            		<select name="currency">
	            		<?php 
	            		foreach ($currencies as $k => $cur){
	            		?>
	            		<option><?php echo $cur->name;?></option>
	            		<?php 
	            		}
	            		?>
	            		</select>
	            		<?php
            		}else { ?>
            			<input type="text" name="currency" />
            			<?php
            		}
            		?>
            		</td>
            	</tr>
            </table>
            </fieldset>
            <input type="hidden" name="option" value="com_bids"/>
            <input type="hidden" name="act" value="addpackage"/>
            <input type="hidden" name="task" value="savepaymentitemsconfig"/>
            <input type="hidden" name="itemname" value="<?php echo $this->itemname;?>"/>
            </form>
		</td>
		<td width="70%" valign="top">
            <fieldset>
            <legend><?php echo JText::_("Packages List");?></legend>
			<table class="adminlist">
				<thead>
				<tr>
					<th height="30"><?php echo JText::_("Delete");?></th>
					<th><?php echo JText::_("Enabled");?></th>
					<th><?php echo JText::_("Name");?></th>
					<th><?php echo JText::_("Credits");?></th>
					<th><?php echo JText::_("Normal Price");?></th>
					<th><?php echo JText::_("Price");?> ( <?php echo JText::_("Unreduced Price");?> )</th>
				</tr>
				</thead>
				<tbody>
				<?php foreach ($packages as $p => $pac) {?>
				<tr>
                    <td align="center"><a href="#" onclick="if(confirm('Are you sure?')=='1') this.href='index.php?option=com_bids&task=paymentitemsconfig&itemname=packages&action=delete&id=<?php echo $pac->id;?>';  "><img src="<?php  echo F_ROOT_URI;?>/administrator/images/cancel_f2.png" style="width:12px;" border="0" /></a></td>
                    <td align="center">
                    <?php
						if ( isset($pac->status) && $pac->status == 1 ) {
							$img = 'publish_y.png';
							$alt = JText::_( 'Published - Unpublish' );
						} else {
							$img = 'publish_x.png';
							$alt = JText::_( 'Unpublished - Publish' );
						}
						
						$status ="<span class=\"editlinktip hasTip\" title=\"".JText::_( 'Publish Information  '.$alt )."\">";
					 	$status .="<a href=\"index.php?option=".APP_EXTENSION."&task=paymentitemsconfig&itemname=packages&action=toggle_publishing&cid[]=$pac->id\" >";
					 	$status .="<img src=\"".JURI::root()."administrator/components/".APP_EXTENSION."/thefactory/category/assets/".$img."\" width=\"16\" height=\"16\" border=\"0\" alt=\"".$alt."\" /></a></span>"; 
					 	
					 	echo $status;
					 ?>
                    </td>
					<td><strong><?php echo $pac->name;?></strong></td>
					<td>
						<?php 
						$pac->unprice = array() ;
						$pac->unprice_detailed = "";
						foreach ($pac->credits as $credit) {
							$price_item = $pricings["price_".$credit->pricing]->getPrice(null);
							$price_item_total = $credit->credits*$pricings["price_".$credit->pricing]->getPrice(null);
							$currency = $pricings["price_".$credit->pricing]->currency;
							if (!$pac->unprice[$currency]) {
								$pac->unprice[$currency] = 0;
							}
							$pac->unprice[$currency] += $price_item_total;
							$pac->unprice_detailed .= " {$price_item_total} ($currency) = {$credit->credits} x  {$price_item} ( {$credit->pricing} ) <br />";
							echo $credit->pricing." ".$credit->credits;
							echo "<br />";
						}?>
					</td>
					<td><strong><?php foreach ($pac->unprice as $cur => $val) echo $cur.": ".$val.";";?></strong><br /><?php echo $pac->unprice_detailed;?></td>
					<td><?php echo $pac->price;?> <?php echo $pac->currency;?>&nbsp;(<?php foreach ($pac->unprice as $cur => $val) echo $cur.": ".$val.";";?>)</td>
				</tr>
				<?php } ?>
				</tbody>
			</table>
            </fieldset>
		</td>
	</tr>
</table>
            <?php
		
	}

	function toggle_publishing(){
		
		$cid = JRequest::getVar("cid",array());
		if(!is_array($cid))
			FactoryLayer::redirect("index.php?option=".APP_EXTENSION."&task=paymentitemsconfig&itemname=packages");

		foreach ($cid as $c => $id){
			$this->_db->setQuery("UPDATE ".PAYTABLE_PACKAGES." SET status=1-status WHERE id = '{$id}'");
			$this->_db->query();
			
		}
		FactoryLayer::redirect("index.php?option=".APP_EXTENSION."&task=paymentitemsconfig&itemname=packages",JText::_("Package(s) toggled!"));
	}
	
	function del_package(){
		
        $id = JRequest::getInt('id','');
		$db = & JFactory::getDBO();
		
		$db->setQuery("DELETE FROM ".PAYTABLE_PACKAGES."_credits WHERE pid = '{$id}'");
		$db->query();
		
		$db->setQuery("DELETE FROM ".PAYTABLE_PACKAGES." WHERE id = '{$id}'");
		$db->query();
		
		FactoryLayer::redirect("index.php?option=".APP_EXTENSION."&task=paymentitemsconfig&itemname=packages",JText::_("Packages removed!"));
	}
}

class price_packages_DBHelper{
	
	function getPackage($name){
		
		if(is_int($name)){
			$db = & JFactory::getDBO();
			$db->setQuery("SELECT * FROM ".PAYTABLE_PACKAGES." WHERE id = '{$name}'  ORDER BY price+0 DESC ");
			$packages  = $db->loadObject();
		}else{
			$db = & JFactory::getDBO();
			$db->setQuery("SELECT * FROM ".PAYTABLE_PACKAGES." WHERE name = '{$name}'  ORDER BY price+0 DESC ");
			$packages  = $db->loadObject();
			
		}
		
		$db->setQuery("SELECT * FROM ".PAYTABLE_PACKAGES."_credits WHERE pid = {$packages->id} ");
		$packages->credits = $db->loadObjectList();
			
		return  $packages;
	}
	
	function getPackages(){
		$db = & JFactory::getDBO();
		$db->setQuery("SELECT * FROM ".PAYTABLE_PACKAGES."  ORDER BY price+0 DESC ");
		$packages  = $db->loadObjectList();
		if($packages)
		for ( $p=0; $p < count($packages); $p++ ){
			$db->setQuery("SELECT * FROM ".PAYTABLE_PACKAGES."_credits WHERE pid = {$packages[$p]->id} ");
			$packages[$p]->credits = $db->loadObjectList();
			
		}
		return  $packages;
	}
	
	function getFrontPackages(){

		$db = & JFactory::getDBO();
		$db->setQuery("SELECT * FROM ".PAYTABLE_PACKAGES." WHERE status=1  ORDER BY price+0 DESC ");
		$packages  = $db->loadObjectList();
		if($packages)
		for ( $p=0; $p < count($packages); $p++ ){
			$db->setQuery("SELECT * FROM ".PAYTABLE_PACKAGES."_credits WHERE pid = {$packages[$p]->id} ");
			$packages[$p]->credits = $db->loadObjectList();
			if ( file_exists(JPATH_ROOT."/images/auctions/packages/".strtolower($packages[$p]->name).".jpg") ) {
				$packages[$p]->image = JURI::root()."/images/auctions/packages/".strtolower($packages[$p]->name).".jpg";
			}else{
				$packages[$p]->image = JURI::root()."/images/auctions/no_image.png";
			}
		}
		return  $packages;
	}
}

class price_package extends JTable{
	
    var $id = null;
    var $name = null;
    var $price = null;
    var $currency = null; 
    
	function price_package( &$db ) {
		
		$this->__construct( PAYTABLE_PACKAGES, 'id', $db );

	}
    
    
}

?>