<?php
/**
 * @package TheFactoryFramework
 * @version 1.0
 * @author The Factory
 * @copyright Commercial
 * 
 * Manages Smarty Templates initialization
 * 		Initializes the standard Smarty variables for TheFactory
 * 			ROOT_HOST	the webpage url
 * 			IMAGE_ROOT  the url to the image repository
 * 			task 	the current Joomla task
 * 			Itemid	the current Joomla Itemid (menu id)
 * 			option	the currnet Joomla option (current extension)
 * 			is_logged_in	is true if the User is authenticated, false if Guest
 * 			userid	the current joomla user id
 * 			my	the current Joomla User Object
 * 
 * 
*/
class JTheFactoryTemplates
{
	/**
	 * Loads the Smarty Framework and initalizes the smarty object 
	 *
	 * @param boolean $debug if true - smarty debug output
	 * @param array $register_functions - list of smarty function names that should be registered with the object
	 * @return smarty object
	 */
	function LoadTemplate($debug=false,$register_functions=null)
	{
        global $Itemid;
        $my = &JFactory::getUser();
        // set path to Smarty directory *nix style
        if (!defined('SMARTY_DIR')) define('SMARTY_DIR', JPATH_COMPONENT_SITE.DS.'smarty'.DS.'libs'.DS);
        // include the smarty class Note 'S' is upper case
        require_once(SMARTY_DIR . 'Smarty.class.php');
        require_once(dirname(__FILE__) .DS. 'front.smarty.php');


		$smarty=new JTheFactorySmarty();
		$smarty->template_dir=JPATH_COMPONENT_SITE.DS.'templates'.DS;
		$smarty->compile_dir=JPATH_COMPONENT_SITE.DS.'templates'.DS.'cache'.DS;

		$smarty->debugging= $debug;

		$smarty->assign('ROOT_HOST',JURI::root());
		$smarty->assign('IMAGE_ROOT',JURI::root().'components/'.APP_EXTENSION.'/images');

		$task	= JRequest::getCmd( 'task' );
		$smarty->assign('Itemid',$Itemid);
		$smarty->assign('option',APP_EXTENSION);
		$smarty->assign('task',$task);
		$smarty->assign('is_logged_in',($my->id)?"1":"0");
		$smarty->assign('userid',$my->id);
		$smarty->assign('my',$my);

		if (count($register_functions))
            foreach ($register_functions as $func_name=>$smarty_name)
		      $smarty->register_function($func_name,$smarty_name);
		return $smarty;
	}
	
	

}


?>