<?php
/**
 * @package TheFactoryFramework
 * @version 2.5
 * @author The Factory
 * @copyright Commercial
 * @modified 25.08.2010
 * 
 *  Manages Extended Users profiles
 *
 */
class JTheFactoryUserProfile extends JObject
{
    var $tablename=null;
    var $field_userid=null;
    var $cb_fields=null;

    function __construct() {
    	
    }

    function &getInstance() {
        static $instance;

        if ( !isset ($instance))
        {
            $instance = new JTheFactoryUserProfile();
        }
        return $instance;
    }
    
	function getUserProfile(&$user_obj, $profile_mode){
    	
		$tbl = constant("APP_".APP_PREFIX."_PROFILE");
    	$uid = (int)$user_obj->userid;
    	
		if ( $profile_mode == "cb" ){
			cb_integration::getProfile($user_obj);
		}elseif ( $profile_mode == "love" ){
			lovefactory_integration::getProfile($user_obj);
		}else{
	    	
			$SelectCols = array();
			$JoinList = array();
			
			$SelectCols[] = " ptable.country as country_id,co.name as `country` "; 
			$JoinList[] = " LEFT JOIN #__bid_country AS co ON ptable.country=co.id ";
								
			$SelectCols[] 	= " u_table.username as username ";
			$JoinList[] = " LEFT JOIN #__users AS u_table ON  ptable.userid=u_table.id ";
			
			$user_obj->username = null;
			$user_obj->country_id = null;
			$user_obj->loadData( $uid, $SelectCols, $JoinList ,array($tbl => "ptable"));
	    }

    }
    
    function getListJoin($mode,$exclusive=1,&$JoinList,&$SelectCols){
    	
		$tbl = constant("APP_".APP_PREFIX."_PROFILE");
    	
    	
		if($mode=="" || $mode=="component"){
			
			$cb_fieldmap = JTheFactoryIntegration::integrationFields();
			foreach ($cb_fieldmap as $c ){
				$SelectCols[] = " prof.{$c}";
			}
			
	    	if($exclusive==1){
	        	$JoinList[] = " RIGHT JOIN `".$tbl."` AS `prof` ON `u`.`id` = `prof`.`userid` " ;
	    	}else{
	        	$JoinList[] = " LEFT JOIN `".$tbl."` AS `prof` ON `u`.`id` = `prof`.`userid` " ;
	    	}
		}elseif ($mode=="cb" && CB_DETECT){
			
			cb_integration::getListJoins($JoinList,$SelectCols,$exclusive);
			
		}elseif ($mode=="love" && LOVE_DETECT){
			
			lovefactory_integration::getListJoins($JoinList,$SelectCols,$exclusive);
		}
    	
    	return $JoinList;
    }
    
    /**
     * Returns True or False if the Current User has an additional Profile
     *
     * @return boolean
     */
    function hasProfile()
    {
		$tbl = constant("APP_".APP_PREFIX."_PROFILE");
        $my=&JFactory::getUser();
        
		if (!$my->id) return false;
		if (CB_DETECT) return true;
        $db=&JFactory::getDBO();
        $db->setQuery("select count(*) from `".$tbl."` where `userid`='{$my->id}'");

        return $db->LoadResult();

    }
    /**
     * Returns the Usergroups (array of groups) 
     *
     * @return array of groups
     */
    function getUserGroups()
    {
        $my=&JFactory::getUser();
        if ($my->id) return false;

        $acl=&JFactory::getACL();

        $user_groups=$acl->acl_get_groups('users',$my->id);
        if (!is_array($user_groups)) return false;
        return $user_groups;
    }
    
    function setRedirectToProfile($mode, $id = null )
    {
    	global $Itemid;
		$url_dir = null;
		if($mode){
			switch ($mode){
				case "cb":{
					/*
					// get ItemId CB
				    require_once(JPATH_ADMINISTRATOR.DS."components".DS."com_comprofiler".DS."plugin.foundation.php");
					cbimport( 'cb.database' );
					$Iid = getCBprofileItemid();
					*/
					if($id)
						$url_dir = JURI::root()."index.php?option=com_comprofiler&user=$id&task=userprofile&Itemid=$Itemid";
					else 
						$url_dir = JURI::root()."index.php?option=com_comprofiler&Itemid=$Itemid";
					break;
				}
				case "love":{
					if($id)
						$url_dir = JURI::root()."index.php?option=com_lovefactory&id=$id&view=profile&Itemid=$Itemid";
					else	
						$url_dir = JURI::root()."index.php?option=com_lovefactory&view=profile&Itemid=$Itemid";
					break;
				}
				default:{
					
					break;
				}
			}
			
		}
		return $url_dir;

    }

}


?>