<?php
/**
* @package		Auctions Factory
* @license		comercial
* @modified	19/01/2010
*/
// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view');

/**
 * @package	Auctions Factory
 */
class bidsViewAuctions extends JView
{

	function listauctions() {

		$model		= &$this->getModel("auctions");
		$model->_task = "auctions";
		$items = $model->getAuctions();
		
		$positions = array();
		$items = $this->renderList($items, "t_listauctions.tpl", $positions);
		
		$this->renderPage("t_listauctions.tpl", $items, $positions);
	}
	
	function listmyauctions() {
		
		$model		= &$this->getModel("auctions");
		$model->_task = "myauctions";
		$items = $model->getAuctions();
		$positions = array();
		$items = $this->renderList($items, "t_myauctions.tpl", $positions);
		
		$this->renderPage("t_myauctions.tpl", $items, $positions);
		
	}
	
	function listwatchlist() {
		
		$model		= &$this->getModel("auctions");
		$model->_task = "watchlist";
		$items = $model->getAuctions();
		$positions = array();
		$items = $this->renderList($items, "t_mywatchlist.tpl", $positions);
		
		$this->renderPage("t_mywatchlist.tpl", $items, $positions);
		
	}
	
	function listmybids() {
		
		$my = &JFactory::getUser();
		if(!$my->id)
			return;
		$model		= &$this->getModel("bid");
		$model->_task = "mybids";
		$items = $model->getBids();
		
		$positions = array();
		$items = $this->renderList($items, "t_mybids.tpl", $positions);
		
		$this->renderBidsPage("t_mybids.tpl", $items, $positions);
		
	}
	
	function listmywonbids() {
		
		$model		= &$this->getModel("bid");
		$model->_task = "mywonbids";
		$items = $model->getBids();
		$positions = array();
		$items = $this->renderList($items, "t_mywonbids.tpl", $positions);
		
		$this->renderPage("t_mywonbids.tpl", $items, $positions);
		
	}
	
	function listsuggestions() {
		
		$model		= &$this->getModel("auctions");
		$model->_task = "suggestions";
		$items = $model->getSuggestions();
		$positions = array();
		$items = $this->renderList($items, "t_suggestions.tpl", $positions);
		
	    $filter_bidtype = JRequest::getInt('filter_bidtype', -1);
	    $bid_type[] = JHTML::_('select.option',0, bid_filter_available);
    	$bid_type[] = JHTML::_('select.option',1, bid_filter_archive);
	    $lists['filter_bidtype'] = JHTML::_('select.genericlist',$bid_type, 'filter_bidtype','class="inputbox" onchange="document.auctionForm.submit();"', 'value', 'text', $filter_bidtype);

		$sfilters['bid_type'] = $filter_bidtype;
	    
		$this->renderPage("t_suggestions.tpl", $items, $positions);
	}
	

	function mysuggestions() {
		
		$model		= &$this->getModel("auctions");
		$model->_task = "mysuggestions";
		$items = $model->getSuggestions();
		$positions = array();
		$items = $this->renderList($items, "t_mysuggestions.tpl", $positions);
		
	    $filter_bidtype = JRequest::getInt('filter_bidtype', -1);
	    $bid_type[] = JHTML::_('select.option',0, bid_filter_available);
    	$bid_type[] = JHTML::_('select.option',1, bid_filter_archive);
	    $lists['filter_bidtype'] = JHTML::_('select.genericlist',$bid_type, 'filter_bidtype','class="inputbox" onchange="document.auctionForm.submit();"', 'value', 'text', $filter_bidtype);

		$sfilters['bid_type'] = $filter_bidtype;
	    
		$this->renderPage("t_mysuggestions.tpl", $items, $positions);
	}	
	
	/**
	 * Renders Listing Items
	 *
	 * @param array $items
	 * @param string $template
	 */
	function renderList( $items, $template , & $positions ){
		
		//$gallery = BidImageUtilies::loadImagePlugin();
	    
		$database = &JFactory::getDBO();
		
        /*@var $pageNav mosPageNav*/
        if (defined("bid_opt_gallery"))
            $gallery_name = "gl_" . bid_opt_gallery;
        else
            $gallery_name = "gl_lytebox";

		$cfields_translations = FactoryFieldsFront::getCustomFieldsOptions();
		
        $gallery = new $gallery_name($database, AUCTION_PICTURES);
	    $gallery->writeJS();
	    
	    if($items)
	    for ($key=0; $key < count($items); $key++){
	    	
	    	$add = $items[$key];
			$add->rownr = $key+1;
			$param = new JParameter( $add->params );
	    	$gallery->clearImages();
			$gallery->addImage($add->picture);
			$add->thumbnail=$gallery->getThumb();
			$add->thumbnail_medium=$gallery->getThumb(0,1,1);
            
			FactoryFieldsFront::translateRowOptions($add,$cfields_translations);
			
			// Distribute all Ad , Owner of ad user custom fields to positions
			$positions[$add->id] = JTheFactoryHelper::loadPositionedFields($add, $template );
	    	
		    $add->start_date_text = date(bid_opt_date_format,(strtotime($add->start_date)) );
			//JTheFactoryHelperTime::process_countdown($add);
			
			$add->description = JFilterOutput::cleanText($add->description);
			$add->shortdescription = JFilterOutput::cleanText($add->shortdescription);
			
			$add->tags = null;
			if($add->alltags)
				$add->tags = explode( "," , $add->alltags );
			
			$add->links = HTML_Auction::_CreateLinksArray($add);
			
			if($add->favorite==0){
				$add->add_to_watchlist = 1;
				$add->del_from_watchlist = 0;
			}
			else {
				$add->add_to_watchlist = 0;
				$add->del_from_watchlist = 1;
			}
			
            if (bid_opt_multiple_shipping) {
                $p = new JAuctionShipZones($database);
                $add->shipping_zones = $p->getPriceList($add->id);
            }
            if (bid_opt_enable_countdown) {
                $now = BidTimeUtilities::getNow();
                $expiredate = BidTimeUtilities::getTimeStamp( $add->end_date );
                $diff = $expiredate - $now;
                if ($diff > 0) {
                    $s = sprintf("%02d", $diff % 60);
                    $diff = intval($diff / 60);
                    $m = sprintf("%02d", $diff % 60);
                    $diff = intval($diff / 60);
                    $h = sprintf("%02d", $diff % 24);
                    $d = intval($diff / 24);
                    if ($d > 0)
                        $add->countdown = "$d " . bid_days . ", $h:$m:$s";
                    else
                        $add->countdown = "$h:$m:$s";
                } else {
                    $add->countdown = bid_expired;
                }
            }
			if( BidTimeUtilities::getTimeStamp($add->end_date) <= BidTimeUtilities::getNow() ){$add->expired=true;}else $add->expired=false;
			
		    $add->start_date_text = date(bid_opt_date_format, strtotime($add->start_date));
		    
		    if($add->end_date && $add->end_date!='0000-00-00 00:00:00' ) {
			    $add->end_date_text = date(bid_opt_date_format." ".bid_opt_date_time_format, strtotime($add->end_date));
			}
            
            JAuctionHelper::setAuctionStatus($add);
				
            if($param->get('max_price','1')==0 || $add->auction_type==AUCTION_TYPE_PRIVATE){
            	$add->highest_bid = null;
            }
			// Deprecated , Leave only for customisations
			//$catObj->load($add->category);
			//$add->catname = $catObj->catname;
	    	$items[$key] = $add;
		}

		if (defined("bid_opt_enable_countdown") && bid_opt_enable_countdown==1) { 
			$jdoc = & JFactory::getDocument();
			$js = JURI::root()."/components/com_bids/js/countdown.js";
			$jdoc->addScript( $js );
			$js = JURI::root()."/components/com_bids/js/startcounter.js";
			$jdoc->addScript( $js );
			$js_declaration = "var days='".JText::_("Days").",';	var expired='".JText::_("Expired")."';var nrcounters=".count($items).";";
			$jdoc->addScriptDeclaration( $js_declaration );
        }
        return $items;
	}
	
	
	function renderPage( $template, $items , $positions ){
		
		$app	= JFactory::getApplication();
		
		$smarty = BidsUtilities::SmartyLoaderHelper();
		$uri 	  = &JFactory::getURI();
		
		
		// Get the page/component configuration
		$params = $app->getParams();
		$model		= &$this->getModel("auctions");
		
		$smarty->assign("positions",  $positions);
        
		$filter_order_Dir =  $model->getfilter_order_Dir();
		
		$reverseorder_Dir =  $model->getreversefilter_order_Dir();
		$filter_order =  $model->getfilter_order();
        
		$filters =  $model->get( '_filters');
		$filter_bidtype = @$filters["filter_bidtype"];
		$filter_archive = @$filters["filter_archive"];
        
		$pagination = $model->getPagination();
		
		$lists = array();
		$archive[] = JHTML::_('select.option','0', bid_active_offers, 'filter_archive','text');
		$archive[] = JHTML::_('select.option','1', bid_my_unpublished_offers,'filter_archive', 'text');
		$archive[] = JHTML::_('select.option','2', bid_view_archive, 'filter_archive', 'text');
		$archive[] = JHTML::_('select.option','3', bid_view_unsold_items, 'filter_archive','text');
		$archive[] = JHTML::_('select.option','4', bid_view_sold_items, 'filter_archive','text');
		$lists['archive'] = JHTML::_('select.genericlist',$archive, 'filter_archive','class="inputbox" size="1" onchange="document.auctionForm.submit();"','filter_archive', 'text', $filter_archive);
		
		$orders[] = JHTML::_('select.option','start_date', bid_sort_newest);
		$orders[] = JHTML::_('select.option','start_price', bid_sort_initialprice);
		$orders[] = JHTML::_('select.option','bin_price', bid_sort_binprice);
		$orders[] = JHTML::_('select.option','end_date', bid_sort_end_date);
		$orders[] = JHTML::_('select.option','username', bid_sort_username);
		$lists['orders'] = JHTML::_('select.genericlist',$orders, 'filter_order', 'class="inputbox" onchange="document.auctionForm.submit();"', 'value', 'text', $filter_order);
	
		$bid_type[] = JHTML::_('select.option',0, bid_filter_available);
		$bid_type[] = JHTML::_('select.option',1, bid_filter_archive);
		if ( $my->id )
			$bid_type[] = JHTML::_('select.option',3, bid_filter_watchlist);
	
		$lists['filter_bidtype'] = JHTML::_('select.genericlist',$bid_type, 'filter_bidtype', 'class="inputbox" onchange="document.auctionForm.submit();"', 'value', 'text', $filter_bidtype);
	
	    $ord_desc[] = JHTML::_('select.option','DESC', bid_order_desc);
	    $ord_desc[] = JHTML::_('select.option','ASC', bid_order_asc);
	    $lists['filter_order_asc'] = JHTML::_('select.genericlist',$ord_desc, 'filter_order_Dir','class="inputbox" onchange="document.auctionForm.submit();"', 'value', 'text', $filter_order_Dir);
	
	    $lists['filter_userid'] = $filter_userid;
	    
		$lists['filter_cats'] = BidsHTML::selectCategory("cat", array("select"=>$filters["cat"], "include_root"=>true, "kids_only"=>true, "leaves_enabled" =>false ));

		$Fi = & FactoryFieldsFront::getInstance();
		$custom_filters = $Fi->getFilters(null, null);
	
		$lists["custom_filters"] = $custom_filters;
		
		//$smarty->debugging = 1;
        $smarty->assign("action", JRoute::_(JFilterOutput::ampReplace($uri->toString())) );
		$smarty->assign("auction_rows", $items);
		
		$smarty->assign("lists", $lists);
		
		$smarty->assign("sfilters", $filters);
        $smarty->assign('filters',HTML_Auction::makeFilterArray($filters));

		$smarty->assign("filter_order_Dir", $filter_order_Dir);
		$smarty->assign("reverseorder_Dir", $reverseorder_Dir);
		$smarty->assign("filter_order", $filter_order);
		$smarty->assign("filter_archive", $filter_archive);
		$smarty->assign("pagination", $pagination);
		
		if ($params->get('show_page_title', 1)){
			$page_title = $this->escape($params->get('page_title'));
			$smarty->assign("page_title" ,  $page_title);
		}
		$smarty->assign("pageclass_sfx" , $params->get('pageclass_sfx') );
		
        $jdoc = &JFactory::getDocument();
        if (bid_opt_enable_countdown) {
            $jdoc->addScript(JURI::root() . "/components/com_bids/js/countdown.js");
        }
        $jdoc->addScript(JURI::root() . "/components/com_bids/js/ratings.js");

		JHTML::_("behavior.modal");
		$smarty->display($template);
		
	}

	function renderBidsPage( $template, $items , $positions ){
		
		$app	= JFactory::getApplication();
		
		$smarty = BidsUtilities::SmartyLoaderHelper();
		$uri 	  = &JFactory::getURI();
		
		
		// Get the page/component configuration
		$params = $app->getParams();
		$model		= &$this->getModel("bid");
		
		$smarty->assign("positions",  $positions);
        
		$filters =  $model->get( '_filters');
		$filter_bidtype = @$filters["filter_bidtype"];
		$filter_archive = @$filters["filter_archive"];
        
		$pagination = $model->getPagination();
		
		$lists = array();
		$archive[] = JHTML::_('select.option','0', bid_active_offers, 'filter_archive','text');
		$archive[] = JHTML::_('select.option','1', bid_my_unpublished_offers,'filter_archive', 'text');
		$archive[] = JHTML::_('select.option','2', bid_view_archive, 'filter_archive', 'text');
		$archive[] = JHTML::_('select.option','3', bid_view_unsold_items, 'filter_archive','text');
		$archive[] = JHTML::_('select.option','4', bid_view_sold_items, 'filter_archive','text');
		$lists['archive'] = JHTML::_('select.genericlist',$archive, 'filter_archive','class="inputbox" size="1" onchange="document.auctionForm.submit();"','filter_archive', 'text', $filter_archive);
		
		$orders[] = JHTML::_('select.option','start_date', bid_sort_newest);
		$orders[] = JHTML::_('select.option','start_price', bid_sort_initialprice);
		$orders[] = JHTML::_('select.option','bin_price', bid_sort_binprice);
		$orders[] = JHTML::_('select.option','end_date', bid_sort_end_date);
		$orders[] = JHTML::_('select.option','username', bid_sort_username);
		$lists['orders'] = JHTML::_('select.genericlist',$orders, 'filter_order', 'class="inputbox" onchange="document.auctionForm.submit();"', 'value', 'text', $filter_order);
	
		$bid_type[] = JHTML::_('select.option',0, bid_filter_available);
		$bid_type[] = JHTML::_('select.option',1, bid_filter_archive);
		if ( $my->id )
			$bid_type[] = JHTML::_('select.option',3, bid_filter_watchlist);
	
		$lists['filter_bidtype'] = JHTML::_('select.genericlist',$bid_type, 'filter_bidtype', 'class="inputbox" onchange="document.auctionForm.submit();"', 'value', 'text', $filter_bidtype);
	
	    $ord_desc[] = JHTML::_('select.option','DESC', bid_order_desc);
	    $ord_desc[] = JHTML::_('select.option','ASC', bid_order_asc);
	    $lists['filter_order_asc'] = JHTML::_('select.genericlist',$ord_desc, 'filter_order_Dir','class="inputbox" onchange="document.auctionForm.submit();"', 'value', 'text', $filter_order_Dir);
	
	    $lists['filter_userid'] = $filter_userid;
	    
		$lists['filter_cats'] = BidsHTML::selectCategory("cat", array("select"=>$filters["cat"], "include_root"=>true, "kids_only"=>true, "leaves_enabled" =>false ));

		$Fi = & FactoryFieldsFront::getInstance();
		$custom_filters = $Fi->getFilters(null, null);
	
		$lists["custom_filters"] = $custom_filters;
		
		//$smarty->debugging = 1;
        $smarty->assign("action", JRoute::_(JFilterOutput::ampReplace($uri->toString())) );
		$smarty->assign("auction_rows", $items);
		
		$smarty->assign("lists", $lists);
		
		$smarty->assign("sfilters", $filters);
        $smarty->assign('filters',HTML_Auction::makeFilterArray($filters));

		$smarty->assign("filter_order_Dir", $filter_order_Dir);
		$smarty->assign("reverseorder_Dir", $reverseorder_Dir);
		$smarty->assign("filter_order", $filter_order);
		$smarty->assign("filter_archive", $filter_archive);
		$smarty->assign("pagination", $pagination);
		
		if ($params->get('show_page_title', 1)){
			$page_title = $this->escape($params->get('page_title'));
			$smarty->assign("page_title" ,  $page_title);
		}
		$smarty->assign("pageclass_sfx" , $params->get('pageclass_sfx') );
		
        $jdoc = &JFactory::getDocument();
        if (bid_opt_enable_countdown) {
            $jdoc->addScript(JURI::root() . "/components/com_bids/js/countdown.js");
        }
        $jdoc->addScript(JURI::root() . "/components/com_bids/js/ratings.js");

		JHTML::_("behavior.modal");
		$smarty->display($template);
		
	}
	
	function display(){
		$this->listauctions();
	}
	
}