<?php 

/**
* @package		Auction Factory
*
* @license		comercial
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class bidsViewUser extends JView
{
	function display($tpl = null)
	{
		switch($tpl){
			case "myuserdetails":$this->myuserdetails();break;
			case "userdetails":$this->userdetails();break;
			default:$this->myuserdetails();break;
		}
	}
	
	/** @todo ?  */
	function myuseredit(){
		$app	= JFactory::getApplication();
		$r = bidsUtilities::redirectToProfile();
		if($r){
			FactoryLayer::redirect( $r );
		}
		// Get the page/component configuration
		$params = $app->getParams();
		
		$smarty = BidsUtilities::SmartyLoaderHelper();
		$database = JFactory::getDBO();
		$my = JFactory::getUser();
	    $lists = array();
		
		if ( !$my->id ) {
			echo JText::_('ALERTNOTAUTH');
			echo "<br />" . JText::_( 'You need to login.' );
			return;
		}
		
	    $user = new JAuctionUsers($database);
	    $user->load($my->id);
	    $u = $user->getUserDetails($my->id);
		
	    $countryid = array();
		$database->setQuery("select id as countryid,name from #__bid_country order by name");
		$countries = $database->loadObjectList("countryid");

		$countryid[] = JHTML::_('select.option','0', bid_choose_country, 'countryid', 'name');
		$countryid = array_merge($countryid, $database->loadObjectList());
	
	    $lists["country"] = JHTML::_('select.genericlist',$countryid, 'country', 'class="inputbox" ', 'countryid', 'name', $user->country_id);
		$Fi = & FactoryFieldsFront::getInstance();
		$fields = $Fi->getHTMLFields("user_profile", $my->id);
		
		if( count($fields)>0 ){
			$vcf = array();
			foreach ($fields as $fi){
				if($fi["compulsory"]==1 || $fi["validate_type"]!=""){
					$vcf[] = "'".$fi["field_id"]."'";
				}
			}
			$lists["validate_custom_fields"] = " new Array(".implode(",",$vcf).")";
			$lists["validate_custom_fields_count"] = count($vcf);
		}else {
			$lists["validate_custom_fields"] = " new Array()";
			$lists["validate_custom_fields_count"] = "0";
		}
		
		JHTML::_('behavior.formvalidation');
		JHTML::script("validator.js",'components/com_bids/js/validator/');
		
		$smarty->assign("profiler", $fields);
		$smarty->assign("user", $user);
		$smarty->assign("lists", $lists);
		$smarty->display("elements/myuserdetails/t_editprofile_form.tpl");
	}

	function myuserdetails(){
		
		$app	= JFactory::getApplication();
		$r = bidsUtilities::redirectToProfile();
		if($r){
			FactoryLayer::redirect( $r );
		}
		// Get the page/component configuration
		$params = $app->getParams();
		
		$smarty = BidsUtilities::SmartyLoaderHelper();
		$database = JFactory::getDBO();
		$my = JFactory::getUser();
		
		if ( !$my->id ) {
			echo JText::_('ALERTNOTAUTH');
			echo "<br />" . JText::_( 'You need to login.' );
			return;
		}
		
	    $user = new JAuctionUsers($database);
	    $user->load($my->id);
	    $u = $user->getUserDetails($my->id);
		$positions = JTheFactoryHelper::loadPositionedFields($u, "t_display_userprofile.tpl","#__bid_users");
		
	    
	    $lists = array();
	    $countryid = array();
		$database->setQuery("select id as countryid,name from #__bid_country where active=1 order by name");
		$countries = $database->loadObjectList("countryid");

		$countryid[] = JHTML::_('select.option','0', bid_choose_country, 'countryid', 'name');
		$countryid = array_merge($countryid, $database->loadObjectList());
	
	    $lists["country"] = JHTML::_('select.genericlist',$countryid, 'country', 'class="inputbox" ', 'countryid', 'name', $user->country_id);
	
	    $sql = "select itemname,amount,price,currency,task_pay from
		   #__bid_pricing p left join #__bid_credits c on p.itemname=c.credittype and c.userid='$my->id'
		   WHERE  p.enabled=1 AND p.itemname <> 'comission' AND p.itemname <> 'packages'";
	    $database->setQuery($sql);
	    $lists["credits"] = $database->loadObjectList();
	    
	    $lists["packages"] = price_packages_DBHelper::getFrontPackages();
	    
	    $sql = "select * from #__bid_rate r
		       left join #__bid_auctions a on r.auction_id=a.id
		       left join #__users u on r.voter=u.id
		       where user_rated='$my->id' order by r.id desc";
	    $database->setQuery($sql, 0, 10);
	    $lists["ratings"] = $database->loadObjectList();
	
	    $database->setQuery("SELECT enabled FROM #__bid_pricing WHERE itemname = 'comission'");
	    $database->loadObject($lists["pricing_plugin"]);
	    
	    $database->setQuery("
	    SELECT m.*, a.title, u.username
		FROM #__bid_messages as m 
		LEFT JOIN #__bid_auctions as a ON m.id_offer = a.id 
		LEFT JOIN #__users as u ON m.userid1 = u.id 
		WHERE userid2='$my->id'  AND userid1 <> '$my->id' AND m.published=1 
		ORDER BY m.modified DESC 
		");
	    $lists["messages"]["received"] = $database->loadObjectList();
	
	    $pl = &JTheFactoryPaymentLib::getInstance();
	    $lists["pricing_plugin"]->enabled = $pl->price_plugins["price_comission"]->enabled;
	    
	    if ($lists["pricing_plugin"]->enabled == "1")
	    {
	        $database->setQuery("SELECT b.*, c.name AS currency_name FROM #__bid_balance b  LEFT JOIN #__bid_currency c ON b.currency = c.id  WHERE b.auctioneer = '$my->id'");
	        $lists["debts"] = $database->loadObjectList();
	        $lists["pay_comission_link"] = JRoute::_('index.php?option=com_bids&task=pay_comission');
	    }
	
	    if (bid_opt_allow_user_settings)
	    {
	        $p = new JAuctionUserDefaults($database);
	        $p->userid = $my->id;
	        $lists["user_settings"] = $p->getUserSettings();
	        // settting processing
	
	        if ($lists["user_settings"]['payment_options'])
	        {
	            $po = $lists["user_settings"]['payment_options']->value;
	        }
	        $query = "SELECT id as payment, name" . "\n FROM #__bid_payment" . "\n ORDER BY id";
	        $database->setQuery($query);
	        $pays = $database->loadObjectList();
	
	        if (bid_opt_payment_select_mode == 0)
	        {
	            if ($po)
	            {
	                $database->setQuery("SELECT id as payment, name FROM #__bid_payment WHERE id IN ($po)");
	                $plist = $database->loadObjectList();
	            }
	            $lists["user_settings"]['payment_options']->html = JHTML::_('select.genericlist',$pays,'payment_options[]', 'class="inputbox" multiple="multiple" ', 'payment', 'name',
	                $plist);
	        }
	
	        if (isset($lists["user_settings"]['auction_type']->value))
	            $fi = $lists["user_settings"]['auction_type']->value;
	        else
	            $fi = null;
	
	        $opts = null;
	        $opts[] = JHTML::_('select.option','', bid_pick_type_of_auction);
	        $opts[] = JHTML::_('select.option',AUCTION_TYPE_PUBLIC, bid_public_label);
	        if (bid_opt_global_enable_private)
	            $opts[] = JHTML::_('select.option',AUCTION_TYPE_PRIVATE, bid_private_label);
	        if (bid_opt_global_enable_bin && bid_opt_enable_bin_only)
	            $opts[] = JHTML::_('select.option',AUCTION_TYPE_BIN_ONLY, bid_bin_only_label);
	
	        $lists["user_settings"]['auction_type']->html = JHTML::_('select.genericlist',$opts,'auction_type', 'class="inputbox" alt="auction_type"', 'value', 'text', $fi);
	
	        if (isset($lists["user_settings"]['currency']->value))
	            $fi = $lists["user_settings"]['currency']->value;
	        else
	            $fi = null;
	
	        $query = "SELECT id as value, name as text " . "\n FROM #__bid_currency" . "\n ORDER BY id";
	        $opts = null;
	        $database->setQuery($query);
	        $opts = $database->loadObjectList();
	        $lists["user_settings"]['currency']->html = JHTML::_('select.genericlist',$opts,'currency', 'class="inputbox" ', 'value', 'text', $fi);
	    }
	    
		$Fi = & FactoryFieldsFront::getInstance();
		$fields = $Fi->getHTMLFields("user_profile", $my->id);
		
		if( count($fields)>0 ){
			$vcf = array();
			foreach ($fields as $fi){
				if($fi["compulsory"]==1 || $fi["validate_type"]!=""){
					$vcf[] = "'".$fi["field_id"]."'";
				}
			}
			$lists["validate_custom_fields"] = " new Array(".implode(",",$vcf).")";
			$lists["validate_custom_fields_count"] = count($vcf);
		}else {
			$lists["validate_custom_fields"] = " new Array()";
			$lists["validate_custom_fields_count"] = "0";
		}
		
		$smarty->assign("profiler", $fields);
		$smarty->assign("user", $user);
		$smarty->assign("lists", $lists);
		if ($params->get('show_page_title', 1)){
			$page_title = $this->escape($params->get('page_title'));
			if($page_title==""){
				$page_title = JText::_("User details");
			}
			$smarty->assign("page_title" ,  $page_title);
		}
		$smarty->assign('return',JRequest::getCmd("return"));
		$smarty->assign("positions" ,  $positions);
		$smarty->display("t_myuserdetails.tpl");

	}
	
	function userdetails(){
		
		
		$smarty = BidsUtilities::SmartyLoaderHelper();
		$database = JFactory::getDBO();
		$id = JRequest::getVar('id',null);
		$lists = array();
		
		if($id!=""){
			$user = new JAuctionUsers($database);
			$user->getUserDetails($id);
			
			$user->paypalemail = BidsUtilities::cloack_email($user->paypalemail);
			$lists = array(); 
			/*
			$lists["country"] = $user->getCountry($user->country);
			if(isset($lists["country"]->name))
				$lists["country"] = $lists["country"]->name;
			else
				$lists["country"] = null;
			*/
		}
		
	    $sql = "select * from #__bid_rate r
		       left join #__bid_auctions a on r.auction_id=a.id
		       left join #__users u on r.voter=u.id
		       where user_rated='$id' order by r.id desc";
	    $database->setQuery($sql, 0, 10);
	    $lists["ratings"] = $database->loadObjectList();
		
		$smarty->assign("positions",  $positions );
		$smarty->assign("lists", $lists);
		$smarty->assign("user", $user);
		$smarty->display("t_userdetails.tpl");
	}
	
	function myratings(){
		$smarty = BidsUtilities::SmartyLoaderHelper();
		$database = JFactory::getDBO();
		$my = JFactory::getUser();
		
		if ( !$my->id ) {
			echo JText::_('ALERTNOTAUTH');
			echo "<br />" . JText::_( 'You need to login.' );
			return;
		}
		
		if($my->id!=""){
			$user = JTable::getInstance("user");
			$user->load($my->id);
			
			$lists = array(); 
			//$lists["country"] = $user->getCountry($user->country);
			if(isset($lists["country"]->name))
				$lists["country"] = $lists["country"]->name;
			else
				$lists["country"] = null;
		}
		
	    $query = "select r.*,us.username,a.title from #__bid_rate r
				  left join #__users us on r.voter = us.id
				  left join #__bid_auctions a on r.auction_id = a.id
		    	  where r.user_rated = '$my->id'
	
		";
		$database->setQuery($query);
		$ratings = $database->loadObjectList();
		
        $smarty->assign('ratings', $ratings);
		$smarty->assign("user", $user);
		$smarty->display("t_myratings.tpl");
	}

	function userratings(){
		$smarty = BidsUtilities::SmartyLoaderHelper();
		$database = JFactory::getDBO();
		$id = JRequest::getVar('userid',null);
		
		if(!$id)
			return ;
			
		if($id!=""){
			$user = JTable::getInstance("user");
			$user->load($id);
			
			$lists = array(); 
			//$lists["country"] = $user->getCountry($user->country);
			if(isset($lists["country"]->name))
				$lists["country"] = $lists["country"]->name;
			else
				$lists["country"] = null;
		}
		
	    $query = "select r.*,us.username,a.title from #__bid_rate r
				  left join #__users us on r.voter = us.id
				  left join #__bid_auctions a on r.auction_id = a.id
		    	  where r.user_rated = '$id'
		";
		$database->setQuery($query);
		$ratings = $database->loadObjectList();
		
		$smarty->assign("ratings", $ratings);
		$smarty->assign("user", $user);
		$smarty->display("t_myratings.tpl");
	}
	
	function showUsers(){
		global $ItemId;
		
		$app	= JFactory::getApplication();
		$uri 	  = &JFactory::getURI();
		$params = $app->getParams();
		
		$smarty = BidsUtilities::SmartyLoaderHelper();
		$model		= &$this->getModel("user");
		
		$positions = array();
		$items = $model->getUsers();
		
	    if($items)
	    for ($key=0; $key < count($items); $key++){
	    	$add = $items[$key];
			$add->rownr = $key;
			$add->link = JRoute::_("index.php?option=com_bids&view=user&layout=viewdetails&id={$add->id}&ItemId=$ItemId");
			$positions[$add->id] = JTheFactoryHelper::loadPositionedFields($add, "t_showusers.tpl" );
	    	$items[$key] = $add;
	    }
		
		//add alternate feed link
		if($params->get('show_feed_link', 1) == 1)
		{
			$document = & JFactory::getDocument();
			$link	= '&format=feed&limitstart=';
			$attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0');
			$document->addHeadLink(JRoute::_($link.'&type=rss'), 'alternate', 'rel', $attribs);
			$attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0');
			$document->addHeadLink(JRoute::_($link.'&type=atom'), 'alternate', 'rel', $attribs);
		}
		
		$smarty->assign("positions",  $positions);
        
		$filters 	= $model->getCurrentFilters();
		$pagination = $model->getPagination();

		//$smarty->debugging = 1;
        $smarty->assign("action", JRoute::_(JFilterOutput::ampReplace($uri->toString())) );
		$smarty->assign("users", $items);
		$smarty->assign("sfilters", $filters);
        //$smarty->assign('filters',HTML_Auction_helper::makeUserFilterArry($filters));

		$smarty->assign("pagination", $pagination);
		
		if ($params->get('show_page_title', 1)){
			$page_title = $this->escape($params->get('page_title',"Show users"));
			$smarty->assign("page_title" ,  $page_title);
		}
		$smarty->assign("pageclass_sfx" , $params->get('pageclass_sfx') );
		
		JHTML::_("behavior.modal");
		
		$smarty->display("t_showusers.tpl");
		
	}
	
	function searchUsers(){
		$app	= JFactory::getApplication();
		// Get the page/component configuration
		$params = $app->getParams();
		
		$smarty = BidsUtilities::SmartyLoaderHelper();
		$database = JFactory::getDBO();
		
		$searchType = $params->get("user_type");
		$smarty->assign("search_type" ,  $searchType);
		
		
		if ($params->get('show_page_title', 1)){
			
			$page_title = $this->escape($params->get('page_title'));
			if($page_title==""){
				$page_title = JText::_("Search Users");
			}
			$smarty->assign("page_title" ,  $page_title);
			
		}
		
		$extra_field_list = $params->get('extra_fields',array());
		
		$lists['country']["label"] = "Country";
		$lists['country']["html"] = BidsHTML::selectCountry("country");
		
		JHTML::_("behavior.calendar");
		JHTML::script("joomla.javascript.js","includes/js/");
		
		$Fi = & FactoryFieldsFront::getInstance();
		$fields = $Fi->getSearchFields("user_profile", null);
		
		
		$lists["city"]["label"]=JText::_("City");
		$lists["city"]["html"]='<input type="text" name="city" />';
		$lists["name"]["label"]=JText::_("Name");
		$lists["name"]["html"]='<input type="text" name="name" />';
		
		$smarty->assign("profiler", $fields);
		$smarty->assign("lists",$lists);
		
		$smarty->assign("search_fields", $extra_field_list);
		
		$smarty->display("elements/search/t_search_users.tpl");
		
	}
	
}
?>