<?php 
/**
 * @package Auctions Factory Manager Factory
 * @version 2.0.0
 * @copyright www.thefactory.ro
 * @license: commercial
 * @build: 20/10/2010
*/


class TheFactoryMenuHelper{
	
	var $id = null;
	var $module_id = null;
	var $menutype = null;
	var $componentid = null;
	var $title = null;
	var $menu_list = array();
	
	function _getMenuType_ID(){
		
		$menuType =& JTable::getInstance('menutypes');
		// Joomla 1.6 will fail this
		$menuType->_tbl_key = "title";
		$menuType->load($this->title);
		$this->id=$menuType->id;
		$this->menutype=$menuType->menutype;
	}
	
	function _getMenuModule_ID(){
		
		$module =& JTable::getInstance( 'module');
		// Joomla 1.6 will fail this
		$module->_tbl_key = "title";
		$module->load($this->title);
		$this->module_id = $module->id;
	}
	
	function storeMenu(){
		
		$this->_getMenuType_ID();
		
		$menuType =& JTable::getInstance('menutypes');
		$menuType->id 		= $this->id;
		$this->menutype = $menuType->menutype = JFilterInput::clean($this->title, 'menutype');
		$menuType->title 	= $this->title;
		$menuType->store();
		$this->storeMenuModule();
	}
	
	function storeMenuModule(){

		$db =& JFactory::getDBO();

		$this->_getMenuModule_ID();
		$module =& JTable::getInstance( 'module');
		$module->id 		= $this->module_id;
		$module->title 		= $this->title;
		$module->position 	= 'left';
		$module->module 	= 'mod_mainmenu';
		$module->published	= 1;
		$module->iscore 	= 0;
		$module->params		= 'menutype='. $this->menutype;
		$module->store();
		
		$module->reorder( 'position='.$db->Quote($module->position) );

		// module assigned to show on All pages by default
		// Clean up possible garbage first
		$query = 'DELETE FROM #__modules_menu WHERE moduleid = '.(int) $module->id;
		$db->setQuery( $query );
		if (!$db->query()) {
			return JError::raiseWarning( 500, $db->getError() );
		}

		// ToDO: Changed to become a Joomla! db-object
		$query = 'INSERT INTO #__modules_menu VALUES ( '.(int) $module->id.', 0 )';
		$db->setQuery( $query );
		if (!$db->query()) {
			return JError::raiseWarning( 500, $db->getError() );
		}
		
		// Add Menu Items
		if(count($this->menu_list)){
			//remove all menu items
			
			foreach ($this->menu_list as $k => $menuitem){
				
				$menuitem->componentid = $this->componentid;
				$menuitem->menutype = $this->menutype;
				$menuitem->store();
			}
		}
		
	}
	
	function AddMenuItem($title, $alias, $link, $ordering, $access=0,$params=null){
		
		$menu =& JTable::getInstance( 'menu');
		$menu->_tbl_key="name";
		$menu->load($title);
		$menu->_tbl_key="id";
		$menu->name=$title;
		$menu->alias = $alias;
		$menu->link = $link;
		$menu->type="component";
		$menu->access=$access;
		$menu->published=1;
		$menu->parent=0;
		$menu->ordering=$ordering;
		
		$this->menu_list[$title] = $menu;
	}
}

// ######################################################################
// ######################## Utilities ###################################
// ######################################################################

function injectSQL() {
	$database =& JFactory::getDBO();
	
	$errors=array();
    $sqlfile=JPATH_BASE."/components/com_bids/bids.sql";
	$mqr = @get_magic_quotes_runtime();
	@set_magic_quotes_runtime(0);
	$query = fread( fopen(  $sqlfile, 'r' ), filesize($sqlfile ) );
	@set_magic_quotes_runtime($mqr);
	$pieces  = split_sql($query);

	for ($i=0; $i<count($pieces); $i++) {
		$pieces[$i] = trim($pieces[$i]);
		if(!empty($pieces[$i]) && $pieces[$i] != "#") {
			$database->setQuery( $pieces[$i] );
			if (!$database->query()) {
				$errors[] = array ( $database->getErrorMsg(), $pieces[$i] );
			}
		}
	}
	
   return $errors;
}
function split_sql($sql) {
	$sql = trim($sql);
	$sql = @ereg_replace("\n#[^\n]*\n", "\n", $sql);

	$buffer = array();
	$ret = array();
	$in_string = false;

	for($i=0; $i<strlen($sql)-1; $i++) {
		if($sql[$i] == ";" && !$in_string) {
			$ret[] = substr($sql, 0, $i);
			$sql = substr($sql, $i + 1);
			$i = 0;
		}

		if($in_string && ($sql[$i] == $in_string) && $buffer[1] != "\\") {
			$in_string = false;
		}
		elseif(!$in_string && ($sql[$i] == '"' || $sql[$i] == "'") && (!isset($buffer[0]) || $buffer[0] != "\\")) {
			$in_string = $sql[$i];
		}
		if(isset($buffer[1])) {
			$buffer[0] = $buffer[1];
		}
		$buffer[1] = $sql[$i];
	}

	if(!empty($sql)) {
		$ret[] = $sql;
	}
	return($ret);
}


function printfile($filename) {
    $filename=JPATH_ROOT . DS . "administrator" . DS . "components" . DS . "com_bids" . DS . "$filename";
    if (!file_exists($filename)) return;
    $contents = fread( fopen(  $filename, 'r' ), filesize($filename ) );
    echo $contents;

}

function InstallModule($module_name,$module_title='My Module',$ismenu=0,$params='',$unique=false)
{
	$database = &JFactory::getDBO();
   
	if (!is_dir( JPATH_ROOT.DS."modules".DS.$module_name)) mkdir( JPATH_ROOT.DS."modules".DS.$module_name );

	
	jimport('joomla.filesystem.file');
	JFolder::copy(JPATH_ROOT.DS."components".DS."com_bids".DS."module".DS."$module_name",JPATH_ROOT.DS."modules".DS.$module_name,'',true);

	
	// EN Lang if exists
	$source_file =  JPATH_ROOT.DS."components".DS."com_bids".DS."module/$module_name/en-GB.$module_name.ini";
	if(file_exists($source_file)){
		$destination_file = JPATH_ROOT.DS."language".DS."en-GB".DS."en-GB.$module_name.ini";
		if (!file_exists($destination_file)) copy ($source_file, $destination_file);
	}
	
	if ($unique){
		$database->setQuery("select count(*) from #__modules where title='$module_title'");
		if ($database->LoadResult()) return; //not unique
	}

	$database->setQuery("
		INSERT INTO `#__modules`
		(`title`,`content`,`ordering`,`position`,
		`checked_out`,`checked_out_time`,`published`,
		`module`,`numnews`,`access`,`showtitle`,`params`,`iscore`,`client_id`)
		VALUES ( '$module_title','',0, 'left',
		0,'0000-00-00 00:00:00',0,
		'$module_name',0,0,1,'$params',0,0)
    ");
	$database->query();

	$module_id=mysql_insert_id();
	$database->setQuery("INSERT INTO `#__modules_menu` VALUES ($module_id,$ismenu)");
	$database->query();
	
}

function clean_cbplugin(){
    RemoveCBPlugin('Auction Factory - My Auctions','My Auctions','auction_my_auctions','plug_auction_my_auctions','getmyauctionsTab');
	 RemoveCBPlugin('Auction Factory - My Bids','My Bids','auction_my_bids','plug_auction_my_bids','getmybidsTab');
    RemoveCBPlugin('Auction Factory - My Ratings','My Ratings','auction_my_ratings','plug_auction_my_ratings','getmyratingsTab');
    RemoveCBPlugin('Auction Factory - My Watchlist','My Watchlist','auction_my_watchlist','plug_auction_my_watchlist','getmywatchlistTab');
    RemoveCBPlugin('Auction Factory - My Won Bids','My Won Bids','auction_my_wonbids','plug_auction_my_wonbids','getmywonbidsTab');
    RemoveCBPlugin('Auction Factory - My TaskPad','Auction Taskpad','auction_my_taskpad','plug_auction_my_taskpad','myTaskPad');
    RemoveCBPlugin('Auction Factory - My Settings','My Settings','auction_my_settings','plug_auction_my_settings','getmysettingsTab');
	
}

function install_cbplugin(){
	
    $database = &JFactory::getDBO();

	$database->setQuery("select * from #__components where `option`='com_comprofiler'");
	$comprofiler = $database->loadResult();
	if(count($comprofiler)<=0){
		return false;
	}
	// CLEAN GARBAGE FIRST
	clean_cbplugin();

    InstallCBPlugin('Auction Factory - My Auctions','My Auctions','auction_my_auctions','plug_auction_my_auctions','getmyauctionsTab');
    InstallCBPlugin('Auction Factory - My Bids','My Bids','auction_my_bids','plug_auction_my_bids','getmybidsTab');
    InstallCBPlugin('Auction Factory - My Ratings','My Ratings','auction_my_ratings','plug_auction_my_ratings','getmyratingsTab');
    InstallCBPlugin('Auction Factory - My Watchlist','My Watchlist','auction_my_watchlist','plug_auction_my_watchlist','getmywatchlistTab');
    InstallCBPlugin('Auction Factory - My Won Bids','My Won Bids','auction_my_wonbids','plug_auction_my_wonbids','getmywonbidsTab');
    InstallCBPlugin('Auction Factory - My TaskPad','Auction Taskpad','auction_my_taskpad','plug_auction_my_taskpad','myTaskPad');
    InstallCBPlugin('Auction Factory - My Settings','My Settings','auction_my_settings','plug_auction_my_settings','getmysettingsTab');
    
	return true;
}

function InstallCBPlugin($plugintitle,$tabtitle,$pluginname,$folder,$class)
{
	$database = &JFactory::getDBO();

   $query = "SELECT id FROM #__comprofiler_plugin where element='$pluginname.plugin'";
   $database->setQuery($query);
   $plugid = $database->loadResult();
   
   if(!$plugid){
		$query = "INSERT INTO #__comprofiler_plugin set
			`name`='$plugintitle',
			`element`='$pluginname.plugin',
			`type`='user',
			`folder`='$folder',
			`ordering`=99,
			`published`=1,
			`iscore`=0
		";
		$database->setQuery( $query );
		$database->query();
	
		$plugid=mysql_insert_id();
   }
   
	$database->setQuery( $query );
	$database->query();

	$plugid=mysql_insert_id();
	$query = "INSERT INTO #__comprofiler_tabs set
		`title`='$tabtitle',
		`ordering`=999,
		`enabled`=1,
		`pluginclass`='$class',
		`pluginid`='$plugid',
		`fields`=0,
		`displaytype`='tab',
		`position`='cb_tabmain'

	";
	$database->setQuery( $query );
	$database->query();

	@mkdir(JPATH_ROOT.'/components/com_comprofiler/plugin/user/'.$folder);
	$source_file = JPATH_ROOT."/components/com_bids/cb_plug/$pluginname.plugin.php";
	$destination_file = JPATH_ROOT."/components/com_comprofiler/plugin/user/$folder/$pluginname.plugin.php";
	copy ($source_file, $destination_file);

	$source_file = JPATH_ROOT."/components/com_bids/cb_plug/$pluginname.plugin.x";
	$destination_file = JPATH_ROOT."/components/com_comprofiler/plugin/user/$folder/$pluginname.plugin.xml";
	copy ($source_file, $destination_file);
}

function RemoveCBPlugin($plugintitle,$tabtitle,$pluginname,$folder,$class)
{
	$database = &JFactory::getDBO();

   $query = "DELETE FROM #__comprofiler_plugin where element='$pluginname.plugin'";
	$database->setQuery( $query );
	$database->query();
	
	$query = "DELETE FROM #__comprofiler_tabs WHERE `title`='$tabtitle'";
	$database->setQuery( $query );
	$database->query();

	@unlink(JPATH_ROOT."/components/com_comprofiler/plugin/user/$folder/$pluginname.plugin.php");
	@unlink(JPATH_ROOT."/components/com_comprofiler/plugin/user/$folder/$pluginname.plugin.xml");
	@rmdir(JPATH_ROOT.DS."components".DS."com_comprofiler".DS."plugin".DS."user".DS."$folder");
}

function InstallPlugin($plugin_element,$plugin_title,$plugin_folder,$params='')
{
   $database = &JFactory::getDBO();

	$source_file = JPATH_ROOT."/components/com_bids/module/$plugin_folder/$plugin_element.php";
	$destination_file =  JPATH_ROOT."/plugins/$plugin_folder/$plugin_element.php";
	if (!file_exists($destination_file)) copy ($source_file, $destination_file);

	$source_file = JPATH_ROOT."/components/com_bids/module/$plugin_folder/$plugin_element.xml";
	$destination_file =  JPATH_ROOT."/plugins/$plugin_folder/$plugin_element.xml";
	if (!file_exists($destination_file)) copy ($source_file, $destination_file);

	$database->setQuery("select count(*) from #__plugins where name='$plugin_title'");
	if ($database->LoadResult()) return; //not unique

	$database->setQuery("
		INSERT INTO `#__plugins`
		(`name`,`element`,`folder`,`access`,
		`ordering`,`published`,`iscore`,
		`client_id`,`checked_out`,`checked_out_time`,`params`)
		VALUES 
		( '$plugin_title','$plugin_element','$plugin_folder', '0',
		'0','1','0',
		'0','0','0000-00-00 00:00:00','$params'
		)
    ");
	$database->query();
	
}


function com_install() {
	$db = & JFactory::getDBO();

	$db->setQuery("SELECT id FROM #__components where link like '%option=com_bids%'");
	$component_id = $db->LoadResult();
	
	$MenuInstaller = new TheFactoryMenuHelper();
	$MenuInstaller->title = "Auctions Menu";
	$MenuInstaller->componentid = $component_id;
	$MenuInstaller->AddMenuItem("Categories","categories","index.php?option=com_bids&view=category", 0,0 );
	$MenuInstaller->AddMenuItem("Tree Categories","tree-categories","index.php?option=com_bids&view=category&layout=tree", 1,0 );
	$MenuInstaller->AddMenuItem("Show Auctions","show-auctions","index.php?option=com_bids&view=auctions", 2 ,0 );
	$MenuInstaller->AddMenuItem("Search Auctions","search-auctions","index.php?option=com_bids&view=bids&layout=search", 2 ,0 );
	$MenuInstaller->AddMenuItem("Search Auctioneers","search-auctioneers","index.php?option=com_bids&view=user&layout=searchusers", 2 ,0 ,"usertype=2");
	$MenuInstaller->storeMenu();
	
	
	$MenuInstaller2 = new TheFactoryMenuHelper();
	$MenuInstaller2->title = "Auctions User Menu";
	$MenuInstaller2->componentid = $component_id;
	$MenuInstaller2->AddMenuItem("My Profile","auctioneer-profile","index.php?option=com_bids&view=user", 0 , 1 );
	$MenuInstaller2->AddMenuItem("Post Offer","post-offer","index.php?option=com_bids&view=auction&layout=form", 1, 1 );
	$MenuInstaller2->AddMenuItem("My Auctions","my-auctions","index.php?option=com_bids&view=auctions&layout=myauctions", 2, 1 );
	
	$MenuInstaller2->storeMenu();
	
	$errors=injectSQL();

	//MODULE TOP Auctions
	InstallModule('mod_bids','AF Latest Auctions',0,'type_display=0',true);
	InstallModule('mod_bids','AF Popular Auctions',0,'type_display=1',true);
	InstallModule('mod_bids','AF Most Valueable Auctions',0,'type_display=2',true);
	InstallModule('mod_bids','AF Random Auctions',0,'type_display=3',true);
	InstallModule('mod_bids','AF Featured Auctions',0,'type_display=4',true);
	
	InstallModule('mod_auctioncattree','AF Category Tree',0,'',true);
	InstallModule('mod_auctionfulltree','AF Full Category Tree',0,'',true);
	InstallModule('mod_bidscloud','AF Tag Cloud Module',0,'',true);

	@mkdir(JPATH_ROOT.DS.'/images/auctions/');
	@copy(JPATH_ROOT.DS.'/components/com_bids/images/no_image.png',JPATH_ROOT.DS.'/images/auctions/no_image.png');
	
	// JOOMFISH contentelements
	if (file_exists(JPATH_ROOT.DS. 'administrator'.DS.'components'.DS.'com_joomfish'.DS.'joomfish.php'))
	{
		copy(JPATH_ROOT.DS.'components/com_bids/contentelements/bid_categories.xml',JPATH_ROOT.DS. 'administrator'.DS.'components'.DS.'com_joomfish'.DS.'contentelements'.DS.'bid_categories.xml');
		copy(JPATH_ROOT.DS.'components/com_bids/contentelements/bid_auctions.xml',JPATH_ROOT.DS. 'administrator'.DS.'components'.DS.'com_joomfish'.DS.'contentelements'.DS.'bid_auctions.xml');
		copy(JPATH_ROOT.DS.'components/com_bids/contentelements/bid_fields.xml',JPATH_ROOT.DS. 'administrator'.DS.'components'.DS.'com_joomfish'.DS.'contentelements'.DS.'bid_fields.xml');
		copy(JPATH_ROOT.DS.'components/com_bids/contentelements/bid_fields_options.xml',JPATH_ROOT.DS. 'administrator'.DS.'components'.DS.'com_joomfish'.DS.'contentelements'.DS.'bid_fields_options.xml');
	}

	// XMAP Extension
	if (file_exists(JPATH_ROOT.DS.'components/com_bids/modules/xmap/com_bids.xml') && file_exists(JPATH_ROOT.DS. 'administrator'.DS.'components'.DS.'com_xmap'.DS.'admin.xmap.php'))
	{
		copy(JPATH_ROOT.DS.'components/com_bids/modules/xmap/com_bids.xml',JPATH_ROOT.DS. 'administrator'.DS.'components'.DS.'com_xmap'.DS.'extensions'.DS.'com_bids.xml');
		copy(JPATH_ROOT.DS.'components/com_bids/modules/xmap/com_bids.php',JPATH_ROOT.DS. 'administrator'.DS.'components'.DS.'com_xmap'.DS.'extensions'.DS.'com_bids.php');
	}

	InstallPlugin('bids','Search - Bids','search','search_limit=50');
	InstallPlugin('system.udde','System - UDDE - Auctions','system','');

	//Install CB Plugin
	$cb_ok=install_cbplugin();

?>
<table class="adminform">
	<tr>
		<td>
		<?php printfile("install.notes");?>
		</td>
	</tr>
	<tr>
		<td>
			<p>
			Thank you for purchasing <strong>Auctions Factory</strong>.<br>
			Please set up your <strong>Auctions Factory</strong> in the <a href='<?php echo JURI::base();?>/administrator/index.php?option=com_bids&task=settings'>admin panel</a></p>
			<br><br>
			<p> Release Notes:<br><br>
			<?php echo @$version->releasenotes;?></p>
			<p><strong>Auctions Factory</strong> Component <em>for Joomla/Mambo CMS</em> <br />
			Visit us at <a target="_blank" href="http://www.thefactory.ro">thefactory.ro</a> to learn  about new versions
			and/or to give us feedback<br>
			(c) 2006-2010 thefactory.ro
		</td>
	</tr>
</table>
<?php 
}

?>